SystemOrganization addCategory: #'Sourcetalk-Core'!
SystemOrganization addCategory: #'Sourcetalk-Tests'!
SystemOrganization addCategory: #'Sourcetalk-View'!
SystemOrganization addCategory: #'Sourcetalk-Client'!
SystemOrganization addCategory: #'Sourcetalk-Server'!

RRComponent subclass: #SKRssFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRssFeed methodsFor: 'accessing' stamp: 'AQ 9/8/2008 02:26'!
model
	^ self s2root.! !

!SKRssFeed methodsFor: 'hacking' stamp: 'lr 10/20/2008 15:09'!
new
	^ self! !

!SKRssFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 23:04'!
renderChannelOn: rss
	self subclassResponsibility! !

!SKRssFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 23:15'!
renderItem: aGroup on: rss
	self subclassResponsibility! !

!SKRssFeed methodsFor: 'accessing' stamp: 'lr 10/31/2008 14:46'!
session
	^ WACurrentSession value! !

!SKRssFeed methodsFor: 'accessing' stamp: 'lr 10/31/2008 14:40'!
url
	"Answer the repository url for the Sourcetalk server."

	^ self application baseUrl takeServerParametersFromRequest: self session currentRequest! !

SKRssFeed subclass: #SKRssGroupsFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRssGroupsFeed class methodsFor: 'initialization' stamp: 'AQ 10/17/2008 00:24'!
initialize
	self registerAsApplication: 'sourcetalk/groups.rss'.! !

!SKRssGroupsFeed methodsFor: 'rendering' stamp: 'lr 10/31/2008 14:50'!
renderChannelOn: rss
	rss title: 'Groups'.
	rss link: (self url with: 'groups').
	rss description: 'Showing each newly created Group in Sourcetalk'.! !

!SKRssGroupsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:57'!
renderContentOn: rss
	self renderChannelOn: rss.
	self model groups do: [ :each | self renderItem: each on: rss ].! !

!SKRssGroupsFeed methodsFor: 'rendering' stamp: 'AQ 10/31/2008 11:27'!
renderItem: aGroup on: rss
	rss item: [
		rss title: aGroup title.
		rss description: aGroup title, ' is our newest Group on Sourcetalk, and was created by ', aGroup creator.
		rss publicationDate: (RRRfc822DateTime newDateAndTime: aGroup timestamp asDateAndTime).]! !

SKRssFeed subclass: #SKRssMembersFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRssMembersFeed class methodsFor: 'initialization' stamp: 'AQ 10/17/2008 00:24'!
initialize
	self registerAsApplication: 'sourcetalk/members.rss'.! !

!SKRssMembersFeed methodsFor: 'rendering' stamp: 'lr 10/31/2008 14:46'!
renderChannelOn: rss
	rss title: 'Members'.
	rss link: (self url with: 'members').
	rss description: 'Showing each newly registered Member of Sourcetalk'.! !

!SKRssMembersFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:57'!
renderContentOn: rss
	self renderChannelOn: rss.
	self model users do: [ :each | self renderItem: each on: rss ].! !

!SKRssMembersFeed methodsFor: 'rendering' stamp: 'AQ 10/31/2008 11:28'!
renderItem: aUser on: rss
	rss item: [
		rss title: aUser title.
		rss description: aUser title, ' is our newest Member on Sourcetalk.'.
		rss publicationDate: (RRRfc822DateTime newDateAndTime: aUser timestamp asDateAndTime).]! !

SKRssFeed subclass: #SKRssProjectFeed
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRssProjectFeed methodsFor: 'accessing' stamp: 'AQ 10/20/2008 00:47'!
project
	^ project! !

!SKRssProjectFeed methodsFor: 'accessing' stamp: 'AQ 10/20/2008 00:48'!
project: aProject
	project := aProject! !

!SKRssProjectFeed methodsFor: 'rendering' stamp: 'AQ 10/31/2008 11:31'!
renderChannelOn: rss
	rss title: self project title.
	rss link: 'http://localhost:8080/seaside/sourcetalk/repository/', self project id.
	rss description: 'A project in Sourcetalk'.! !

!SKRssProjectFeed methodsFor: 'rendering' stamp: 'AQ 10/20/2008 00:50'!
renderContentOn: rss
	self renderChannelOn: rss.
	self project repository memos do: [ :each | self renderItem: each on: rss ].! !

!SKRssProjectFeed methodsFor: 'rendering' stamp: 'AQ 10/31/2008 11:36'!
renderItem: aMemo on: rss
	rss item: [
		rss title: aMemo name.
		rss description: aMemo properties comment.
		rss author: aMemo properties author.
		rss publicationDate: (RRRfc822DateTime newDateAndTime: aMemo timestamp asDateAndTime). ]! !

SKRssFeed subclass: #SKRssProjectsFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRssProjectsFeed class methodsFor: 'initialization' stamp: 'AQ 10/17/2008 00:24'!
initialize
	self registerAsApplication: 'sourcetalk/projects.rss'.! !

!SKRssProjectsFeed methodsFor: 'rendering' stamp: 'lr 10/31/2008 14:51'!
renderChannelOn: rss
	rss title: 'Projects'.
	rss link: (self url with: 'projects').
	rss description: 'Showing each newly created Project of Sourcetalk'.! !

!SKRssProjectsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:41'!
renderContentOn: rss
	self renderChannelOn: rss.
	self model projects do: [ :each | self renderItem: each on: rss ].! !

!SKRssProjectsFeed methodsFor: 'rendering' stamp: 'lr 10/31/2008 14:51'!
renderItem: aProject on: rss
	rss item: [ rss title: aProject title.
		rss description: aProject title, ' is the newest Project on Sourcetalk'.
		rss link: (self url with: 'projects/' , aProject id asString).
		rss author: aProject creator.
		rss publicationDate: (RRRfc822DateTime newDateAndTime: aProject timestamp asDateAndTime).]! !

WAEntryPoint subclass: #SKHttpHandler
	instanceVariableNames: 'application rss url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Server'!

!SKHttpHandler class methodsFor: 'initialization' stamp: 'lr 10/16/2008 11:51'!
initialize
	WADispatcher default register: (self named: 'sourcetalk')! !

!SKHttpHandler methodsFor: 'accessing' stamp: 'lr 10/16/2008 11:52'!
application
	^ application ifNil: [ application := self buildApplication ]! !

!SKHttpHandler methodsFor: 'private' stamp: 'lr 10/31/2008 13:26'!
buildApplication
	| result |
	result := SKRootComponent applicationNamed: self name.
	result preferenceAt: #sessionClass put: SKSession.
	result addLibrary: SKFileLibrary; addLibrary: SULibrary.
	^ result setParent: self parent! !

!SKHttpHandler methodsFor: 'private' stamp: 'AQ 10/31/2008 11:34'!
feeds
	^ Dictionary new
		at: 'projects.rss'
			put: SKRssProjectsFeed;
		at: 'members.rss'
			put: SKRssMembersFeed;
		at: 'groups.rss'
			put: SKRssGroupsFeed;
		yourself! !

!SKHttpHandler methodsFor: 'processing' stamp: 'lr 10/20/2008 14:52'!
handleMonticelloRequest: aRequest
	^ SKHttpService new handleRequest: aRequest! !

!SKHttpHandler methodsFor: 'processing' stamp: 'lr 11/6/2008 11:03'!
handleRequest: aRequest
	(aRequest fields includesKey: 'message')
		ifTrue: [ ^ self handleMonticelloRequest: aRequest ].
	(aRequest url endsWith: '.rss')
		ifTrue: [ ^ self handleRssRequest: aRequest ].
	^ self application handleRequest: aRequest! !

!SKHttpHandler methodsFor: 'processing' stamp: 'lr 10/31/2008 14:49'!
handleRssRequest: aRequest 
	| id project session |
	session := SKSession new.
	session setParent: self application.
	session instVarNamed: 'currentRequest' put: aRequest.
	^ WACurrentSession use: session during: [
		self url: (aRequest url findTokens: $/).
			self feeds
				at: self url last
				ifPresent: [:class | 
					self rss rootComponent: class new.
					^ self rss handleRequest: aRequest].
			id := UUID
						fromString: (self url last copyUpTo: $.).
			project := self s2root projects
						detect: [:each | each id = id]
						ifNone: [self error: 'RSS Not found'].
			(project isVisibleBy: session user)
				ifTrue: [self rss rootComponent: (SKRssProjectFeed new project: project;
							 yourself)].
			self rss handleRequest: aRequest]! !

!SKHttpHandler methodsFor: 'initialization' stamp: 'AQ 10/24/2008 12:11'!
initialize
	super initialize.
	rss := RRRssHandler new.! !

!SKHttpHandler methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:10'!
rss
	^ rss! !

!SKHttpHandler methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:11'!
rss: aRSSHandler
	rss := aRSSHandler! !

!SKHttpHandler methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:13'!
url
	^ url! !

!SKHttpHandler methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:13'!
url: anObject
	url := anObject! !

MDRepository subclass: #MDSourcetalkRepository
	instanceVariableNames: 'url project email password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDSourcetalkRepository class methodsFor: 'accessing' stamp: 'lr 11/6/2008 08:13'!
type
	^ #SourcetalkRepository! !

!MDSourcetalkRepository class methodsFor: 'instance-creation' stamp: 'lr 11/6/2008 11:17'!
url: aUrlString project: aProjectString email: aUserEmailString password: aPasswordString
	^ self new initializeUrl: aUrlString project: aProjectString email: aUserEmailString password: aPasswordString! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:15'!
allHashstamps
	| result |
	result := self send: MDGetHashstamps new.
	result assertMessageIs: MDAllHashstamps.
	^ result hashstamps! !

!MDSourcetalkRepository methodsFor: 'accessing' stamp: 'lr 10/16/2008 13:08'!
email
	^ email ifNil: [ (MDAuthorInfo value copyAfter: $<) copyUpTo: $> ]! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:14'!
get: aHashstamp
	| objects |
	objects := self getAll: (Set with: aHashstamp).
	^ objects isEmpty ifFalse: [ objects anyOne ]! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 12:20'!
getAll: aCollection
	| result |
	result := self send: (MDGetObjects with: aCollection).
	result assertMessageIs: MDObjects.
	^ result objects! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:15'!
includes: aHashstamp
	^ (self get: aHashstamp) notNil! !

!MDSourcetalkRepository methodsFor: 'initialization' stamp: 'lr 11/6/2008 11:17'!
initializeUrl: aUrlString project: aProjectString email: aUserEmailString password: aPasswordString
	url := aUrlString.
	project := aProjectString.
	email := aUserEmailString.
	password := aPasswordString! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:14'!
memos
	| result |
	result := self send: MDGetMemos new.
	result assertMessageIs: MDMemos.
	^ result objects! !

!MDSourcetalkRepository methodsFor: 'accessing' stamp: 'lr 11/6/2008 11:17'!
name
	^ project! !

!MDSourcetalkRepository methodsFor: 'accessing' stamp: 'lr 10/16/2008 13:10'!
password
	^ password ifNil: [ MDPasswordInfo value ]! !

!MDSourcetalkRepository methodsFor: 'accessing' stamp: 'lr 11/6/2008 11:17'!
project
	^ project! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 12:23'!
put: anObject
	| result |
	result := self send: (MDPutObjects with: (Array with: anObject)). 
	result assertMessageIs: MDThankYou! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 12:22'!
putAll: aCollection
	| request |
	request := self send: (MDOfferObjects withObjects: aCollection).
	request assertMessageIs: MDRequestObjects.
	request 
		filter: aCollection
		in: [ :put | (self send: put) assertMessageIs: MDThankYou ]! !

!MDSourcetalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:15'!
selectFrom: aCollection
	| request |
	request := self send: (MDOfferObjects with: aCollection).
	request assertMessageIs: MDRequestObjects.
	^ request hashstamps! !

!MDSourcetalkRepository methodsFor: 'private' stamp: 'lr 11/6/2008 11:13'!
send: aMessage
	^ (MDSourcetalkClient url: self url project: self name email: self email password: self password)
		send: aMessage! !

!MDSourcetalkRepository methodsFor: 'accessing' stamp: 'lr 9/11/2008 11:56'!
url
	^ url! !

MDRepository subclass: #MDSynchronizedRepository
	instanceVariableNames: 'mutex delegate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDSynchronizedRepository class methodsFor: 'instance-creation' stamp: 'lr 11/6/2008 08:13'!
on: aRepository
	^ self new initializeOn: aRepository! !

!MDSynchronizedRepository class methodsFor: 'accessing' stamp: 'lr 11/6/2008 08:13'!
type
	^ #SynchronizedRepository! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 08:41'!
allHashstamps
	^ self critical: [ delegate allHashstamps ]! !

!MDSynchronizedRepository methodsFor: 'private' stamp: 'lr 11/6/2008 10:06'!
critical: aBlock
	^ mutex critical: [
		| result |
		delegate rescanData.
		result := aBlock value.
		delegate close.
		result ]! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 08:41'!
get: aHashstamp 
	^ self critical: [ delegate get: aHashstamp ]! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 08:41'!
getAll: aCollection
	^ self critical: [ delegate getAll: aCollection ]! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 08:41'!
includes: aHashstamp
	^ self critical: [ delegate includes: aHashstamp ]! !

!MDSynchronizedRepository methodsFor: 'initialization' stamp: 'lr 11/6/2008 08:40'!
initializeOn: aRepository
	mutex := Semaphore forMutualExclusion.
	delegate := aRepository! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 09:41'!
memos
	^ self critical: [ delegate memos ]! !

!MDSynchronizedRepository methodsFor: 'accessing' stamp: 'lr 11/6/2008 08:10'!
name
	^ delegate name! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 08:41'!
put: anObject
	^ self critical: [ delegate put: anObject ]! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 08:41'!
putAll: aCollection
	^ self critical: [ delegate putAll: aCollection ]! !

!MDSynchronizedRepository methodsFor: 'public' stamp: 'lr 11/6/2008 08:41'!
selectFrom: aCollection
	^ self critical: [ delegate selectFrom: aCollection ]! !

!MADescription methodsFor: '*sourcetalk' stamp: 'AQ 10/24/2008 17:42'!
onlyEditing
	^ self propertyAt: #onlyEditing ifAbsent: [ false ]! !

!MADescription methodsFor: '*sourcetalk' stamp: 'AQ 10/24/2008 17:43'!
onlyEditing: aBoolean
	self propertyAt: #onlyEditing put: aBoolean! !

!MADescription methodsFor: '*sourcetalk' stamp: 'lr 10/3/2008 12:25'!
onlySuperuser
	^ self propertyAt: #onlySuperuser ifAbsent: [ false ]! !

!MADescription methodsFor: '*sourcetalk' stamp: 'lr 10/3/2008 12:25'!
onlySuperuser: aBoolean
	self propertyAt: #onlySuperuser put: aBoolean! !

WARequestHandler subclass: #SKHttpService
	instanceVariableNames: 'request escaper user project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Server'!

!SKHttpService methodsFor: 'private' stamp: 'lr 11/6/2008 11:34'!
findProject
	| name result |
	name := request fields
		at: 'project'
		ifAbsent: [ String new ].
	result := self s2root 
		getProjectNamed: name.
	result isNil 
		ifTrue: [ self error: 'Project ' , name printString , ' not found.' ].
	(result isVisibleBy: self user)
		ifFalse: [ self error: 'You are not allowed to see ' , name printString , '.' ].
	^ result! !

!SKHttpService methodsFor: 'private' stamp: 'lr 11/6/2008 11:31'!
findUser
	| email password result |
	email := request fields
		at: 'email'
		ifAbsent: [ request user ].
	password := request fields
		at: 'password'
		ifAbsent: [ request password ].
	result := self s2root userByEMail: email.
	^ result isNil
		ifTrue: [
			(email isNil or: [ email isEmpty or: [ email = 'anonymous' ] ])
				ifTrue: [ self s2root guest ]
				ifFalse: [ self error: 'Invalid user ' , email printString ] ]
		ifFalse: [
			(result verifyPassword: password)
				ifTrue: [ result ]
				ifFalse: [ self error: 'Invalid password for user ' , email printString ] ]! !

!SKHttpService methodsFor: 'handlers' stamp: 'lr 10/31/2008 15:40'!
handleGet: message
	^ MDObjects with: (self repository getAll: message hashstamps)! !

!SKHttpService methodsFor: 'actions' stamp: 'lr 10/31/2008 15:40'!
handleGetHashstamps: message
	^ MDAllHashstamps with: self repository allHashstamps! !

!SKHttpService methodsFor: 'handlers' stamp: 'lr 10/31/2008 15:40'!
handleGetMemos: message
	^ MDMemos with: self repository memos! !

!SKHttpService methodsFor: 'handlers' stamp: 'lr 11/6/2008 11:39'!
handleGetRepositories: aMessage
	^ MDObjects with: ((self s2root projects 
		select: [ :each | each isVisibleBy: self user ])
		collect: [ :each | each title ])! !

!SKHttpService methodsFor: 'handlers' stamp: 'lr 10/31/2008 15:40'!
handleOfferObjects: message
	self project addADownload.
	^ MDRequestObjects with: (self repository selectFrom: message hashstamps).! !

!SKHttpService methodsFor: 'handlers' stamp: 'lr 11/1/2008 16:34'!
handlePutObjects: message
	(self project isWritableBy: self user)
		ifFalse: [ self error: 'You are not allowed to commit to this project.' ].
	self repository putAll: message objects.
	self user addOneCommit.
	^ MDThankYou with: message objects size! !

!SKHttpService methodsFor: 'processing' stamp: 'lr 11/6/2008 11:26'!
handleRequest: aRequest
	| result |
	request := aRequest.
	escaper := [ :response | ^ response ].
	result := [ self processRequest: aRequest ]
		on: Error
		do: [ :err | MDUnrecognizedMessage with: err description ].
	self return: result! !

!SKHttpService methodsFor: 'processing' stamp: 'lr 10/16/2008 11:38'!
processMessage: aMessage
	^ aMessage handledBy: self! !

!SKHttpService methodsFor: 'processing' stamp: 'lr 11/6/2008 11:29'!
processRequest: aRequest
	^ self processMessage: (MDNetMessage 
		readFrom: (Base64MimeConverter
			mimeDecodeToBytes: (aRequest fields at: 'message')
				readStream))! !

!SKHttpService methodsFor: 'accessing' stamp: 'lr 11/6/2008 11:27'!
project
	^ project ifNil: [ project := self findProject ]! !

!SKHttpService methodsFor: 'accessing' stamp: 'lr 10/31/2008 15:39'!
repository
	^ self project repository! !

!SKHttpService methodsFor: 'actions' stamp: 'lr 11/6/2008 10:04'!
return: aMessage
	"Answer return a response with the given message."
	
	| stream |
	stream := RWBinaryOrTextStream on: ByteArray new.
	aMessage writeOn: stream.
	escaper value: (WAResponse new
		stream: (Base64MimeConverter mimeEncode: stream);
		contentType: 'application/x-monticello';
		doNotCache;
		yourself)! !

!SKHttpService methodsFor: 'accessing' stamp: 'lr 11/6/2008 11:27'!
user
	^ user ifNil: [ user := self findUser ]! !

TestCase subclass: #SKEntryTest
	instanceVariableNames: 'entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKEntryTest methodsFor: 'running' stamp: 'AQ 11/3/2008 22:59'!
setUp
	entry := SKEntry new.! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:43'!
testAddTags
	self assert: (entry tags isEmpty).
	entry tags: OrderedCollection new.
	entry tags add: 'seaside'.
	self assert: (entry tags first = 'seaside').
	self assert: (entry tags size = 1).
	entry tags addAll: #('tag' 'info').
	self assert: (entry tags size = 3).! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:43'!
testEditableBy
	| user |
	user := SKGuest new.
	self deny: (entry isEditableBy: user).
	user := SKUser new.
	self deny: (entry isEditableBy: user).
	user superuser: true.
	self deny: (entry isEditableBy: user).! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:44'!
testRemoveTags
	self assert: entry tags isEmpty.
	entry tags: OrderedCollection new.
	entry tags add: 'seaside'.
	self assert: entry tags first = 'seaside'.
	self assert: entry tags size = 1.
	entry tags remove: 'seaside'.
	self assert: entry tags isEmpty.! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:43'!
testVisibleBy
	| user |
	user := SKGuest new.
	self assert: (entry isVisibleBy: user).
	user := SKUser new.
	self assert: (entry isVisibleBy: user).
	user superuser: true.
	self assert: (entry isVisibleBy: user).! !

TestCase subclass: #SKGroupTest
	instanceVariableNames: 'group user user2 guest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKGroupTest methodsFor: 'running' stamp: 'AQ 11/3/2008 23:39'!
setUp
	group := SKGroup new.
	user := SKUser new.
	user2 := SKUser new.
	guest := SKGuest new.! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:41'!
testAddAdmin
	self assert: group admins isEmpty.
	group addAdmin: user.
	self assert: group admins size = 1.
	self assert: group admins anyOne = user.! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:41'!
testAddUser
	self assert: group users isEmpty.
	group addUser: user.
	self assert: group users size = 1.
	self assert: group users anyOne = user! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:40'!
testCreator
	self assert: group creator isNil.
	group addAdmin: user.
	self assert: group creator = user.
	group addAdmin: user2.
	self deny: group creator = user2.! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:40'!
testIsEditableBy
	self deny: (group isEditableBy: guest).
	self deny: (group isEditableBy: user).
	self deny: (group isEditableBy: user2).
	
	group addAdmin: user.
	self assert: (group isEditableBy: user).
	user2 superuser: true.
	self assert: (group isEditableBy: user2).! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:41'!
testIsGroup
	self assert: group isGroup.! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:42'!
testRemoveAdmin
	group addAdmin: user.
	self assert: group admins size = 1.
	group removeAdmin: user2.
	self deny: group admins isEmpty.
	group removeAdmin: user.
	self assert: group admins isEmpty.! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:43'!
testRemoveUser
	group addUser: user.
	self assert: group users size = 1.
	group removeUser: user2.
	self deny: group users isEmpty.
	group removeUser: user.
	self assert: group users isEmpty.! !

TestCase subclass: #SKGuestTest
	instanceVariableNames: 'guest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKGuestTest methodsFor: 'running' stamp: 'AQ 11/4/2008 00:05'!
setUp
	guest := SKGuest new.! !

!SKGuestTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:50'!
testIsGuest
	self assert: guest isGuest.! !

!SKGuestTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:51'!
testTitle
	self assert: guest title = 'Guest'.! !

TestCase subclass: #SKMemberTest
	instanceVariableNames: 'member'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKMemberTest methodsFor: 'running' stamp: 'AQ 11/3/2008 23:08'!
setUp
	member := SKMember new.! !

!SKMemberTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:44'!
testIsGroup
	self deny: member isGroup.! !

!SKMemberTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:44'!
testUsers
	self assert: member users isEmpty.! !

TestCase subclass: #SKPersonTest
	instanceVariableNames: 'person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKPersonTest methodsFor: 'running' stamp: 'AQ 11/4/2008 00:04'!
setUp
	person := SKPerson new.! !

!SKPersonTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:47'!
testIsGuest
	self deny: person isGuest.! !

!SKPersonTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:47'!
testIsSuperuser
	self deny: person isSuperuser.! !

TestCase subclass: #SKProjectTest
	instanceVariableNames: 'project user user2 guest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKProjectTest methodsFor: 'running' stamp: 'AQ 11/4/2008 00:58'!
setUp
	user := SKUser new.
	user2 := SKUser new.
	project := SKProject new.
	guest := SKGuest new.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:26'!
testAddADownload
	self assert: project downloads = 0.
	project addADownload.
	self assert: project downloads = 1.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:21'!
testAddAdmin
	self assert: project admins isEmpty.
	project addAdmin: user.
	self assert: project admins size = 1.
	self assert: project admins anyOne = user.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:21'!
testAddDeveloper
	self assert: project developers isEmpty.
	project addDeveloper: user.
	self assert: project developers size = 1.
	self assert: project developers anyOne = user.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:26'!
testCreator
	self assert: project creator isNil.
	project addAdmin: user.
	self assert: project creator = user.
	project addAdmin: user2.
	self deny: project creator = user2.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:43'!
testIsEditableBy
	self deny: (project isEditableBy: guest).
	self deny: (project isEditableBy: user).
	self deny: (project isEditableBy: user2).
	project addAdmin: user.
	self assert: (project isEditableBy: user).
	project addDeveloper: user2.
	self deny: (project isEditableBy: user2).
	user2 superuser: true.
	self assert: (project isEditableBy: user2).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:39'!
testIsVisibleByPrivate
	project visibility: #private.
	self deny: (project isVisibleBy: guest).
	self deny: (project isVisibleBy: user).
	project addDeveloper: user.
	self assert: (project isVisibleBy: user).
	project removeDeveloper: user.
	self deny: (project isVisibleBy: user).
	project addAdmin: user.
	self assert: (project isVisibleBy: user).
	user2 superuser: true.
	self assert: (project isVisibleBy: user2).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:38'!
testIsVisibleByProtected
	project visibility: #protected.
	self assert: (project isVisibleBy: guest).
	self assert: (project isVisibleBy: user).
	user2 superuser: true.
	self assert: (project isVisibleBy: user2).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:38'!
testIsVisibleByPublic
	project visibility: #public.
	self assert: (project isVisibleBy: guest).
	self assert: (project isVisibleBy: user).
	user2 superuser: true.
	self assert: (project isVisibleBy: user2).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:49'!
testIsWritableByPrivate
	project visibility: #private.
	self deny: (project isWritableBy: guest).
	self deny: (project isWritableBy: user).
	self deny: (project isWritableBy: user2).
	project addAdmin: user.
	self assert: (project isWritableBy: user).
	project addDeveloper: user2.
	self assert: (project isWritableBy: user2).
	project removeDeveloper: user2.
	self deny: (project isWritableBy: user2).
	user2 superuser: true.
	self assert: (project isWritableBy: user2).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:49'!
testIsWritableByProtected
	project visibility: #protected.
	self deny: (project isWritableBy: guest).
	self deny: (project isWritableBy: user).
	self deny: (project isWritableBy: user2).
	project addAdmin: user.
	self assert: (project isWritableBy: user).
	project addDeveloper: user2.
	self assert: (project isWritableBy: user2).
	project removeDeveloper: user2.
	self deny: (project isWritableBy: user2).
	user2 superuser: true.
	self assert: (project isWritableBy: user2).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:47'!
testIsWritableByPublic
	project visibility: #public.
	self assert: (project isWritableBy: guest).
	self assert: (project isWritableBy: user).
	user2 superuser: true.
	self assert: (project isWritableBy: user2).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:24'!
testRating
	self assert: project rating = 0.
	project rating: 5.5.
	self assert: project rating = 5.5
	! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:52'!
testRemoveAdmin
	project addAdmin: user.
	self deny: project admins isEmpty.
	project removeAdmin: user2.
	self deny: project admins isEmpty.
	project removeAdmin: user.
	self assert: project admins isEmpty.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:52'!
testRemoveDeveloper
	project addDeveloper: user.
	self deny: project developers isEmpty.
	project removeDeveloper: user2.
	self deny: project developers isEmpty.
	project removeDeveloper: user.
	self assert: project developers isEmpty.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:56'!
testState
	self assert: project state = #Planning.
	project state: #Alpha.
	self assert: project state = #Alpha.
	! !

TestCase subclass: #SKRootTest
	instanceVariableNames: 'root user group project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKRootTest methodsFor: 'running' stamp: 'AQ 11/4/2008 01:04'!
setUp
	root := SKRoot new.
	group := SKGroup new.
	user := SKUser new.
	project := SKProject new.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:58'!
testAddGroup
	self assert: root groups isEmpty.
	root addGroup: group.
	self deny: root groups isEmpty.
	self assert: root groups anyOne = group.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:59'!
testAddProject
	self assert: root projects isEmpty.
	root addProject: project.
	self deny: root projects isEmpty.
	self assert: root projects anyOne = project.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:59'!
testAddUser
	self assert: root users isEmpty.
	root addUser: user.
	self deny: root users isEmpty.
	self assert: root users anyOne = user.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:01'!
testCountProjectsOfUser
	| project2 |
	root addUser: user.
	root addProject: project.
	project addAdmin: user.
	self assert: (root countProjectsOfUser: user) = 1.
	project2 := SKProject new.
	root addProject: project2.
	project2 addDeveloper: user.
	self assert: (root countProjectsOfUser: user) = 2.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:02'!
testGetGroupsOfUser
	root addUser: user.
	root addGroup: group.
	group addAdmin: user.
	self assert: (root getGroupsOfUser: user) anyOne = group.
	root removeGroup: group.
	self assert: (root getGroupsOfUser: user) isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:24'!
testGetProjectNamed
	| project2 |
	project title: 'Project'.
	root addProject: project.
	project2 := root getProjectNamed: 'Project'.
	self assert: (project2 = project).! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:26'!
testGetProjectsOfUser
	| project2 |
	root addUser: user.
	root addProject: project.
	project addAdmin: user.
	self deny: root projects isEmpty.
	self assert: (root getProjectsOfUser: user) anyOne = project.
	root removeProject: project.
	self assert: (root getProjectsOfUser: user) isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:52'!
testRemoveAdmin
	root addProject: project.
	root addGroup: group.
	group addAdmin: user.
	project addAdmin: user.
	self deny: project admins isEmpty.
	self deny: group admins isEmpty.
	self assert: root users isEmpty.
	root removeUser: user.
	self assert: root users isEmpty.
	root addUser: user.
	self deny: root users isEmpty.
	self deny: root statistics newestMembers isEmpty.
	root removeUser: user.
	self assert: root users isEmpty.
	self assert: project admins isEmpty.
	self assert: group admins isEmpty.
	self assert: root statistics newestMembers isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:55'!
testRemoveGroup
	self assert: root groups isEmpty.
	root removeGroup: group.
	self assert: root groups isEmpty.
	root addGroup: group.
	self deny: root groups isEmpty.
	self deny: root statistics newestGroups isEmpty.
	root removeGroup: group.
	self assert: root groups isEmpty.
	self assert: root statistics newestGroups isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:55'!
testRemoveProject
	self assert: root projects isEmpty.
	root removeProject: project.
	self assert: root projects isEmpty.
	root addProject: project.
	self deny: root projects isEmpty.
	self deny: root statistics newestProjects isEmpty.
	root removeProject: project.
	self assert: root projects isEmpty.
	self assert: root statistics newestProjects isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:52'!
testRemoveUser
	root addProject: project.
	root addGroup: group.
	group addUser: user.
	project addDeveloper: user.
	self deny: project developers isEmpty.
	self deny: group users isEmpty.
	self assert: root users isEmpty.
	root removeUser: user.
	self assert: root users isEmpty.
	root addUser: user.
	self deny: root users isEmpty.
	self deny: root statistics newestMembers isEmpty.
	root removeUser: user.
	self assert: root users isEmpty.
	self assert: project developers isEmpty.
	self assert: group users isEmpty.
	self assert: root statistics newestMembers isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:41'!
testUserByEMail
	root addUser: user.
	user email: 'test@mail.com'.
	self assert: (root userByEMail: 'test@mail.com') = user.! !

TestCase subclass: #SKStatisticsTest
	instanceVariableNames: 'statistics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKStatisticsTest methodsFor: 'running' stamp: 'AQ 11/4/2008 01:42'!
setUp
	statistics := SKStatistics new.! !

!SKStatisticsTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 02:03'!
testCheckIfFull
	| group i |
	group := SKGroup new.
	i := 0. 
	self assert: statistics newestGroups isEmpty.
	( i to: 11 ) do: [ :n |
		statistics newGroup: group].
	self assert: statistics newestGroups size = 10.! !

!SKStatisticsTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:46'!
testNewGroup
	| group |
	group := SKGroup new.
	self assert: statistics newestGroups isEmpty.
	statistics newGroup: group.
	self deny: statistics newestGroups isEmpty.! !

!SKStatisticsTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:47'!
testNewMember
	| user |
	user := SKUser new.
	self assert: statistics newestMembers isEmpty.
	statistics newMember: user.
	self deny: statistics newestMembers isEmpty.! !

!SKStatisticsTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 01:47'!
testNewProject
	| project |
	project := SKProject new.
	self assert: statistics newestProjects isEmpty.
	statistics newProject: project.
	self deny: statistics newestProjects isEmpty.! !

TestCase subclass: #SKUserTest
	instanceVariableNames: 'user user2 guest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKUserTest methodsFor: 'running' stamp: 'AQ 11/4/2008 00:01'!
setUp
	user := SKUser new.
	user2 := SKUser new.
	guest := SKGuest new.! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:54'!
testAddOneCommit
	self assert: user commits = 0.
	user addOneCommit.
	self assert: user commits = 1.! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:15'!
testEmail
	self deny: user email = 'e@mail.net'.
	user email: 'e@mail.net'.
	self assert: user email = 'e@mail.net'! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:00'!
testIsEditableBy
	self deny: (user isEditableBy: guest).
	self assert: (user isEditableBy: user).
	self deny: (user isEditableBy: user2).
	user2 superuser: true.
	self assert: (user isEditableBy: user2).! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:00'!
testIsVisibleBy
	self assert: (user isVisibleBy: guest).
	self assert: (user isVisibleBy: user).
	self assert: (user isVisibleBy: user2).
	user2 superuser: true.
	self assert: (user isVisibleBy: user2).! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:16'!
testIsWithinGroup
	| group collection |
	collection := OrderedCollection new.
	group := SKGroup new.
	collection add: group.
	self deny: (user isWithin: collection).
	group addAdmin: user.
	self assert: (user isWithin: collection).
	self deny: (user2 isWithin: collection).
	group addUser: user2.
	self assert: (user2 isWithin: collection).! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:13'!
testIsWithinProject
	| project |
	project := SKProject new.
	self deny: (user isWithin: project admins).
	project addAdmin: user.
	self assert: (user isWithin: project admins).
	self deny: (user2 isWithin: project developers).
	project addDeveloper: user2.
	self assert: (user2 isWithin: project developers).! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 11/4/2008 00:18'!
testIsWithinUserCollection
	| collection |
	collection := OrderedCollection new.
	self deny: (user isWithin: collection).
	collection add: user.
	self assert: (user isWithin: collection).
	self deny: (user2 isWithin: collection).! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 11/3/2008 23:59'!
testPassword
	user password: '12345'.
	self assert: (user verifyPassword: '12345').
	self deny: (user verifyPassword: '1234')! !

!SKUserTest methodsFor: 'tests' stamp: 'lr 10/3/2008 12:24'!
testSuperuser
	self deny: user isSuperuser.
	user superuser: true.
	self assert: user isSuperuser! !

WAFileLibrary subclass: #SKFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
addPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 13 0 0 0 13 8 6 0 0 0 114 235 228 124 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 216 10 27 0 48 53 118 228 14 13 0 0 0 171 73 68 65 84 40 207 99 52 155 245 159 1 29 240 190 16 128 11 126 150 248 192 136 46 207 130 77 67 113 168 9 156 223 187 90 224 63 186 70 12 77 12 12 12 12 47 159 254 98 192 7 152 24 200 0 44 232 126 96 96 96 96 16 151 102 99 120 249 244 23 131 184 52 27 86 63 50 58 55 241 163 248 1 221 121 48 141 8 63 158 129 216 132 207 15 216 228 88 24 24 24 24 118 190 190 77 154 159 62 75 124 96 100 184 141 234 39 81 85 78 56 251 245 237 239 40 26 62 75 124 96 100 65 142 64 222 23 2 76 12 12 12 127 209 77 70 143 39 38 52 201 127 68 7 57 58 136 51 208 70 132 214 237 51 24 242 140 228 164 61 0 225 126 67 179 213 177 190 158 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: 'lr 10/31/2008 16:28'!
defaultCss
	^ '/* html */
body { margin: 0; }

/* blueprint */
input.password, input.title, textarea, select {margin:0.5em 0;border:1px solid #bbb;}
input.password:focus {border:1px solid #666;}
input.password {width: 300px; padding:5px;}

/* top */
.header { color: white; }
.header table { width: 400px; margin: auto auto; }
.header a { color: white; text-decoration: none; }
.header th { background-color: inherit; text-align: right; }
.header .buttons input { margin-right: 1em; }
.header .body { background-color: #333; }
.header .bottom { background: url(menu.png) repeat-x; height: 50px; text-align: right; }
.header .bottom div.tab { float: right; height: 50px; }
.header .bottom div.tab div { float: left; height: 50px; }
.header .bottom div.tab div.left { background: url(menuLeft.png) no-repeat; width: 40px; }
.header .bottom div.tab div.inner { background: url(menuInner.png) repeat-x; padding-top: 10px; }
.header .bottom div.tab div.right { background: url(menuRight.png) no-repeat; width: 40px; }

/* container */
.container { }

.logo h1 { background: url(logo.png) no-repeat; margin: 0; height: 150px; width: 640px; }
.logo h1 a { display: block; height: 153px; outline: none; }
.logo h1 a span { display: none; }

.tabs div { text-align: center; color: #3a8fcd; font-size: 2em; }
.tabs div.span-6 { margin: 0; width: 239px; }
.tabs div.last { width: 229px; }
.tabs div a { display: block; color: inherit; text-decoration: none; outline: none; }
.tabs div.active { background-color: #f7f7f7; color: #5da922; }

.main { padding-top: 10px; background: url(main.png) repeat-x; }
.main .menu input { width: 100px; }

.browse div { float: left; }

'! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
editPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 88 0 167 0 24 62 123 236 198 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 216 10 27 0 23 41 184 32 224 39 0 0 1 54 73 68 65 84 56 203 165 145 47 72 67 81 20 198 127 119 46 56 24 130 201 224 138 96 16 92 222 75 111 6 139 65 193 180 104 151 33 136 220 52 16 139 44 93 227 250 176 109 197 58 65 131 6 195 208 25 44 178 217 158 27 62 39 78 44 142 149 99 120 250 246 252 179 199 155 126 229 92 56 252 190 243 241 93 37 34 212 247 231 8 83 230 110 233 243 41 31 83 1 80 46 19 35 186 132 226 46 232 173 160 17 241 48 226 124 50 239 205 180 7 232 231 23 232 62 193 202 50 212 78 5 80 241 40 151 181 214 0 24 99 208 169 25 112 31 253 101 44 42 236 56 14 182 109 99 238 93 184 190 241 123 24 105 80 144 158 232 205 117 140 49 56 142 67 167 211 193 178 44 47 73 58 173 66 19 20 164 39 39 59 151 184 137 11 22 87 107 84 42 21 44 203 194 24 51 252 129 81 37 6 97 0 183 61 224 42 117 128 199 14 225 250 252 25 153 239 6 65 184 209 60 196 109 15 56 238 182 232 182 222 32 241 245 242 143 4 97 112 81 77 43 250 165 95 187 138 69 130 67 228 151 248 23 24 96 34 153 76 74 227 232 129 133 236 237 216 240 108 118 123 216 193 222 198 43 83 107 77 128 72 176 95 98 181 90 37 151 203 1 144 237 151 20 99 74 137 8 255 209 59 220 222 171 182 99 236 108 160 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: '<no timestamp>'!
ieCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* ie.css */
body {text-align:center;}
.container {text-align:left;}
* html .column {overflow-x:hidden;}
* html legend {margin:-18px -8px 16px 0;padding:0;}
ol {margin-left:2em;}
sup {vertical-align:text-top;}
sub {vertical-align:text-bottom;}
html>body p code {*white-space:normal;}
hr {margin:-8px auto 11px;}'! !

!SKFileLibrary methodsFor: 'uploaded' stamp: 'lr 10/31/2008 12:29'!
logoPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 2 128 0 0 0 150 8 2 0 0 0 193 191 174 219 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 78 235 73 68 65 84 120 218 236 125 11 124 28 213 121 239 204 62 244 126 27 89 150 45 191 176 100 240 75 216 226 101 187 198 224 38 4 19 210 144 155 0 78 218 18 40 78 218 155 132 22 59 225 182 110 161 36 161 144 210 150 4 187 33 201 189 1 187 16 238 237 141 193 244 23 110 66 98 66 10 4 140 193 80 100 99 99 25 188 50 182 145 108 189 172 247 74 43 237 99 230 126 51 223 204 217 179 179 187 51 103 31 146 165 229 251 179 217 140 102 207 156 121 250 252 231 255 157 239 33 171 170 42 17 8 4 2 129 64 152 92 184 232 18 16 8 4 2 129 48 249 240 208 37 32 16 8 217 66 115 239 155 252 159 77 51 86 231 222 57 142 71 198 246 247 188 244 254 224 145 174 192 153 143 70 62 60 237 255 48 16 25 89 88 210 80 145 55 99 121 101 211 242 138 166 171 106 174 165 39 129 32 2 153 76 208 4 2 33 61 220 121 96 147 133 113 45 120 114 221 111 26 202 150 230 204 249 246 140 117 238 106 221 241 219 51 207 1 227 218 52 155 145 95 253 223 230 221 250 165 11 191 82 232 46 166 135 132 96 3 50 65 19 8 132 236 232 221 120 12 135 134 114 227 76 21 53 178 203 183 227 150 223 95 253 220 71 255 110 207 190 128 222 241 158 199 125 63 184 229 149 171 127 123 246 57 122 72 8 54 32 19 52 129 64 32 56 16 234 223 54 255 249 123 253 205 248 167 44 201 178 236 154 93 56 183 186 96 86 145 167 184 60 175 82 150 92 227 202 88 79 160 163 123 172 163 107 236 172 170 217 21 85 216 234 59 135 254 234 157 222 215 191 185 244 254 124 119 1 93 70 2 17 48 129 64 200 14 58 2 237 31 135 211 236 10 156 253 203 3 95 106 31 61 133 212 155 231 206 95 90 190 178 161 108 41 114 42 16 173 214 72 103 220 153 5 179 150 170 43 135 67 131 239 15 29 249 112 248 56 136 102 248 229 151 109 187 161 135 127 186 244 113 226 96 66 60 200 4 77 32 16 210 34 224 209 220 39 96 127 120 248 155 111 127 25 217 215 45 123 128 119 63 55 239 79 46 169 186 60 202 190 154 218 85 180 255 211 151 96 101 169 183 252 242 25 235 174 157 253 217 154 194 217 46 89 27 96 223 58 247 218 61 7 191 134 124 76 32 144 2 38 16 8 4 105 32 216 219 25 56 123 98 248 253 176 18 170 45 154 91 230 173 88 84 122 177 215 229 101 13 254 225 221 173 39 253 62 109 160 148 61 107 103 126 98 97 73 3 16 109 4 254 67 234 213 229 47 163 94 99 89 255 179 34 175 106 221 204 79 30 27 60 252 193 224 123 17 53 188 191 251 165 159 157 248 241 237 245 127 73 215 156 64 4 76 32 16 50 197 193 190 55 166 233 145 3 167 254 170 109 247 107 93 47 162 180 181 0 100 238 167 102 127 238 83 179 111 124 183 255 109 104 131 236 187 174 230 147 11 74 26 20 85 81 36 69 82 85 158 107 121 234 149 36 92 165 201 98 144 191 75 202 27 189 178 247 200 192 59 176 225 191 181 238 184 170 230 90 32 120 198 253 199 135 90 58 70 219 224 96 198 149 177 217 133 26 253 215 21 47 88 90 113 9 249 78 19 1 19 8 4 130 29 252 225 97 199 54 181 69 117 83 234 152 63 26 249 112 123 203 119 223 236 121 197 178 30 109 197 64 147 240 237 27 106 129 207 143 222 255 30 218 153 101 73 110 172 186 172 174 120 161 198 190 186 25 217 158 122 37 110 25 182 157 91 188 176 47 120 174 109 228 100 72 9 253 244 248 195 15 172 250 201 222 51 255 241 219 179 191 120 167 119 127 194 35 116 201 238 213 213 87 223 52 255 182 213 213 215 208 51 150 243 160 56 96 2 129 144 14 28 131 128 1 251 63 125 122 234 28 240 227 190 31 60 117 226 199 64 132 140 234 242 93 5 192 178 197 158 146 34 79 49 112 240 80 112 96 36 236 15 41 65 144 164 72 198 192 160 53 133 179 215 206 252 68 153 183 60 172 132 120 174 149 76 15 44 36 99 11 245 154 228 172 66 183 189 227 61 175 119 255 103 80 25 135 21 21 121 51 64 251 178 67 114 203 30 89 95 0 89 109 153 36 158 87 124 225 255 88 254 224 165 51 214 210 147 70 4 76 32 16 8 49 248 212 139 43 252 182 97 190 37 222 178 223 94 123 100 42 28 42 112 219 3 135 239 6 233 201 168 183 220 91 49 187 104 94 125 217 146 154 130 217 30 151 87 209 167 117 221 146 123 92 25 63 51 122 186 117 248 216 112 104 16 90 22 186 139 86 86 93 89 145 87 5 172 108 75 189 6 243 154 235 37 126 134 24 58 255 208 127 252 131 193 35 140 251 243 92 249 64 252 165 222 178 98 79 41 44 67 155 177 72 96 40 52 48 26 246 7 35 227 97 53 204 142 252 143 230 110 162 40 166 28 6 153 160 9 4 66 202 232 8 180 251 157 146 108 44 158 26 57 176 198 35 99 247 29 186 19 103 115 241 181 96 81 201 69 64 171 165 222 114 80 165 97 53 20 10 7 25 155 202 178 92 91 88 87 87 180 0 137 19 190 65 248 66 51 94 168 48 19 180 35 245 98 51 224 251 11 75 22 195 154 143 252 31 194 55 8 238 186 226 5 213 5 179 64 127 195 222 81 106 131 22 114 201 50 232 111 160 255 174 64 135 63 52 136 52 252 203 182 221 39 134 63 248 167 75 31 159 145 95 77 79 29 17 48 129 64 32 72 190 161 163 142 109 26 202 150 77 133 67 125 240 240 221 140 125 129 246 214 84 111 152 87 124 33 40 206 209 136 159 151 179 8 244 112 6 242 195 224 34 137 115 114 182 153 235 101 6 231 104 27 99 43 109 25 40 28 120 29 56 120 161 230 198 5 124 44 235 43 195 163 152 81 203 236 65 147 224 178 103 97 201 226 121 197 139 78 251 91 207 142 126 132 179 236 45 3 135 182 188 245 167 63 89 179 167 196 83 74 15 94 142 129 226 128 9 4 66 202 56 216 119 192 177 205 172 130 57 231 253 56 127 223 249 194 239 58 126 137 203 32 109 63 81 251 153 57 69 243 128 122 21 160 90 142 47 117 7 43 221 195 89 103 68 212 190 186 8 86 88 51 51 230 23 137 217 88 54 93 162 181 191 96 115 126 43 201 92 214 251 215 130 151 244 109 149 144 38 169 131 24 200 196 122 48 255 140 132 148 96 68 13 47 44 93 188 188 242 210 25 249 51 241 200 79 12 191 127 223 193 59 233 169 35 2 38 16 8 4 33 5 220 52 99 205 249 61 200 161 208 192 15 90 238 195 229 50 111 197 53 179 174 135 111 208 190 28 143 74 108 25 99 135 152 159 179 133 122 145 161 77 234 85 204 77 164 152 68 28 49 212 171 152 61 160 116 86 48 128 56 130 158 86 38 199 155 90 89 97 234 25 183 26 143 4 138 60 197 203 43 87 93 80 80 131 199 255 102 207 43 79 159 218 69 15 30 17 48 129 64 248 184 195 209 255 89 210 3 106 207 239 65 62 117 226 199 61 99 157 146 238 117 117 73 213 229 229 121 149 218 108 46 103 73 86 56 217 202 120 84 179 66 115 54 103 198 196 22 234 85 57 234 85 76 186 149 76 174 181 80 47 238 43 86 94 75 250 38 6 245 42 81 194 214 54 145 52 99 184 54 7 220 80 186 180 216 83 130 167 243 191 62 120 24 94 41 232 217 35 2 38 16 8 196 190 246 242 247 60 87 2 14 68 70 158 251 232 223 113 121 118 225 220 139 203 27 65 251 226 159 49 170 23 255 98 76 108 82 175 133 17 213 232 178 33 86 25 245 178 233 94 142 107 77 194 230 172 214 28 199 99 46 143 232 142 152 75 151 78 189 200 250 42 238 53 207 157 183 160 164 1 195 148 225 140 224 149 130 30 63 34 96 2 129 240 241 133 72 14 172 85 85 231 153 128 95 235 250 29 58 49 185 101 207 202 170 43 34 154 95 85 12 29 42 18 39 64 145 242 84 53 150 17 21 70 189 90 156 174 233 113 165 113 179 196 8 91 111 160 47 43 28 245 26 38 107 53 74 240 18 235 36 54 131 52 111 220 142 242 188 185 235 176 18 174 202 175 46 243 86 226 73 61 223 190 103 60 50 70 79 32 17 48 129 64 248 152 194 55 116 204 177 205 121 183 63 191 125 238 53 92 168 204 159 81 83 56 59 162 68 162 210 86 98 140 168 160 210 149 88 212 80 140 167 149 196 168 23 133 51 182 151 204 137 91 213 220 16 137 19 213 53 18 170 164 201 92 115 71 152 103 35 142 122 209 45 75 239 65 209 231 140 85 182 44 161 95 152 193 235 145 57 69 243 100 73 243 157 30 8 246 38 75 161 69 32 2 38 16 8 185 143 102 1 5 220 84 117 158 61 176 142 235 110 98 192 91 243 138 23 98 112 17 163 207 24 42 141 243 133 230 167 123 21 131 134 13 27 117 180 141 26 93 230 137 147 167 94 115 71 6 127 243 211 204 230 132 177 36 153 51 190 138 41 184 89 183 146 241 179 230 23 86 230 45 47 112 23 226 154 183 204 23 11 66 14 128 226 128 9 4 66 10 16 73 193 1 242 183 196 91 118 126 143 179 125 68 203 130 41 203 174 11 242 107 88 136 17 211 172 82 92 78 43 198 121 44 37 164 106 182 183 52 144 184 101 221 211 138 109 168 176 144 98 115 71 252 114 76 6 105 69 138 152 91 69 163 144 185 99 80 162 43 245 156 210 21 121 85 129 192 168 110 126 104 161 135 144 8 152 64 32 124 44 229 111 175 179 252 93 124 190 83 112 132 148 80 0 211 92 72 82 121 94 37 51 5 199 113 155 194 209 112 226 132 86 76 40 75 38 215 90 152 219 210 103 116 71 82 52 69 135 101 71 22 234 229 105 158 175 241 96 254 170 137 227 98 111 169 28 144 97 101 215 216 25 122 8 137 128 9 4 194 199 17 135 4 82 112 172 172 186 242 252 30 228 184 98 120 42 129 118 204 119 21 48 139 49 79 189 60 173 114 180 39 73 156 35 52 35 72 53 134 53 213 228 146 87 53 168 215 236 135 117 18 229 111 131 219 163 105 44 227 154 169 150 119 5 88 3 103 129 203 254 208 48 61 132 68 192 4 2 97 218 195 55 212 50 172 219 147 75 189 101 130 110 83 199 167 67 10 142 18 79 169 75 118 243 89 53 162 18 211 38 157 36 95 232 215 156 253 229 100 174 202 56 90 137 49 101 71 37 47 207 199 113 60 106 68 47 197 9 101 37 150 194 45 212 107 44 184 101 183 217 91 132 158 91 34 96 2 129 48 109 240 124 251 51 191 57 179 71 74 30 194 219 52 99 245 163 87 238 118 236 199 31 26 114 156 131 44 241 150 213 22 158 183 50 192 39 253 190 151 59 126 125 184 255 109 252 51 162 134 99 200 50 74 159 188 138 149 172 244 140 238 207 9 26 40 220 36 174 194 89 152 85 11 31 91 76 211 170 73 223 49 38 104 201 168 120 200 234 49 176 254 101 179 7 252 85 229 168 189 216 75 25 161 137 128 9 4 194 244 65 103 160 221 62 123 198 176 147 95 149 41 127 157 61 128 206 151 255 243 187 253 111 255 232 253 239 189 215 223 204 175 188 184 124 133 96 233 64 75 17 5 46 41 135 33 94 165 88 151 105 137 43 195 160 50 187 114 252 142 76 171 54 39 184 141 94 25 185 198 246 47 73 49 26 221 234 189 5 82 248 253 193 35 112 94 244 84 19 1 19 8 132 92 128 160 111 173 72 10 142 134 178 37 147 124 240 129 200 200 79 222 255 167 61 167 159 100 107 128 219 102 22 214 86 229 85 47 173 184 132 207 111 149 204 211 74 138 113 128 82 149 168 53 88 136 122 45 52 25 203 169 252 116 175 185 219 232 97 104 223 24 227 171 253 41 155 173 112 153 105 104 61 52 217 45 123 64 208 119 140 182 111 126 253 143 22 148 212 111 156 243 121 248 84 23 204 162 167 151 8 152 64 32 228 62 14 246 57 39 161 92 53 185 10 24 14 233 59 135 238 194 156 207 218 136 38 123 46 42 95 81 83 56 187 216 83 146 239 42 240 184 188 124 253 34 147 41 173 211 189 92 84 174 170 242 19 181 49 132 205 203 92 59 234 149 172 158 86 18 43 77 168 50 198 149 37 222 71 218 74 213 92 160 20 146 177 215 157 87 87 60 191 109 228 20 206 1 159 242 183 254 207 15 254 249 113 223 15 190 184 240 171 119 212 223 149 239 46 160 135 147 8 152 64 32 228 50 166 90 22 232 253 221 47 221 115 240 107 44 59 227 236 162 121 75 202 27 171 242 171 243 92 121 24 251 171 87 31 178 163 94 198 142 208 94 150 101 158 35 21 174 36 176 149 122 165 88 195 53 239 210 21 213 176 108 74 88 214 166 119 85 173 216 48 82 175 166 107 181 125 201 92 50 16 228 100 201 98 127 54 143 87 114 73 174 242 188 42 175 236 29 141 140 14 133 250 209 23 58 172 132 255 247 137 159 236 235 122 241 159 46 123 188 174 104 1 61 159 211 14 148 9 139 64 32 229 42 137 228 205 16 49 83 79 38 251 190 63 120 228 111 155 255 28 217 23 132 239 165 51 214 94 126 193 186 153 5 181 110 217 29 82 66 97 205 253 42 194 108 206 209 194 189 44 219 179 100 38 135 150 20 230 231 204 72 55 98 150 4 230 106 5 74 124 58 73 133 43 115 196 140 201 102 38 231 104 253 6 96 85 21 67 130 129 212 101 153 219 87 36 118 222 87 50 42 49 24 89 45 101 227 39 86 43 73 167 234 34 111 105 85 254 5 115 138 22 204 47 89 84 226 49 188 177 78 250 125 119 236 251 76 203 192 33 122 206 137 128 9 4 194 244 195 98 129 24 36 145 20 28 13 147 149 130 99 40 52 0 236 11 68 43 233 218 241 138 234 245 13 101 75 139 220 197 88 115 55 90 68 1 43 222 171 81 214 196 228 207 10 87 68 33 142 68 205 164 25 70 27 86 137 65 137 118 98 118 110 214 47 82 88 37 6 244 100 54 69 176 194 194 124 117 194 214 14 22 167 117 81 97 203 76 84 75 188 241 27 247 101 248 66 199 20 79 212 183 5 125 15 47 76 179 139 231 193 219 6 118 53 18 246 111 125 235 214 19 195 239 211 147 76 4 76 32 228 14 58 116 255 225 221 39 119 238 56 118 255 244 61 11 17 211 177 35 90 135 157 107 48 172 154 172 20 28 63 253 224 225 174 192 89 92 94 89 117 101 93 209 2 32 42 80 189 124 233 192 40 245 178 26 12 73 75 7 74 124 37 96 77 158 242 165 3 185 170 189 9 75 7 70 235 15 154 214 110 22 191 203 137 111 195 154 172 83 175 214 191 28 147 127 67 231 91 217 180 60 235 203 82 212 34 30 77 87 9 59 192 227 4 209 95 85 80 93 91 52 23 215 251 195 195 247 54 127 157 229 255 34 76 11 208 28 48 129 16 67 84 29 129 182 206 64 187 111 232 24 44 240 70 215 218 194 186 187 150 220 55 77 223 33 28 219 148 120 202 167 145 2 254 104 228 195 95 180 153 181 126 139 230 205 45 94 232 146 93 88 193 222 54 171 134 26 235 132 108 50 90 162 68 208 138 213 231 217 126 174 215 156 198 229 188 154 77 201 43 113 62 215 250 94 100 252 93 150 162 110 86 108 89 150 162 251 197 25 98 163 51 25 171 21 114 158 92 216 119 153 183 60 92 16 66 31 52 184 44 255 122 236 129 191 89 254 143 244 15 153 8 152 64 152 54 252 244 224 225 111 29 31 106 177 175 49 112 222 179 59 101 240 86 145 133 216 33 184 74 142 68 14 239 40 147 147 130 227 185 143 254 157 49 37 28 121 145 167 216 40 247 43 169 156 219 177 53 180 55 33 245 170 113 9 153 45 212 43 37 10 237 181 100 213 96 6 103 70 189 60 237 34 231 66 27 151 203 5 28 42 107 127 185 113 74 24 222 27 162 199 38 163 54 55 163 144 37 213 5 255 25 93 200 140 166 37 173 135 232 33 106 28 156 87 30 136 140 226 211 251 171 182 167 111 154 127 219 162 210 139 233 223 53 17 48 129 48 61 248 73 196 66 123 222 243 27 167 13 17 211 241 44 39 226 244 77 153 12 148 64 189 207 183 63 163 243 145 92 91 84 87 230 173 48 203 8 58 83 175 196 69 247 114 174 209 49 9 173 236 169 87 74 146 85 131 171 220 32 179 36 86 58 239 106 66 54 164 4 199 194 99 65 37 8 11 97 53 4 175 11 97 69 75 209 165 189 55 152 57 165 161 61 240 177 254 237 118 235 31 248 211 227 242 120 93 121 30 217 227 145 189 176 70 209 29 167 117 154 103 105 165 85 183 236 41 207 171 28 13 251 245 235 16 121 178 245 209 251 87 61 74 255 174 137 128 9 132 105 0 145 234 2 57 175 128 107 11 231 218 55 56 40 112 149 234 75 39 35 5 199 145 129 230 161 208 128 46 43 229 186 162 5 5 238 66 164 49 41 113 234 40 161 156 86 138 148 180 48 81 242 172 26 134 181 57 186 47 217 148 197 170 28 84 198 129 17 3 145 145 177 72 0 228 105 48 50 174 234 7 44 233 252 28 37 105 153 69 31 105 136 152 47 0 102 183 122 11 156 17 150 180 80 96 175 156 151 231 202 207 211 23 64 63 179 227 132 149 37 222 178 225 224 32 252 249 90 247 139 112 125 224 189 132 254 105 19 1 19 8 83 29 34 213 5 26 202 150 158 199 252 198 153 64 36 123 179 36 16 62 52 117 20 240 65 211 92 81 153 55 163 216 83 42 75 46 149 133 244 8 83 175 20 27 221 43 197 86 71 176 205 170 193 107 98 51 83 149 145 181 42 50 28 26 130 11 14 212 59 18 246 71 164 176 164 7 33 73 140 101 13 97 172 253 225 66 7 88 89 230 9 152 1 169 93 230 164 60 104 228 72 56 16 144 70 245 208 38 21 4 113 190 171 32 207 157 159 239 46 244 186 64 28 187 138 60 197 176 95 16 214 64 246 175 117 189 120 67 221 205 244 79 155 8 152 64 200 13 126 154 182 242 87 32 121 164 72 240 174 136 149 94 176 158 82 134 248 104 228 67 92 184 160 160 6 24 72 97 1 187 156 167 85 130 212 202 2 57 173 20 206 117 57 25 245 74 209 12 27 134 234 5 230 30 12 246 15 6 7 135 195 131 163 33 191 233 95 133 250 86 66 171 178 201 180 198 151 204 28 177 12 2 150 173 252 203 217 198 245 170 15 138 230 32 173 79 254 234 123 148 130 106 16 68 182 20 130 77 93 5 238 2 160 97 143 236 46 116 23 13 43 218 76 240 225 254 183 137 128 137 128 9 132 92 224 39 105 18 163 107 178 175 23 5 76 199 142 174 203 83 42 1 22 203 58 89 226 41 3 33 136 25 175 82 162 94 147 222 36 206 4 205 106 2 70 35 136 148 216 12 210 18 151 36 11 51 108 128 204 29 8 246 2 251 14 133 6 101 52 22 75 168 120 93 46 221 62 172 175 116 153 172 107 172 97 148 140 76 45 115 34 216 100 122 217 176 62 203 156 115 151 198 191 160 131 93 250 180 178 106 204 121 107 107 35 163 225 17 56 18 232 22 116 176 182 141 170 30 27 56 76 255 180 137 128 9 132 92 224 39 233 252 85 248 201 194 27 134 192 4 176 227 235 133 72 13 134 85 85 147 68 192 97 61 249 134 164 231 163 112 201 178 136 147 179 106 102 176 226 169 183 177 244 178 124 185 144 25 147 199 148 145 67 67 111 73 113 241 69 146 53 49 164 182 60 16 234 235 31 63 215 31 236 11 41 65 147 104 113 138 87 163 82 147 98 145 137 13 254 117 105 76 108 104 95 142 116 249 101 166 127 85 62 181 150 198 229 26 237 107 107 92 24 218 164 106 187 80 141 244 153 232 9 166 241 110 72 15 196 226 223 81 8 68 192 4 194 244 230 167 134 178 165 34 153 26 167 32 4 13 236 142 10 216 55 36 146 130 99 146 222 81 10 61 197 6 101 70 198 66 74 200 229 118 39 43 162 32 241 78 206 113 37 140 22 23 45 155 87 88 207 186 61 29 240 29 28 122 147 83 162 81 234 149 205 56 93 69 138 244 7 123 251 198 207 245 142 119 163 7 149 204 9 89 137 35 87 160 222 123 234 31 94 86 114 169 108 8 99 169 197 127 240 225 147 127 135 82 152 219 80 150 98 253 176 36 174 116 177 190 107 76 182 165 209 172 158 215 90 54 69 182 36 25 190 90 56 87 28 205 212 1 59 64 39 53 2 17 48 129 48 237 249 41 183 39 128 69 130 119 69 250 89 60 41 19 192 128 138 188 42 92 24 8 246 85 229 95 144 239 46 72 181 122 96 180 28 97 12 237 177 237 163 230 104 92 208 152 79 150 250 198 123 206 141 119 193 78 205 220 25 178 204 113 158 100 218 150 145 131 53 189 139 214 101 174 141 91 246 68 127 213 109 197 60 25 243 242 87 53 179 85 195 79 17 85 114 203 88 142 208 8 67 114 105 153 47 181 182 216 137 209 191 254 133 39 92 232 46 166 127 221 68 192 19 142 182 33 45 255 120 121 254 172 178 124 42 138 57 169 232 30 105 29 143 248 97 97 110 217 202 9 221 209 208 120 231 224 120 103 190 187 100 102 113 253 121 225 39 41 215 39 128 29 95 47 58 2 237 246 41 74 38 217 72 192 178 76 244 5 123 106 35 117 176 95 123 234 149 146 87 15 140 101 96 85 81 19 27 156 135 66 253 221 99 157 186 234 53 201 212 76 226 203 11 95 221 177 89 214 127 115 105 127 197 178 47 180 1 6 69 5 108 152 163 101 153 235 68 226 89 223 44 23 161 96 212 111 68 138 184 116 143 107 52 71 235 129 192 17 221 42 205 179 111 20 37 222 82 26 163 114 156 128 199 195 254 214 254 125 61 35 173 56 22 195 55 251 41 223 83 50 179 168 30 190 171 139 234 97 220 132 49 26 150 179 50 22 251 250 246 181 15 29 130 5 126 119 252 78 235 202 86 46 159 185 49 39 249 24 46 120 247 104 244 172 219 6 141 226 39 107 231 222 158 108 147 163 61 123 91 251 246 193 107 10 108 139 107 224 202 192 29 169 175 90 183 172 122 99 74 123 111 213 175 60 92 118 124 233 177 0 250 132 123 61 183 124 101 125 229 186 12 239 53 62 87 176 59 216 23 220 104 203 175 240 44 45 170 90 215 80 181 46 43 183 248 124 77 0 235 249 165 223 120 173 235 69 223 208 81 75 122 41 77 143 22 213 173 170 90 13 148 182 190 230 186 76 223 48 4 12 236 142 193 187 34 157 44 182 53 98 251 134 90 160 147 206 177 51 124 44 83 67 217 50 216 245 213 53 215 165 202 220 151 84 94 110 12 8 193 129 193 96 127 101 222 12 201 12 198 77 163 112 47 79 123 44 18 137 173 28 9 251 123 131 221 61 99 29 122 213 7 147 47 77 106 77 40 124 113 186 151 77 3 51 126 69 5 204 214 107 100 108 186 101 49 237 43 97 253 6 83 218 42 122 44 18 22 83 210 39 123 163 28 172 55 51 220 170 209 10 173 112 175 20 11 75 26 136 219 114 150 128 97 8 110 238 216 3 67 164 205 24 138 195 52 107 3 3 244 210 234 141 105 143 155 64 36 71 187 247 38 28 250 45 59 133 207 27 237 79 192 48 189 102 238 237 233 137 179 167 143 110 177 223 17 116 123 203 178 237 89 233 10 112 205 130 59 47 173 189 201 166 193 247 223 184 198 190 135 132 4 12 87 254 229 83 143 198 19 24 172 129 15 252 42 72 192 112 85 223 233 216 3 215 63 190 43 139 32 134 15 52 3 246 5 14 222 176 224 206 52 104 24 174 21 220 101 232 196 190 13 124 94 57 245 40 28 63 156 120 74 143 211 78 223 35 59 125 219 211 120 36 62 245 226 138 132 235 55 55 108 217 220 176 53 69 70 124 243 233 83 187 94 237 122 193 134 155 177 252 131 174 99 202 128 159 174 159 115 83 218 14 198 89 49 176 139 36 42 73 152 38 12 78 68 59 217 206 23 18 230 176 196 115 124 80 186 251 134 186 155 239 104 216 34 30 102 189 180 226 146 154 194 217 88 137 161 35 208 86 93 48 171 216 83 98 90 161 83 42 220 27 203 190 250 138 43 43 54 92 88 164 177 215 217 177 143 126 119 238 87 39 253 31 248 195 195 198 36 175 201 148 53 249 115 214 86 252 225 133 69 23 233 5 1 229 145 136 255 212 232 241 3 131 191 63 23 236 68 147 50 52 168 201 159 93 236 46 227 165 109 177 187 116 105 201 42 160 79 223 232 81 198 214 151 148 93 49 183 96 97 93 193 2 60 152 246 177 147 231 130 93 7 7 223 132 62 181 12 90 18 203 111 169 167 165 148 85 151 102 15 87 116 237 236 66 17 172 103 219 194 184 225 232 25 45 173 88 41 17 114 143 128 97 20 222 219 250 144 35 169 36 25 160 31 133 113 19 216 107 99 253 54 241 113 51 25 145 56 14 229 109 71 183 0 177 173 169 187 61 43 226 59 230 92 70 91 179 216 50 115 203 42 156 44 255 170 1 148 9 87 204 158 198 4 119 186 191 237 137 230 206 61 76 61 11 18 182 38 187 251 247 193 149 183 127 177 200 240 185 194 189 0 211 139 75 121 199 154 184 169 34 165 176 87 224 155 93 173 143 164 84 149 200 31 26 122 190 253 25 248 0 1 223 81 191 53 85 26 22 217 23 112 188 227 89 28 79 61 5 7 48 238 46 223 118 76 24 233 8 60 199 123 26 31 22 12 93 117 201 238 235 231 124 225 137 214 31 2 235 244 141 159 235 31 63 87 232 46 74 22 95 20 71 189 18 151 204 217 106 136 254 92 205 159 46 41 89 137 63 212 121 47 188 180 232 170 31 156 186 119 127 255 75 188 167 213 31 207 254 26 52 179 28 210 234 138 107 254 104 214 31 63 211 241 248 239 251 224 223 157 124 101 197 213 55 205 250 51 203 4 240 188 194 69 127 185 224 239 97 249 91 239 223 10 29 22 187 75 254 124 222 223 0 245 198 24 18 138 151 195 247 103 102 126 233 153 206 157 205 131 111 68 29 181 52 163 116 4 56 88 143 71 138 213 190 250 127 24 34 204 166 129 215 84 111 32 110 203 53 2 6 18 125 186 101 75 74 195 113 66 182 16 31 202 159 251 224 222 52 200 158 1 164 27 108 126 203 210 237 41 113 176 35 107 10 94 1 205 50 47 208 50 187 115 168 176 71 184 71 241 246 121 11 242 221 37 142 7 255 194 137 135 28 251 177 57 12 120 217 106 31 58 180 113 209 54 199 139 15 52 255 70 251 19 233 237 5 104 27 22 4 57 56 43 37 249 98 9 88 168 242 15 240 232 206 214 237 187 79 238 76 123 71 112 228 205 189 155 54 45 220 188 185 126 139 184 193 246 96 54 60 167 68 252 212 224 144 152 126 77 251 100 31 60 124 55 124 11 114 240 23 230 223 182 251 228 46 44 189 247 161 255 56 28 64 169 183 28 171 15 89 12 206 82 162 18 70 42 87 65 129 97 86 254 220 2 87 161 70 117 138 18 137 68 224 27 150 255 98 238 182 35 67 111 143 232 238 14 64 162 127 50 251 107 55 198 177 47 254 84 226 46 253 179 186 173 189 161 158 99 254 119 93 122 60 46 251 137 111 6 223 94 87 30 112 230 95 204 223 54 39 127 62 251 149 127 21 40 114 23 223 60 107 115 251 216 169 115 227 93 146 230 132 21 6 173 140 74 88 91 208 235 55 152 70 111 148 190 72 195 134 67 86 93 209 252 229 149 77 196 109 211 2 162 245 128 179 194 190 128 122 49 43 52 16 231 99 7 191 152 9 251 242 135 157 234 176 158 149 43 43 114 240 142 236 155 146 244 23 100 95 237 159 168 237 126 65 92 10 246 227 104 189 64 71 45 155 3 126 234 240 87 210 99 95 6 224 96 145 67 205 58 251 10 86 254 1 246 250 198 129 77 153 176 47 3 116 114 219 190 235 69 172 202 226 138 223 49 120 247 184 136 17 219 156 35 135 139 12 71 152 246 201 2 7 11 222 166 25 249 213 183 46 250 26 46 15 135 6 79 250 125 99 145 81 137 51 65 43 209 114 191 10 95 184 151 99 95 171 19 22 176 175 150 213 34 18 9 133 66 200 190 146 102 55 46 89 91 249 9 157 59 93 53 249 117 22 246 253 85 207 207 159 239 217 205 83 236 205 181 155 61 46 15 104 116 201 136 240 141 210 48 91 246 202 222 181 149 127 8 218 151 173 57 58 220 252 98 239 47 6 194 189 172 25 112 240 202 210 213 122 110 13 163 42 131 75 155 51 54 210 102 25 254 213 214 44 90 198 194 159 213 255 21 17 91 78 17 48 138 209 172 48 19 16 176 136 117 241 233 163 91 178 69 132 48 58 131 26 203 226 37 19 212 172 61 35 89 176 63 15 166 66 192 112 143 4 89 211 70 149 194 197 7 74 203 202 197 7 97 106 243 178 5 135 10 239 88 153 211 60 64 228 254 30 20 115 120 206 174 252 69 246 21 167 76 71 116 4 218 129 225 4 77 187 34 100 230 24 188 43 114 221 176 148 225 78 223 35 119 30 216 36 82 123 216 6 187 90 31 17 108 249 229 69 95 103 222 88 103 71 63 26 8 246 43 122 164 110 44 245 170 22 234 53 200 88 85 227 162 144 180 181 207 156 217 245 47 173 127 107 89 191 162 244 114 205 111 89 118 173 173 248 67 126 253 91 131 175 62 211 177 107 79 231 191 189 61 248 26 163 216 5 133 245 179 242 235 206 140 157 250 101 247 255 237 13 118 243 212 219 31 58 247 219 115 191 120 177 247 57 143 203 219 80 188 140 17 51 240 238 179 93 79 190 57 240 242 239 122 255 31 47 148 47 42 89 142 74 26 247 142 31 35 165 22 231 225 21 127 47 174 157 253 89 34 182 156 34 224 119 58 246 164 58 11 155 108 220 119 180 22 34 1 100 247 36 197 143 63 43 167 41 174 128 235 178 97 127 46 215 73 14 72 72 220 96 144 140 248 179 120 241 225 94 111 88 112 231 68 27 84 216 165 118 36 242 87 187 126 155 221 135 202 49 54 9 104 18 200 210 49 128 39 61 165 136 6 219 204 21 191 227 188 178 136 140 110 40 91 10 212 155 158 131 91 252 97 11 190 175 128 34 124 160 233 39 32 133 13 250 212 217 55 142 122 149 56 234 229 51 86 70 57 24 36 111 56 28 126 170 253 199 251 251 95 58 226 255 47 153 67 77 254 28 151 30 56 180 162 236 50 94 206 158 14 180 98 221 192 211 129 19 188 8 94 88 180 184 117 244 216 43 125 191 238 11 247 48 255 103 36 218 55 7 95 2 162 245 186 242 6 35 253 167 199 124 240 57 21 56 254 254 200 97 16 205 110 217 163 251 69 199 40 102 151 41 127 101 140 42 214 191 93 44 2 74 98 42 216 224 120 104 255 181 139 182 161 254 38 76 11 8 205 1 55 119 238 201 202 206 150 159 15 246 69 236 111 123 98 99 253 54 199 102 131 89 34 96 116 54 206 92 1 179 88 35 27 128 202 108 237 219 7 47 25 169 114 182 5 208 73 22 47 126 211 172 155 146 233 236 236 178 47 59 120 155 139 41 152 112 35 139 10 248 213 174 23 28 57 50 19 0 187 219 123 14 139 41 87 103 39 50 17 34 7 234 205 226 229 133 75 39 232 221 230 214 202 229 122 13 6 213 75 50 24 181 137 108 11 247 74 177 53 128 25 251 30 30 126 11 227 139 142 12 253 87 99 233 229 236 215 11 139 46 194 176 221 154 188 217 60 209 206 204 159 189 162 244 50 151 102 154 158 205 43 215 153 121 181 72 168 70 58 232 40 167 186 60 178 23 133 236 171 125 47 200 220 236 112 137 187 108 126 225 162 213 21 27 176 61 154 199 13 126 149 52 238 87 100 69 159 227 141 38 176 68 67 180 30 174 20 141 6 190 115 201 223 93 126 193 58 137 144 75 4 172 205 228 101 105 172 92 106 75 192 160 99 38 136 125 145 218 69 162 86 178 194 154 130 242 183 76 32 127 136 200 241 104 46 196 39 82 187 110 241 251 5 82 76 181 19 123 249 155 204 5 122 34 216 23 208 110 123 193 155 179 109 127 182 215 142 192 70 15 76 36 251 74 2 51 208 34 202 213 49 0 73 144 86 179 251 114 35 146 246 18 25 247 158 230 175 99 48 82 137 183 172 192 93 24 95 71 193 160 91 53 90 58 16 73 79 145 88 106 44 131 125 177 248 129 75 54 139 35 88 213 182 150 88 99 166 73 180 136 13 51 62 13 31 158 122 153 52 7 141 107 40 87 83 1 99 39 94 61 121 181 108 38 133 158 87 88 15 188 59 191 96 17 136 108 254 80 141 36 89 122 226 14 253 104 13 234 101 169 164 245 146 72 18 6 32 49 92 91 251 71 55 205 191 157 40 45 215 8 184 91 108 46 115 77 221 237 56 191 11 237 123 70 91 129 182 45 129 194 208 198 134 186 112 154 89 252 184 161 171 69 149 235 144 126 90 251 133 94 17 124 125 251 28 3 99 68 38 110 243 220 206 62 213 89 153 0 214 250 113 114 201 6 42 77 117 202 54 225 126 95 56 145 90 39 152 246 36 217 171 70 178 232 47 216 133 224 142 96 115 208 208 152 83 5 110 241 254 182 39 236 3 171 236 49 28 26 178 240 229 241 161 22 71 227 48 12 235 201 156 132 109 202 215 67 183 223 56 176 73 208 242 140 145 190 87 213 92 91 226 41 239 8 180 181 14 31 3 105 43 178 109 86 234 23 57 90 209 69 82 112 100 29 254 240 160 72 179 199 125 143 224 75 70 190 187 160 190 116 73 137 167 12 217 151 81 47 239 102 133 212 11 80 140 188 202 134 14 70 246 149 76 214 101 212 104 217 151 172 59 67 113 127 202 177 191 198 56 60 67 75 143 102 79 246 240 142 87 58 1 131 40 198 84 148 174 66 87 225 103 102 126 113 94 225 34 203 113 70 229 175 89 193 65 150 20 89 213 143 74 141 186 92 89 168 23 113 108 240 176 63 60 172 135 38 19 114 136 128 219 5 196 220 141 23 61 192 68 21 18 237 178 234 141 152 210 8 134 78 148 113 77 182 228 183 87 152 0 226 35 137 5 189 127 225 68 28 9 88 228 109 99 110 185 243 196 109 182 38 128 29 143 71 208 214 29 195 109 113 47 16 112 143 196 157 161 226 51 96 192 182 45 61 123 223 235 217 139 119 16 126 74 118 157 95 62 245 168 200 142 96 23 124 42 15 232 16 238 56 156 102 218 94 241 55 212 221 108 137 111 73 150 91 131 199 166 5 119 164 154 103 3 176 173 249 171 130 236 27 23 86 164 189 34 192 26 145 48 30 123 238 20 156 0 118 100 113 120 33 200 124 136 89 95 115 93 67 217 18 224 6 193 119 11 17 244 142 247 236 62 185 11 151 103 23 206 171 200 171 196 233 94 147 122 21 179 104 129 194 202 238 154 212 43 51 237 27 140 4 145 125 121 254 179 84 231 101 156 234 138 201 61 169 31 67 176 171 55 220 29 173 239 107 202 211 160 58 166 43 224 4 38 104 175 236 197 60 89 55 213 222 49 51 175 150 117 56 166 4 124 35 71 251 130 231 214 87 93 199 167 119 214 140 207 209 146 15 178 195 248 54 122 250 251 239 221 251 237 149 59 136 213 114 138 128 69 24 49 161 41 21 93 174 224 3 218 5 134 248 250 202 164 147 19 241 114 57 25 96 100 191 38 206 181 7 118 4 111 0 143 53 127 49 67 50 99 9 188 28 20 100 81 189 99 63 221 217 80 192 153 71 97 137 236 23 136 77 48 16 8 54 188 110 209 182 248 195 214 95 185 238 4 213 11 253 188 211 177 39 89 106 76 184 197 34 42 22 184 54 161 167 30 188 175 100 235 130 248 4 228 47 50 71 170 61 239 244 61 34 152 254 226 222 198 135 19 246 15 63 137 136 24 123 238 60 152 173 26 12 153 41 224 205 13 91 54 45 216 204 222 48 62 61 231 166 219 246 93 159 149 59 248 100 235 15 49 8 184 208 93 92 93 80 163 7 203 70 36 46 190 40 106 139 214 121 215 156 18 214 86 34 37 15 6 251 70 67 163 82 30 199 190 18 75 230 44 91 100 174 110 79 118 91 34 122 247 15 188 244 82 223 175 48 82 200 156 220 117 163 252 205 51 9 152 23 199 104 130 134 133 185 5 23 214 228 207 214 43 49 24 92 251 92 215 255 238 26 63 59 167 96 126 204 219 0 146 186 42 139 95 150 255 236 248 213 167 102 127 110 205 76 202 194 241 113 34 96 17 65 99 227 252 140 153 155 68 250 129 33 62 217 224 14 111 0 245 85 235 236 89 220 81 41 10 78 220 58 102 150 16 228 9 199 112 166 172 132 232 48 142 4 225 219 61 170 229 6 177 152 208 5 47 62 244 96 159 210 4 126 130 119 35 160 201 132 145 102 130 119 57 25 251 74 78 214 248 148 18 138 137 164 118 18 73 17 101 65 71 160 93 196 19 24 122 254 209 149 187 109 58 239 12 156 113 236 196 222 123 57 43 19 192 152 20 51 189 231 13 14 239 158 198 239 91 8 30 78 25 214 59 190 160 56 134 38 3 245 254 178 125 55 82 212 236 162 185 5 238 34 158 125 153 71 18 155 241 85 13 167 104 201 160 103 89 26 9 15 159 13 180 41 74 140 252 45 246 148 97 120 79 169 167 148 231 218 211 129 19 200 175 176 48 191 112 17 251 201 101 154 154 215 86 110 104 44 187 130 137 224 87 250 126 221 29 236 68 206 230 137 220 165 187 140 97 162 74 137 75 16 221 166 167 159 68 87 231 204 255 165 255 219 137 31 18 1 127 188 8 24 115 253 167 157 241 81 48 70 8 45 159 54 13 96 232 119 148 209 176 35 27 191 39 17 21 62 55 27 118 99 193 126 218 51 22 124 112 209 128 14 45 140 200 155 250 225 80 69 206 26 110 174 96 66 177 100 113 222 34 119 217 230 69 205 241 56 83 10 232 18 73 110 156 70 1 134 7 15 127 43 115 246 21 209 157 142 177 67 34 42 220 177 6 131 79 224 53 37 33 54 45 220 124 215 146 251 18 254 52 44 52 189 237 240 222 243 90 215 239 198 35 99 26 101 122 75 75 189 229 32 51 195 74 132 175 218 139 116 171 235 75 102 139 214 254 67 109 59 22 25 133 87 156 145 184 9 175 133 133 139 75 61 229 163 145 145 229 165 151 241 74 55 160 248 145 77 251 66 221 11 76 235 151 86 89 193 165 57 91 1 7 95 144 95 187 168 104 9 35 218 125 3 47 122 93 222 120 39 44 221 11 218 131 193 69 252 126 11 92 133 176 6 222 33 106 98 157 188 120 29 108 153 241 53 2 153 227 11 58 73 210 177 129 119 225 249 153 190 5 52 137 128 19 104 62 199 54 111 180 63 113 77 242 160 79 135 193 66 32 198 9 142 97 131 83 255 34 26 104 208 150 128 133 114 87 9 76 0 159 232 119 166 52 145 163 205 68 1 219 228 220 230 121 180 89 44 120 233 198 139 30 200 36 165 54 80 190 227 93 134 11 146 44 78 204 49 157 153 86 1 162 42 133 232 11 17 203 106 170 37 8 95 237 122 65 132 246 238 109 124 216 158 96 68 116 167 189 70 20 142 0 118 76 193 113 32 141 123 109 147 210 89 36 198 23 94 80 28 45 255 239 244 190 142 11 51 242 171 243 92 249 17 83 224 42 209 90 70 204 22 141 83 191 88 184 94 91 136 72 145 115 99 221 195 161 65 75 46 11 228 200 59 234 190 217 19 234 88 80 216 192 175 252 96 228 8 218 147 219 199 78 55 149 175 101 68 187 166 98 195 7 35 135 97 253 229 229 87 49 162 29 83 2 231 66 221 160 116 61 102 233 223 232 59 98 193 130 171 170 54 250 35 131 172 103 100 208 234 188 89 208 237 64 168 119 69 233 165 108 191 38 185 234 41 189 44 68 171 198 80 49 43 161 200 126 120 254 204 30 34 224 220 33 224 106 160 138 30 103 21 91 173 59 94 165 186 251 163 166 231 142 61 96 104 206 122 77 133 248 81 94 68 136 59 42 87 193 9 224 58 129 126 210 206 10 226 88 97 137 217 3 68 38 101 225 182 102 152 176 26 30 15 199 187 124 221 162 109 201 204 18 142 14 122 77 179 110 18 63 24 65 203 106 170 67 216 142 150 251 29 219 108 110 216 226 200 46 34 47 7 246 20 46 152 243 203 81 104 166 170 128 109 38 182 37 221 57 92 196 66 112 181 192 188 251 73 191 207 216 163 167 12 132 166 150 253 74 53 156 173 140 169 95 93 251 98 53 6 22 15 172 231 77 150 250 198 123 250 130 218 112 134 161 189 60 209 2 174 168 88 111 89 163 93 135 209 163 152 93 242 173 193 87 174 173 190 177 72 175 117 15 13 170 242 170 191 185 240 1 203 132 241 59 131 175 123 101 47 182 247 71 134 45 189 93 92 162 185 254 253 246 220 47 44 68 187 186 226 26 53 145 243 182 73 184 42 75 233 101 178 44 251 211 90 136 16 240 95 231 94 35 98 155 46 112 158 117 104 16 211 22 123 91 31 74 35 80 68 68 129 193 232 63 209 85 223 1 45 2 7 15 42 205 209 30 208 218 47 228 77 230 168 128 197 107 46 89 180 224 173 141 143 11 150 33 242 137 57 190 217 91 254 5 95 179 28 57 62 254 130 180 13 29 122 250 232 22 199 28 168 54 78 215 105 51 92 170 19 192 207 183 63 227 72 234 208 161 136 79 117 230 230 113 145 56 90 145 194 74 169 102 207 126 168 233 49 27 246 253 134 64 150 74 184 236 119 52 56 103 110 111 31 57 109 60 237 238 2 32 96 212 184 122 125 92 163 34 33 178 175 170 154 41 39 245 122 125 192 82 67 193 129 174 177 14 147 173 173 236 251 74 223 111 226 217 247 248 232 123 103 199 219 60 178 166 104 67 106 232 133 115 207 178 224 34 126 1 27 247 132 58 223 31 121 215 235 202 243 202 240 241 246 235 153 176 226 163 138 187 131 103 251 66 61 241 251 106 27 251 80 141 202 89 169 192 85 20 77 36 98 36 185 142 169 121 172 70 203 58 197 160 119 252 220 217 209 54 226 182 28 33 96 24 224 4 249 47 85 14 6 5 38 34 22 215 136 17 128 72 87 229 201 233 83 132 141 150 10 72 124 193 41 85 71 34 23 201 129 21 223 237 45 75 183 139 187 35 137 188 253 216 231 115 22 1 92 16 71 41 111 225 120 76 6 46 82 77 25 29 224 83 178 142 136 132 214 164 58 1 252 155 51 206 87 242 174 37 223 22 233 234 247 201 75 5 35 106 11 235 236 11 34 137 100 29 113 116 116 74 149 125 239 105 124 56 25 169 35 251 138 36 235 216 92 47 84 21 120 36 108 76 36 107 242 87 167 91 51 225 179 130 249 53 148 40 81 169 24 118 4 255 141 43 129 158 241 206 176 18 66 203 176 91 118 89 114 110 244 6 187 254 207 217 31 141 42 35 140 26 223 29 62 240 212 153 31 2 245 122 92 94 141 86 93 222 230 161 55 158 60 243 195 147 129 15 44 28 60 174 142 181 140 28 250 85 247 255 133 183 129 60 87 30 182 63 49 250 62 180 71 174 229 115 91 130 248 254 207 222 95 118 142 199 112 228 193 161 55 246 246 60 27 115 163 245 234 76 170 89 81 17 63 70 166 107 99 166 91 53 83 108 50 173 108 16 118 251 232 41 226 182 105 1 33 39 44 160 192 182 163 66 53 133 82 42 15 231 19 115 122 18 164 255 97 1 131 109 50 46 17 180 63 59 26 3 180 208 231 44 121 114 245 164 168 128 83 101 95 193 0 226 204 229 175 227 5 97 28 111 137 39 206 250 41 139 43 224 148 38 128 129 90 28 233 234 134 186 155 5 69 167 99 124 148 189 109 92 48 194 42 43 53 24 162 196 217 176 37 217 188 175 56 251 194 245 217 180 112 179 144 104 208 156 152 66 146 230 14 61 234 150 61 146 25 95 164 154 17 192 166 169 86 54 136 74 215 187 253 193 222 145 208 176 158 106 3 237 207 174 127 57 249 183 24 98 139 17 68 24 80 244 198 192 43 75 74 46 129 95 251 67 61 253 225 94 96 95 61 125 149 17 98 4 31 208 169 187 59 30 119 187 220 11 11 47 194 173 194 106 176 55 212 141 201 156 113 246 23 51 103 185 37 247 7 35 135 143 143 28 225 147 123 160 49 60 172 134 94 236 253 127 197 174 146 34 119 169 162 70 186 198 219 71 34 254 176 18 254 193 169 191 15 43 65 88 0 181 13 239 10 240 193 23 11 197 40 39 161 232 74 223 58 43 108 201 172 41 233 21 162 136 219 114 135 128 231 234 177 37 130 161 186 226 28 124 66 160 195 101 51 69 231 149 157 139 224 38 215 73 217 178 63 191 39 102 0 168 46 202 190 7 214 198 68 17 186 25 190 253 136 156 178 51 1 59 217 228 225 209 122 167 99 79 115 138 5 63 210 99 95 193 164 208 41 77 0 255 90 64 254 138 88 86 5 149 244 74 135 20 28 66 196 233 248 54 32 152 15 18 187 74 102 90 199 98 80 98 137 189 150 62 212 244 152 224 30 203 188 21 61 17 237 81 1 66 205 115 229 231 187 242 21 67 254 33 11 153 138 80 213 147 88 232 214 105 56 134 222 177 110 157 188 49 105 134 11 195 126 48 49 36 230 103 214 179 109 104 132 218 58 218 130 94 87 30 217 235 54 120 215 163 55 64 138 213 66 143 128 101 207 142 159 198 53 110 23 144 116 62 95 55 16 168 151 213 44 146 185 201 102 221 250 141 30 97 154 207 246 112 100 112 32 220 23 81 194 97 53 172 168 232 111 165 176 5 45 181 136 20 165 94 164 97 93 1 27 101 143 153 253 217 244 137 142 114 176 30 151 69 200 21 2 198 241 253 103 35 95 17 28 34 5 57 88 196 192 40 238 216 229 216 155 77 2 141 108 217 159 5 157 138 29 93 169 83 245 192 98 121 64 197 33 18 227 180 52 117 175 186 248 215 8 71 57 155 82 10 82 246 70 152 204 199 219 225 6 137 101 168 72 117 2 216 145 162 68 44 171 146 128 253 25 176 216 54 5 199 107 221 206 69 159 132 180 184 152 2 46 241 150 37 35 78 184 44 130 229 40 180 78 46 125 204 222 174 206 99 94 241 133 61 99 218 191 142 161 208 32 108 149 231 202 51 232 71 150 76 29 204 178 87 40 152 163 163 111 252 156 145 141 146 37 174 146 48 72 200 133 53 136 24 251 154 156 202 147 46 126 123 144 137 81 230 154 196 236 54 146 111 184 188 46 189 43 151 81 188 72 54 74 24 197 38 182 212 169 151 119 114 150 152 133 89 146 152 73 89 69 183 50 197 44 102 108 208 112 116 210 87 85 77 67 180 196 105 95 94 2 83 66 202 233 2 209 208 239 84 39 219 28 231 131 69 98 126 108 146 103 165 106 231 148 146 251 61 101 203 254 12 231 43 200 154 206 41 56 82 177 63 67 111 105 24 138 133 98 174 50 246 125 203 122 50 47 76 247 113 203 178 237 233 73 115 145 208 154 148 228 175 136 201 247 150 5 119 8 18 185 72 122 106 167 24 98 145 20 208 14 4 220 17 104 23 204 25 121 111 227 195 9 137 115 199 177 251 5 217 23 78 231 201 117 191 17 124 65 65 172 168 52 194 117 134 130 253 227 145 49 172 63 200 60 173 204 76 88 192 199 134 15 214 64 176 207 31 30 198 242 65 152 9 146 105 83 94 251 34 233 106 223 49 236 235 230 217 23 228 175 198 181 81 74 246 224 12 177 198 190 186 231 51 246 134 63 177 34 190 22 119 107 211 153 138 151 182 17 120 75 136 104 203 17 125 25 72 55 162 47 43 176 30 19 137 104 229 158 76 191 50 237 124 89 153 69 213 156 18 150 162 165 159 106 10 103 19 183 229 20 1 75 2 185 144 44 120 249 212 163 54 132 148 173 172 203 226 4 92 157 132 128 133 94 5 170 214 57 142 248 251 219 158 16 188 140 206 188 149 138 7 150 72 153 69 11 224 190 56 10 83 173 220 66 138 6 222 120 244 100 47 153 23 218 84 190 186 234 231 41 249 60 199 241 147 179 176 91 153 202 4 240 171 78 154 85 36 176 85 210 109 227 187 4 178 104 45 182 101 95 193 170 68 142 19 192 226 118 236 132 167 6 212 235 152 203 154 177 239 143 174 220 157 18 251 242 55 8 200 169 63 216 27 84 198 129 77 117 83 173 81 247 215 172 10 172 181 25 83 198 6 198 123 245 188 143 70 178 73 217 44 121 36 155 100 140 218 87 227 224 88 131 179 70 174 186 255 179 199 160 94 143 135 173 212 153 216 248 150 217 55 242 174 145 130 3 171 8 179 105 102 41 154 38 51 234 81 133 86 101 157 138 21 131 122 77 14 214 168 23 39 125 57 5 204 2 144 20 201 112 61 139 214 91 52 53 112 158 43 127 94 241 34 226 182 92 35 224 84 57 24 134 120 155 242 130 195 217 8 186 101 59 18 9 254 73 214 155 200 4 112 253 36 202 95 41 21 15 172 53 117 183 167 161 5 69 202 30 207 44 170 207 252 241 26 202 82 125 101 141 122 155 126 158 121 56 120 214 39 128 29 147 62 94 45 150 80 122 103 235 118 145 232 100 167 20 28 217 153 0 62 36 150 130 227 158 198 239 39 212 190 142 54 121 4 144 55 176 175 184 229 153 225 178 25 107 103 228 87 35 229 244 141 247 104 98 221 48 62 155 115 193 186 32 70 90 66 149 140 236 107 122 45 235 46 82 250 76 45 99 223 232 12 46 111 136 102 126 85 46 147 137 13 210 245 120 240 39 99 146 216 99 108 174 83 56 150 17 116 73 6 251 90 14 30 133 44 170 91 238 59 169 252 141 196 180 52 62 188 252 53 20 181 153 227 26 176 188 162 201 107 150 73 38 228 20 1 167 202 193 32 46 147 233 75 17 5 44 72 45 34 229 8 147 249 19 9 230 205 176 103 77 241 116 214 54 66 60 213 139 35 165 30 2 155 82 255 153 203 95 41 99 19 52 156 32 188 97 220 121 249 175 210 155 241 141 227 39 103 243 172 72 137 130 148 250 20 209 211 208 137 160 100 180 23 175 98 6 118 231 9 96 145 92 217 55 212 221 28 127 161 94 237 122 65 240 68 96 243 135 46 253 105 26 236 43 233 94 208 55 206 251 99 147 207 148 174 177 14 16 193 134 190 228 166 81 225 127 99 145 192 64 176 207 76 88 17 213 163 88 229 30 53 176 105 37 70 205 26 101 95 79 212 229 202 205 243 49 111 124 230 228 178 27 13 218 40 124 227 143 217 148 176 138 33 124 37 36 87 37 98 16 109 56 162 132 145 110 245 101 157 119 37 227 39 67 37 27 238 87 70 36 146 20 147 249 75 226 189 160 63 81 251 25 34 182 156 37 224 84 57 248 104 119 154 101 92 197 39 32 69 108 191 201 252 137 90 251 179 224 12 252 70 251 19 226 197 116 231 102 47 7 214 218 185 183 167 167 8 69 142 86 164 236 241 196 161 190 106 221 141 23 61 0 170 55 237 115 76 196 79 206 2 49 213 9 96 1 70 159 107 223 0 132 239 182 230 175 10 238 209 158 62 69 114 87 57 78 0 11 58 138 39 156 216 22 73 7 38 105 33 209 247 221 211 248 112 38 183 242 79 46 252 139 153 5 181 236 128 123 198 58 209 239 55 26 38 171 187 25 15 133 6 116 110 230 61 161 184 120 92 217 164 97 201 197 68 176 254 113 49 239 42 51 66 137 253 137 11 46 51 213 179 201 223 156 171 115 12 239 34 101 154 147 184 166 162 53 73 87 255 132 149 16 174 15 43 184 38 162 59 69 71 91 198 126 43 124 248 47 207 187 104 139 46 246 148 126 106 206 141 68 108 211 5 105 22 99 64 14 126 186 101 139 227 80 46 152 25 42 109 8 218 126 147 185 80 137 204 182 218 71 13 181 246 237 123 71 204 249 89 18 75 193 33 232 129 5 253 44 203 216 75 121 170 1 75 71 212 87 174 155 136 204 163 34 53 130 82 154 0 22 41 45 96 79 153 64 30 219 222 17 173 31 236 232 155 45 98 196 118 236 228 184 0 251 66 39 241 253 0 109 139 28 128 86 163 80 44 222 215 6 133 238 226 255 126 209 95 255 195 187 223 68 226 233 30 235 0 37 90 149 95 237 210 39 131 49 235 228 152 18 0 2 150 89 109 123 163 90 145 185 44 153 51 193 230 55 254 233 210 181 172 140 90 217 176 72 27 19 195 154 155 149 38 157 101 44 77 40 155 217 164 229 36 149 122 149 232 108 52 90 149 21 147 119 35 134 222 213 3 144 12 213 27 187 16 142 213 193 81 103 171 168 35 180 145 147 82 141 13 10 254 194 252 47 23 234 201 50 9 185 76 192 140 131 159 58 252 21 71 177 213 61 210 154 21 123 102 194 206 69 108 191 54 46 84 34 179 173 54 148 9 167 182 247 196 67 41 92 180 162 172 121 96 77 125 246 21 159 0 158 80 222 101 16 49 65 167 168 128 143 102 114 60 226 73 42 68 142 77 48 119 149 125 33 97 65 59 193 250 154 79 197 175 124 85 32 134 202 38 104 56 85 108 156 243 249 119 122 223 248 117 251 51 192 132 64 81 192 253 99 145 177 89 5 179 65 143 234 234 208 5 175 71 193 200 184 65 144 102 232 145 225 129 21 243 113 185 76 119 104 125 65 102 222 203 198 178 209 12 123 113 197 154 178 229 120 246 101 105 49 144 25 177 84 162 98 88 155 163 90 214 100 220 136 201 193 156 241 25 155 73 230 4 48 78 15 27 49 193 186 199 22 231 252 172 114 206 207 51 11 103 223 186 232 107 196 106 31 11 2 70 14 198 50 236 14 52 25 241 79 208 209 59 166 233 55 254 217 39 159 40 205 100 54 20 118 253 130 216 1 48 212 101 207 3 43 19 103 96 17 4 51 190 107 142 174 94 88 228 42 213 8 230 244 32 194 115 37 222 178 148 38 128 253 225 161 180 143 39 85 246 149 4 10 8 102 229 4 69 236 4 171 170 210 44 182 35 24 145 37 136 187 151 253 195 185 177 206 183 123 53 27 27 144 83 255 248 57 127 104 112 102 193 172 178 188 74 85 138 152 119 135 15 1 138 234 221 232 183 225 153 101 72 94 70 207 102 168 18 55 79 108 210 112 34 186 53 202 29 70 3 124 117 210 149 76 251 51 242 43 44 155 6 231 112 24 229 175 46 133 245 149 58 13 75 204 217 202 160 106 20 208 230 183 146 220 249 89 246 186 60 127 223 248 125 146 191 211 11 137 231 128 197 83 58 79 28 13 56 90 98 223 233 216 211 154 89 50 75 65 95 167 132 205 64 222 61 221 178 37 213 124 85 217 170 66 8 242 119 162 203 67 101 30 194 235 56 219 93 158 63 107 114 216 87 18 115 44 90 236 84 40 48 139 111 3 169 178 175 228 148 130 67 68 185 46 22 72 48 34 162 164 23 167 146 168 36 37 253 157 18 242 221 5 15 93 250 216 149 23 92 205 56 47 164 4 207 142 182 157 244 31 239 24 109 11 132 71 226 55 49 202 6 179 68 206 188 20 150 163 166 105 147 185 145 115 29 96 102 198 80 76 33 27 49 233 214 16 184 152 84 82 99 92 248 134 63 85 252 54 255 212 41 217 152 0 86 160 125 8 169 218 240 207 66 143 232 104 157 9 171 243 179 113 90 146 186 117 201 119 29 39 248 9 211 128 128 129 125 247 182 62 244 88 243 23 5 235 10 76 208 145 217 231 85 134 131 124 69 204 241 216 166 80 177 160 52 143 79 26 5 228 244 179 195 95 73 163 94 175 227 4 176 160 7 214 36 240 22 156 157 13 7 195 79 240 132 116 103 22 230 11 157 164 100 63 128 246 79 29 254 74 122 111 6 157 25 208 39 112 210 157 7 54 61 125 106 87 26 219 198 27 102 119 159 220 153 6 251 74 2 211 183 142 112 244 8 243 137 77 0 39 244 94 46 241 56 187 52 103 104 180 79 200 193 255 114 217 206 63 171 255 43 86 229 94 171 187 16 25 27 10 13 88 210 35 167 129 132 147 187 42 43 252 160 70 115 84 113 22 102 115 30 87 225 168 23 233 150 145 174 18 14 177 245 186 246 213 41 89 103 104 96 95 37 234 171 133 236 107 166 131 142 40 102 226 14 147 245 163 198 231 111 46 187 255 179 243 190 68 124 150 19 4 172 251 45 3 13 60 247 193 189 79 31 221 98 79 195 105 7 122 138 24 99 147 121 23 239 111 123 194 38 194 216 34 208 51 159 126 134 17 159 185 89 193 249 194 174 225 178 164 196 28 226 10 88 208 3 43 67 2 22 204 112 242 74 162 84 42 88 37 16 62 240 147 99 8 181 227 11 135 96 248 22 219 41 80 126 122 126 245 157 129 51 2 42 217 154 214 10 169 23 62 176 32 24 101 107 193 3 135 239 70 77 9 61 63 223 254 204 23 94 254 131 29 199 238 23 244 186 202 46 251 2 102 21 206 113 122 213 16 145 209 137 85 172 200 244 249 107 93 47 102 127 8 147 221 155 27 182 62 185 238 215 107 102 94 147 213 142 205 196 30 186 125 219 200 195 108 100 204 48 172 202 168 77 153 234 69 138 69 147 178 78 168 161 144 206 172 65 37 24 210 62 227 33 99 65 251 96 3 131 125 21 230 129 21 193 169 95 92 86 89 66 74 125 129 37 158 228 43 32 21 123 74 255 177 233 177 207 207 187 149 200 108 58 194 19 79 168 188 194 192 64 94 24 70 155 106 111 90 30 103 246 20 244 129 74 88 4 80 208 24 251 116 203 22 144 176 104 204 196 132 27 192 190 130 172 143 81 164 89 185 76 64 69 240 129 14 51 201 44 33 18 201 42 226 129 149 121 134 200 114 177 152 90 184 254 32 244 225 190 195 219 210 120 196 223 51 210 234 139 173 45 248 94 207 94 27 3 3 222 101 251 43 118 180 103 47 244 188 97 193 157 9 47 14 108 11 123 180 212 105 128 77 160 125 170 166 151 142 128 115 133 84 224 197 219 246 93 255 233 186 155 144 176 129 141 120 179 51 122 249 166 154 182 9 250 4 254 206 252 9 44 77 43 100 54 85 136 212 106 76 54 21 141 202 216 254 221 2 94 65 238 90 114 95 201 4 156 203 194 146 134 127 190 116 231 41 127 235 243 237 79 191 222 253 210 153 209 211 206 252 170 26 165 130 163 174 197 50 151 109 74 213 147 89 234 234 83 119 171 214 226 136 52 73 172 26 58 88 139 247 213 147 126 176 0 36 62 209 149 41 145 85 46 179 149 102 148 14 115 250 24 103 130 35 6 109 135 153 31 22 155 0 54 18 99 153 129 191 150 196 147 128 79 214 126 230 27 23 255 93 117 193 44 137 144 27 4 252 94 34 121 1 195 31 50 16 140 167 139 116 87 85 24 193 53 45 34 16 2 4 3 107 194 177 85 144 69 52 14 22 171 132 24 143 84 43 197 58 34 195 188 78 34 180 39 226 129 85 151 49 1 195 29 129 91 41 98 64 134 151 30 80 255 201 226 172 112 154 192 70 142 195 161 58 78 100 64 3 248 96 176 53 139 248 106 31 58 52 152 188 96 34 16 255 4 57 31 0 197 238 76 158 18 18 40 153 175 187 151 21 85 42 8 71 235 113 86 32 162 128 109 148 238 213 53 215 57 166 193 218 125 106 103 182 28 161 227 177 160 164 30 8 9 62 79 157 248 241 174 214 29 241 13 176 18 145 164 26 243 188 122 121 34 151 42 155 14 77 154 180 117 1 225 233 33 70 154 232 132 111 125 19 89 175 46 4 76 171 68 100 179 202 48 176 35 230 220 80 13 99 181 42 177 169 89 93 41 155 121 158 163 42 153 83 186 166 31 86 212 39 203 244 130 54 51 111 152 149 24 76 207 103 99 13 44 22 186 139 175 169 221 120 211 252 219 39 243 9 36 76 6 1 219 187 95 193 144 157 234 180 95 178 0 92 160 70 241 18 135 105 96 99 253 182 9 138 125 154 80 5 156 221 20 217 54 128 23 169 238 108 36 106 134 7 198 134 128 225 238 11 78 213 227 163 37 248 60 128 38 78 149 128 117 2 123 51 195 147 61 212 119 128 39 224 201 33 69 132 163 245 56 43 47 31 25 70 18 95 85 115 173 0 1 239 218 180 96 115 201 4 11 250 17 173 250 2 186 92 73 72 182 122 58 104 211 135 73 54 244 46 147 194 26 233 74 88 46 73 99 92 151 70 117 178 34 69 140 28 150 218 26 21 89 214 101 102 249 208 130 145 184 92 84 146 196 139 233 232 220 48 75 51 201 248 53 18 141 65 10 179 228 27 204 254 204 59 94 113 113 71 70 130 145 47 204 191 109 221 204 79 46 171 88 149 239 46 32 246 202 1 196 204 1 183 13 29 202 86 242 222 232 251 114 242 129 178 105 194 60 168 97 116 22 9 147 205 74 186 99 246 62 145 57 1 11 122 96 101 229 176 151 207 204 78 24 113 107 172 81 58 254 148 39 194 95 204 50 81 50 105 4 102 41 23 8 84 148 170 69 58 25 74 38 197 194 108 15 17 15 41 251 188 34 235 107 174 115 188 32 254 208 16 136 224 137 62 151 64 56 192 71 4 113 41 42 85 22 198 195 127 140 68 143 230 20 175 153 39 210 164 76 37 108 78 241 134 12 163 177 230 72 21 12 169 177 31 109 114 87 159 250 213 103 127 245 6 250 52 176 190 222 92 25 10 171 65 189 141 222 88 247 136 230 237 207 17 137 153 160 99 106 14 226 145 175 169 222 208 52 99 13 177 111 110 18 112 218 105 35 147 193 190 84 192 220 178 149 19 49 58 3 245 218 79 76 242 172 153 21 149 12 157 124 185 241 241 204 251 233 22 203 10 146 21 187 122 218 121 164 19 12 220 182 178 53 91 211 240 86 229 157 226 179 154 21 99 93 124 154 198 245 179 174 203 188 219 123 26 31 94 156 241 225 137 196 230 234 85 249 146 66 36 149 180 99 160 11 206 160 59 138 224 52 220 208 82 66 161 167 48 42 76 85 137 47 154 27 157 241 141 150 55 136 86 62 224 211 101 32 7 27 1 187 232 177 172 47 107 46 84 72 174 138 229 163 121 90 153 46 87 193 32 44 71 244 15 231 123 21 66 159 44 53 234 126 133 126 209 9 216 215 248 168 10 103 124 134 198 68 90 185 73 192 130 53 133 82 162 37 199 58 181 27 23 109 203 238 52 237 198 250 109 41 149 231 203 188 230 60 102 4 19 49 47 59 146 189 136 7 86 22 237 234 233 85 82 138 71 179 109 38 78 204 214 146 125 2 238 217 155 146 35 58 136 179 172 168 76 203 44 105 134 153 37 224 144 158 92 247 27 222 172 157 246 11 132 136 151 150 189 198 21 81 192 142 135 241 105 129 115 153 4 17 92 158 87 37 161 247 178 233 48 108 154 133 21 131 123 205 242 6 28 219 169 28 19 243 142 81 17 150 30 146 201 92 93 215 70 63 6 221 26 223 99 227 58 245 142 107 212 171 125 216 175 134 255 51 147 191 44 255 6 115 203 82 194 204 227 218 40 83 40 197 228 154 44 246 150 18 105 229 38 1 139 212 20 74 149 150 68 52 104 74 53 134 29 186 90 182 61 213 4 141 203 51 203 104 1 34 242 214 198 199 5 123 112 108 38 226 129 85 157 85 179 121 86 252 212 10 156 122 128 247 176 236 38 206 132 99 6 82 79 245 200 55 101 35 13 147 197 79 184 182 176 46 237 204 198 88 13 23 41 205 49 67 69 137 167 60 115 137 223 49 218 110 251 110 33 144 170 211 73 103 195 5 17 169 127 188 59 173 160 106 113 92 88 114 17 23 7 108 201 162 44 25 9 170 84 61 148 72 82 98 10 255 73 81 14 214 73 151 81 44 179 36 107 17 68 176 160 211 109 244 99 170 222 96 48 98 44 132 85 131 104 131 81 222 213 55 87 12 247 43 227 27 253 176 164 104 80 19 58 78 171 156 227 21 75 187 81 83 48 155 72 43 55 9 24 134 200 172 20 125 195 174 196 105 53 165 218 74 54 68 248 213 85 63 79 35 62 7 246 11 42 60 141 61 194 133 2 190 23 180 117 11 98 210 60 176 210 144 239 54 68 120 171 128 249 29 30 173 172 112 48 238 17 238 181 163 113 37 30 155 27 182 138 20 227 75 202 61 51 86 63 122 229 238 248 50 62 119 45 185 47 13 251 54 208 54 99 95 157 95 179 160 108 28 207 174 35 208 158 204 246 43 88 171 81 196 138 32 98 21 192 168 232 137 27 215 150 84 52 178 178 128 44 129 20 171 35 100 36 137 212 203 221 99 62 13 61 174 55 38 23 149 201 190 152 64 35 170 89 225 79 147 80 49 180 23 63 22 26 54 214 176 101 166 125 181 201 99 53 24 117 129 86 88 22 232 48 159 223 195 140 65 102 214 114 141 125 139 61 197 53 133 68 192 57 5 143 133 56 225 211 54 116 232 104 247 222 244 4 49 12 229 48 212 166 74 132 64 3 48 164 238 61 241 80 26 78 209 112 192 48 22 103 242 222 80 95 181 14 142 89 48 179 7 158 99 214 37 157 52 185 30 88 150 139 255 229 198 199 95 62 245 168 120 254 81 36 194 166 89 55 193 123 143 248 155 19 92 100 184 212 47 39 74 238 33 120 156 75 171 55 102 104 177 120 168 233 177 7 14 223 45 82 54 32 42 61 189 101 87 215 92 7 164 98 195 178 64 165 219 154 191 42 88 14 1 104 242 142 122 235 171 128 62 131 187 61 195 91 121 213 204 79 37 59 6 56 11 16 175 87 213 92 155 108 91 145 76 150 130 137 36 225 212 128 170 29 29 170 119 249 182 139 216 222 211 67 153 183 162 177 226 178 67 253 111 73 70 169 122 221 233 89 15 55 210 216 87 251 91 114 75 18 139 41 210 181 136 203 20 37 110 160 61 183 214 82 47 83 168 45 96 169 96 89 175 6 40 197 215 96 96 222 82 166 209 216 200 218 97 132 18 49 171 178 105 226 86 13 165 107 198 26 233 214 111 126 67 86 196 80 146 12 3 52 44 175 168 188 140 24 43 199 32 199 22 179 138 181 182 245 237 107 31 58 100 159 146 144 113 18 144 238 178 153 27 51 204 17 33 206 253 56 28 55 36 47 115 148 134 250 124 229 212 163 246 103 138 69 123 146 81 47 108 110 47 97 237 13 12 120 0 142 180 119 227 69 15 76 208 163 0 188 184 191 237 9 199 139 159 121 229 34 96 122 140 253 21 105 12 79 84 157 238 172 151 197 201 111 96 169 93 173 143 216 243 37 208 109 211 140 53 171 170 174 20 49 168 34 64 210 1 169 216 16 207 122 157 200 147 233 84 251 124 29 119 45 249 182 72 57 194 47 188 252 7 22 46 4 86 134 19 113 220 118 167 239 17 199 50 12 215 207 185 73 144 50 225 82 60 120 248 110 199 102 247 52 62 60 113 28 252 159 29 207 223 255 238 93 124 1 6 172 119 36 105 37 23 140 226 10 46 179 186 145 89 13 201 205 234 251 186 245 154 131 184 146 85 110 192 58 72 241 251 178 20 10 100 188 203 202 17 90 104 152 143 18 54 162 149 52 57 174 154 218 87 225 106 57 176 138 11 234 183 47 217 113 237 236 207 18 105 125 92 8 216 66 15 227 17 127 188 151 208 220 242 149 229 73 82 109 100 200 196 218 30 195 126 62 15 51 12 193 121 238 18 216 35 168 192 9 202 65 141 169 151 134 199 59 25 149 178 157 102 158 127 106 186 0 206 189 103 180 117 112 76 211 169 193 136 31 78 95 50 61 198 179 120 17 180 58 149 163 173 240 68 193 46 248 23 23 204 220 146 245 221 37 180 130 30 31 106 177 40 63 45 157 147 167 60 19 75 181 111 168 5 20 118 103 224 12 203 189 181 170 106 245 172 194 186 171 179 228 5 102 15 160 189 227 67 71 129 113 117 222 61 159 169 249 225 85 192 81 4 131 80 126 118 195 235 19 116 0 33 37 116 251 190 79 183 143 158 100 28 172 209 167 108 22 56 210 73 87 11 240 213 75 33 33 221 186 181 132 210 218 183 89 13 73 91 143 229 12 205 106 72 46 57 182 60 131 202 17 100 84 182 170 18 38 208 96 107 144 131 181 210 132 42 171 19 172 68 19 110 152 17 71 172 232 47 178 175 206 211 198 248 92 158 87 245 31 215 236 163 0 164 143 41 1 19 8 4 130 56 64 82 219 228 20 155 28 17 124 184 255 191 254 242 192 23 113 160 99 36 106 144 46 83 192 154 168 149 116 11 51 234 99 73 39 96 179 254 160 78 219 82 108 17 67 94 248 114 75 134 241 57 94 10 171 134 180 85 245 218 192 146 202 25 153 21 125 13 10 95 156 150 54 107 45 40 42 223 191 36 253 247 197 255 227 79 169 214 111 206 193 69 151 128 64 32 100 29 130 233 174 118 249 182 79 92 76 112 99 229 101 55 206 253 19 150 124 131 205 170 42 42 75 209 204 114 78 177 234 67 10 38 223 48 171 21 69 131 128 195 177 161 71 124 12 18 134 39 177 77 66 172 49 115 227 226 178 78 114 78 215 232 246 140 12 109 184 97 75 102 129 35 30 115 138 230 111 90 248 21 122 168 136 128 9 4 2 193 25 192 190 34 113 95 29 129 246 9 141 9 254 218 197 127 125 97 233 69 150 4 88 166 229 88 98 37 5 185 92 205 70 69 35 51 18 201 164 94 36 81 157 92 217 135 255 51 234 44 173 6 35 70 160 17 203 52 25 142 68 147 123 152 245 24 128 137 57 225 139 154 216 76 73 173 114 242 87 245 186 60 127 215 248 207 94 151 151 30 170 220 3 153 160 9 4 194 132 0 164 237 231 95 249 3 71 129 11 84 253 31 215 188 62 113 19 228 189 227 61 127 117 224 75 109 35 39 245 233 91 153 51 44 75 230 28 176 44 241 51 196 81 131 179 203 248 83 50 82 74 199 123 96 169 177 118 104 102 136 198 63 89 13 65 180 66 27 156 111 242 174 196 149 78 98 170 215 194 190 46 217 253 215 203 190 247 153 185 183 208 227 68 10 152 64 32 16 82 16 193 87 11 248 144 79 116 98 172 25 249 213 63 89 179 103 213 140 53 106 44 29 154 153 176 140 152 91 150 3 210 212 196 102 5 5 53 28 45 244 27 163 143 35 198 178 100 164 137 54 35 137 181 114 11 97 67 245 70 211 91 170 209 24 95 21 203 28 153 142 208 166 191 21 166 227 50 93 186 224 147 231 46 248 238 202 127 37 246 37 5 76 32 16 8 41 35 62 50 234 188 136 96 196 179 167 127 182 243 248 15 70 34 126 172 143 20 85 186 248 39 91 230 116 176 161 123 141 246 230 160 105 45 0 108 10 96 190 100 47 203 255 97 102 2 49 182 224 92 180 152 138 142 85 189 70 87 165 158 242 135 46 123 236 146 202 203 233 41 202 97 184 191 243 157 239 208 85 32 16 8 19 129 82 111 89 103 224 140 165 130 69 60 180 84 201 106 112 117 245 213 19 122 48 75 43 46 217 88 247 133 60 119 254 105 255 137 177 200 168 145 128 67 167 86 190 90 3 124 93 80 48 243 194 146 197 93 99 103 77 171 178 98 212 116 144 165 152 26 74 24 98 132 149 148 140 169 92 35 175 22 211 214 172 135 88 234 53 57 87 138 49 56 179 67 189 182 246 179 223 187 244 127 93 88 122 17 61 66 164 128 9 4 2 97 98 69 176 166 80 55 188 158 173 242 142 246 8 41 161 3 61 191 111 238 123 227 216 224 187 17 53 114 202 223 90 238 173 168 202 175 134 189 207 41 94 176 170 106 245 101 51 214 14 135 6 191 188 239 250 225 208 128 44 49 29 156 0 28 115 163 255 84 244 23 211 225 11 201 86 253 74 195 214 210 188 138 231 78 255 159 15 253 31 48 233 140 165 133 25 1 23 184 139 63 89 123 195 231 230 253 233 197 229 43 232 201 33 2 38 16 8 132 76 177 237 157 63 23 73 255 121 67 221 205 241 169 182 207 35 94 60 251 220 63 30 249 27 147 122 229 36 173 98 9 216 100 92 110 165 182 188 178 242 202 71 174 248 153 75 75 244 33 117 5 58 222 62 247 90 235 112 75 32 50 122 98 248 125 32 254 11 242 107 106 10 102 47 175 108 90 94 209 68 169 54 136 128 9 4 2 33 107 104 238 125 211 62 209 230 228 139 96 65 60 122 236 193 103 63 250 153 136 2 150 98 178 98 69 185 25 86 94 80 48 235 177 181 191 152 145 95 77 79 2 193 2 242 130 38 16 8 19 139 166 25 171 5 243 98 238 242 109 159 82 71 254 245 139 183 93 63 231 11 24 40 108 248 72 115 159 216 149 17 21 39 131 85 246 209 254 119 65 65 205 15 46 127 146 216 151 64 4 76 32 16 206 15 238 168 223 42 210 236 249 246 103 28 61 182 38 117 124 148 221 127 189 252 123 183 213 223 25 83 84 56 38 222 215 244 165 82 163 117 3 217 167 190 236 226 159 172 222 179 160 164 158 30 0 2 17 48 129 64 56 111 34 88 176 106 242 142 99 223 157 122 111 15 119 61 114 249 83 117 69 11 56 117 139 21 20 162 130 87 91 214 28 161 13 110 246 184 60 95 94 244 245 159 174 249 5 85 240 37 16 1 19 8 132 243 140 91 4 50 83 74 250 132 177 96 101 229 201 125 129 88 243 212 85 123 183 46 251 238 194 210 197 72 180 10 63 251 171 27 159 113 185 208 93 252 217 121 95 250 249 250 151 191 186 248 91 148 63 146 96 15 114 194 34 16 8 147 4 145 26 133 40 151 31 189 114 247 148 61 11 223 80 203 129 158 223 31 29 60 216 51 214 217 25 56 59 18 30 190 176 100 113 190 171 96 105 197 202 21 149 151 175 174 94 79 158 204 4 34 96 13 225 112 120 120 120 88 123 45 45 44 44 40 40 200 177 147 242 122 189 37 37 90 177 94 191 223 31 10 133 96 161 180 180 212 227 241 76 68 207 149 149 149 83 228 244 199 198 198 2 129 64 230 39 59 245 145 173 219 58 117 240 124 251 51 15 30 190 91 164 37 16 240 249 173 103 76 32 76 2 114 103 252 130 113 185 167 167 7 22 128 104 171 171 13 159 195 142 142 142 147 39 79 194 194 194 133 11 231 206 157 155 27 103 10 167 233 243 249 240 164 144 38 91 90 90 224 244 97 97 253 250 245 236 196 129 77 97 161 182 182 86 124 236 78 214 51 244 176 118 237 218 41 114 250 112 67 241 70 55 53 53 225 65 230 42 178 117 91 167 14 110 168 187 121 151 111 187 136 8 222 213 250 72 211 140 221 18 129 144 211 200 157 57 224 254 254 254 147 58 112 204 98 172 140 11 185 52 82 91 78 10 70 100 92 195 139 212 182 182 54 188 26 41 13 211 150 158 199 116 160 2 155 82 55 90 123 115 244 120 114 155 125 217 197 207 252 182 78 41 136 207 4 131 92 166 1 154 64 4 60 45 105 9 129 6 85 105 42 89 80 51 135 223 239 199 5 228 69 118 142 236 196 19 82 114 38 61 87 84 84 76 157 187 140 18 112 74 189 19 76 4 10 10 10 214 235 88 177 98 69 134 183 117 170 137 96 193 162 11 83 45 38 152 64 200 58 114 193 4 141 118 57 52 75 2 6 6 6 128 72 208 224 140 140 2 3 22 140 92 208 12 255 4 58 137 183 224 193 175 176 33 244 131 210 74 196 196 7 82 12 247 133 195 37 110 197 198 74 232 16 215 3 85 176 93 95 112 193 5 208 6 127 133 109 19 30 12 254 10 237 145 105 160 91 104 195 143 185 40 1 97 61 110 197 88 19 214 160 29 158 189 139 132 66 33 208 76 176 30 55 79 181 103 214 15 155 62 103 243 175 142 52 192 174 39 158 99 117 117 181 101 14 158 191 35 241 71 18 127 41 240 242 38 124 39 16 233 42 161 140 46 44 44 196 67 133 109 97 43 124 102 108 158 4 222 165 0 22 206 157 59 7 107 224 188 224 182 198 239 209 241 137 178 220 14 203 85 226 167 186 241 241 78 118 91 69 246 149 240 124 241 141 141 205 247 179 151 176 9 157 120 6 246 221 180 224 142 157 2 228 218 17 104 7 17 12 132 77 195 52 33 87 145 11 78 88 205 205 205 140 132 24 97 92 113 197 21 48 232 28 57 114 4 169 2 134 75 28 230 16 48 66 53 52 52 176 17 231 248 241 227 150 30 96 232 105 108 108 180 49 114 250 124 62 164 88 30 172 91 182 107 88 3 67 39 191 235 133 11 23 194 134 188 157 28 14 143 169 28 56 140 195 135 15 243 237 17 192 13 176 161 165 103 220 23 252 137 195 43 156 50 156 230 177 99 199 44 219 66 51 104 156 73 207 107 215 174 133 11 2 135 141 51 196 246 23 7 118 196 38 47 249 235 9 125 178 185 121 52 165 38 187 122 201 250 129 78 160 7 188 236 75 150 44 193 222 68 186 138 103 223 248 187 3 23 1 110 132 253 147 192 246 5 127 90 154 177 227 17 124 162 18 222 14 190 141 248 109 117 220 87 178 243 133 211 193 101 54 199 12 127 190 245 214 91 248 86 209 212 212 52 65 134 110 127 104 232 243 175 252 1 124 59 182 172 45 172 123 118 195 235 52 76 19 114 21 185 96 130 134 129 143 73 79 24 67 153 191 21 27 149 96 0 130 215 121 28 97 153 98 96 35 14 27 191 160 31 104 131 195 40 172 143 31 214 121 113 131 61 64 99 224 78 24 124 113 176 99 204 202 118 13 107 112 215 108 44 131 110 161 115 56 66 54 94 227 56 139 192 65 25 233 10 122 70 106 196 161 159 13 220 22 85 138 154 12 54 129 53 240 13 155 176 159 22 234 192 179 78 187 103 236 150 177 47 156 41 80 66 50 246 133 93 48 214 196 123 129 183 6 214 227 230 60 141 65 183 115 117 224 197 129 93 176 75 145 176 31 102 87 96 250 155 57 217 193 65 226 155 68 124 87 9 95 17 112 129 127 55 130 30 28 159 4 246 54 0 205 240 168 216 19 197 206 14 143 156 153 94 88 27 203 19 5 109 226 111 7 127 130 34 183 85 112 95 9 207 23 238 96 188 25 159 57 121 177 155 50 17 64 17 44 100 220 10 180 239 244 61 66 195 52 129 76 208 83 23 48 88 176 97 139 25 18 249 113 135 233 33 248 233 213 87 95 181 140 56 216 140 119 147 134 49 168 95 7 12 184 9 131 151 216 40 198 108 143 48 90 241 42 36 126 215 208 15 138 24 94 157 192 32 203 43 60 216 10 199 196 89 179 102 225 232 15 157 15 12 12 240 92 194 218 227 126 217 156 40 254 89 169 3 175 6 210 91 230 61 163 9 29 9 6 182 133 211 177 25 154 217 43 8 175 65 161 61 138 45 124 19 66 202 231 175 3 220 53 148 104 231 206 157 99 204 26 223 15 123 115 66 78 98 52 195 203 53 232 208 210 149 13 1 51 229 202 172 193 246 79 2 187 92 172 13 124 131 100 196 107 5 155 195 222 227 143 28 218 160 156 229 159 40 108 3 203 248 130 194 14 149 25 255 249 169 238 100 183 21 174 164 200 190 18 158 47 244 195 30 0 248 70 58 199 91 3 203 236 141 118 130 176 105 193 230 221 167 118 137 136 96 104 6 141 5 167 141 9 4 34 224 243 0 123 15 44 166 246 24 113 178 241 142 145 1 108 200 134 87 70 186 129 64 32 33 1 51 6 2 78 133 129 30 103 239 248 225 62 126 215 236 8 97 136 100 7 201 70 97 118 240 188 199 13 116 2 67 39 155 151 181 244 204 40 220 114 226 204 85 135 215 55 105 244 204 174 6 92 4 156 95 135 115 132 225 219 254 70 176 235 201 78 156 41 54 214 128 105 44 182 107 118 233 216 85 98 100 195 247 195 218 227 169 49 185 6 7 198 14 62 254 145 136 7 107 12 167 195 222 159 28 159 4 248 137 221 47 62 164 13 184 10 223 3 112 234 52 225 21 128 39 4 251 100 79 20 124 67 111 112 23 128 191 171 117 240 125 198 79 117 39 188 173 130 251 74 120 190 252 217 89 228 111 93 221 132 215 35 18 159 9 6 146 222 125 106 231 230 134 173 52 88 19 136 128 167 40 216 59 62 27 202 121 151 81 198 151 22 142 97 254 47 240 141 178 73 16 48 230 66 231 56 252 245 232 128 33 152 55 183 198 239 154 119 149 178 172 97 67 42 234 48 232 205 50 165 199 218 160 204 226 79 51 190 219 132 110 74 105 244 204 155 91 25 9 57 222 5 38 199 147 169 228 248 59 149 240 117 42 254 2 242 239 79 236 246 49 30 98 134 116 71 176 187 195 59 49 137 60 9 236 194 178 185 131 244 174 0 98 233 210 165 104 99 199 7 9 0 155 0 65 198 59 214 37 187 173 130 251 74 120 190 150 215 11 180 168 227 53 180 188 74 78 17 17 252 233 186 155 167 84 153 66 2 129 8 56 10 139 152 75 198 67 150 105 78 148 44 56 132 37 140 180 65 175 209 132 64 186 69 246 197 161 208 231 243 65 183 208 21 211 79 124 159 241 1 81 241 226 245 240 225 195 208 21 218 24 81 138 193 159 204 235 39 225 38 241 44 30 63 149 155 97 207 56 13 233 215 129 182 202 100 215 132 93 79 27 231 53 11 137 242 183 143 173 100 76 111 233 39 62 0 218 98 102 72 104 165 16 225 81 145 39 129 185 217 91 132 35 122 179 227 182 150 19 137 111 195 110 19 78 165 67 159 240 19 78 205 194 182 199 142 29 67 67 133 200 109 77 118 181 45 251 178 121 111 224 111 37 147 191 9 47 230 121 23 193 187 124 219 239 105 124 152 198 107 2 17 240 20 101 95 139 117 46 33 15 241 99 37 223 3 63 115 204 167 99 76 104 127 102 241 33 208 9 250 16 49 175 34 84 18 241 209 59 188 10 73 70 39 252 28 36 155 129 235 236 236 228 15 56 94 24 89 2 135 18 142 245 153 244 12 167 208 216 216 200 188 112 109 38 86 109 238 78 123 123 187 229 34 227 53 97 199 12 221 198 191 178 240 20 139 203 140 2 45 199 192 119 203 71 209 216 75 240 132 55 215 230 73 96 23 150 63 42 184 137 120 161 44 244 150 176 13 147 170 44 40 8 141 207 112 95 154 155 155 89 51 254 226 219 220 86 193 125 217 159 47 179 132 227 153 242 174 94 83 74 4 63 223 254 204 245 115 110 162 228 148 132 28 67 46 120 65 243 90 45 126 37 63 96 241 158 165 252 32 197 94 255 37 221 75 249 136 142 248 105 69 4 208 0 54 136 55 231 38 27 43 19 230 3 177 28 97 124 128 16 26 141 249 3 182 108 98 115 142 252 213 200 164 103 56 96 76 237 25 127 161 226 193 83 62 179 232 194 245 68 159 32 230 111 197 218 176 5 92 70 87 163 100 253 248 124 62 22 190 108 97 107 222 145 27 180 62 220 26 104 236 104 3 231 47 154 200 147 192 46 44 207 196 45 45 70 241 218 89 179 102 37 236 135 111 195 230 86 177 219 120 55 123 11 101 218 223 86 193 125 37 236 205 114 203 48 200 24 122 155 104 223 171 132 34 88 176 241 20 44 83 72 32 144 2 142 2 231 210 48 62 146 37 44 228 51 27 196 39 81 2 185 131 217 43 223 122 235 45 88 15 210 150 205 62 38 27 140 128 141 112 232 4 213 2 205 64 111 225 24 199 198 47 11 205 39 83 33 22 149 195 126 2 242 0 69 200 186 141 39 114 214 51 27 148 249 110 25 127 236 223 191 31 227 161 211 232 57 222 11 9 78 13 121 14 134 251 100 89 181 209 196 141 174 185 120 61 89 248 53 172 71 114 197 126 144 152 241 37 128 93 61 222 107 26 46 50 26 102 45 253 240 199 108 233 10 116 42 59 108 251 32 96 203 221 17 121 18 216 132 43 246 0 109 48 23 135 229 236 88 63 241 71 206 183 129 14 241 29 8 126 181 244 35 197 25 228 147 221 86 193 125 37 59 95 182 11 102 87 224 131 229 38 83 4 255 186 125 143 72 118 104 223 80 203 238 147 59 55 45 220 76 163 54 129 20 240 20 130 37 203 18 26 129 227 185 54 225 172 48 11 30 197 73 56 212 1 176 210 198 221 23 246 5 191 50 162 98 190 75 141 141 141 232 40 27 191 107 155 41 61 54 80 242 126 176 120 36 192 34 40 64 217 11 132 197 15 54 222 110 44 197 206 225 97 231 105 244 28 239 85 206 215 183 176 185 23 24 159 195 174 39 166 116 224 189 160 49 250 136 217 189 241 20 128 144 248 23 5 100 80 22 210 10 253 240 142 190 236 144 44 93 49 107 252 138 21 43 146 217 201 109 50 89 218 63 9 188 91 59 172 68 75 47 90 209 249 179 139 239 7 175 0 116 98 113 11 199 119 53 75 63 120 155 18 186 244 199 223 86 145 125 57 102 238 228 61 240 39 89 254 50 17 124 71 195 22 193 198 59 91 183 139 216 171 9 132 233 130 220 41 71 200 230 213 210 155 196 98 178 67 124 142 115 34 234 226 177 121 199 76 60 81 249 89 234 236 246 156 234 245 180 164 57 76 245 234 97 27 155 78 44 93 101 165 232 100 194 39 1 132 38 26 0 144 221 19 94 225 84 175 128 96 27 251 219 154 70 63 60 142 29 59 134 10 216 230 173 101 18 32 88 39 24 176 190 230 186 135 46 253 41 13 220 4 34 96 2 225 227 2 150 238 148 101 109 156 238 111 171 237 237 237 108 50 66 36 194 123 98 47 111 239 155 119 30 216 36 216 248 158 198 135 41 65 52 33 55 224 162 75 64 32 56 130 85 122 200 153 211 97 179 39 112 82 54 83 230 147 131 166 25 171 65 218 10 54 222 113 236 126 223 80 11 61 147 4 82 192 4 66 238 3 107 76 73 250 140 169 77 22 142 105 4 230 56 61 117 206 168 35 208 126 219 190 235 5 167 120 107 11 235 158 92 247 27 202 79 73 32 2 38 16 8 132 44 96 167 239 145 157 194 53 128 27 202 150 254 232 202 221 196 193 132 105 13 50 65 19 8 132 41 129 205 13 91 129 86 5 27 251 134 90 190 113 96 19 57 69 19 136 128 9 4 2 33 11 184 183 241 251 226 162 22 56 248 182 125 215 211 124 48 129 8 152 64 32 16 50 5 40 224 187 150 220 39 222 30 103 142 119 159 220 73 151 142 64 4 76 32 16 8 25 225 134 186 155 83 141 50 218 113 236 254 59 15 108 34 41 76 152 118 32 39 44 2 129 48 229 144 158 109 121 211 194 205 155 235 183 144 103 22 129 8 152 64 32 16 210 132 63 52 244 141 180 68 45 22 120 216 220 176 149 174 33 129 8 152 64 32 16 38 149 131 37 61 80 248 142 134 45 148 48 139 64 4 76 32 16 8 147 205 193 72 195 247 52 126 159 170 8 19 136 128 9 4 2 33 29 60 120 248 238 231 219 159 73 123 115 32 224 59 234 183 18 13 19 136 128 9 4 2 33 101 0 1 239 56 118 127 38 105 55 214 215 92 119 215 210 251 64 19 211 197 36 16 1 19 8 4 66 10 240 13 181 60 112 248 91 25 198 26 221 80 119 243 93 75 238 35 55 105 2 17 48 129 64 32 164 134 148 242 69 39 4 186 73 111 90 176 153 104 152 64 4 76 32 16 8 41 160 35 208 254 224 225 111 53 247 190 153 73 39 228 38 77 32 2 38 16 8 132 116 240 124 251 51 187 124 219 129 140 51 233 164 105 198 234 187 150 124 91 188 2 4 129 144 93 80 42 74 2 129 48 253 0 226 245 201 117 191 217 220 176 37 147 78 64 70 191 218 245 2 93 76 2 17 48 129 64 32 164 128 18 111 217 230 134 173 207 110 120 125 125 205 117 116 53 8 68 192 4 2 129 48 169 168 45 172 123 232 210 159 62 122 229 110 138 244 37 16 1 19 8 4 194 100 3 216 23 56 248 158 198 135 41 210 151 64 4 76 32 16 8 147 13 54 49 44 30 98 84 226 161 96 36 194 121 3 121 65 19 8 132 92 131 63 52 180 227 216 253 142 9 44 27 202 150 2 97 211 229 34 16 1 19 8 4 66 54 225 27 106 217 113 236 187 201 34 134 107 11 235 128 125 41 29 7 129 8 152 64 32 16 38 4 175 118 189 176 163 229 126 75 196 48 240 238 143 174 220 77 17 192 132 243 11 154 3 38 16 8 185 140 245 53 215 61 187 225 117 203 196 240 93 75 238 35 246 37 16 1 19 8 4 194 132 99 115 195 214 255 184 230 117 204 61 185 105 225 102 74 66 73 152 10 32 19 52 129 64 248 24 193 55 212 66 218 151 64 4 76 32 16 8 4 194 199 23 100 130 38 16 8 4 2 225 60 224 255 11 48 0 169 33 245 227 182 180 76 16 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: '<no timestamp>'!
mainPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 1 60 8 2 0 0 0 118 4 183 238 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 72 73 68 65 84 120 218 236 211 177 13 0 48 8 3 65 28 101 255 121 41 51 65 24 0 157 219 235 208 147 238 174 255 78 141 91 203 55 137 179 96 157 187 26 86 42 198 82 196 74 197 88 231 24 99 31 138 49 198 24 99 140 49 198 24 99 140 241 122 126 2 12 0 140 169 5 131 9 54 124 151 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: 'lr 10/31/2008 13:45'!
menuInnerPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 1 0 0 0 50 8 2 0 0 0 18 153 38 221 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 32 73 68 65 84 120 218 98 50 54 54 102 98 96 96 24 148 216 215 215 23 68 51 252 255 255 159 144 90 128 0 3 0 42 61 4 224 15 89 102 31 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
menuLeftPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 40 0 0 0 50 8 2 0 0 0 161 209 14 199 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 2 31 73 68 65 84 120 218 236 152 89 139 129 97 24 134 199 146 3 41 89 78 148 172 41 91 28 88 162 56 161 148 226 47 200 159 148 114 44 74 148 178 68 118 101 201 26 10 17 230 158 222 210 228 104 22 158 169 233 187 203 215 77 233 234 121 151 103 249 120 46 151 235 237 47 196 127 251 35 113 96 14 204 129 159 38 97 60 30 223 108 54 112 120 46 22 139 217 108 118 62 159 41 192 248 72 165 82 246 212 104 52 48 243 249 188 223 239 79 167 211 151 130 121 183 219 109 50 153 192 129 212 235 245 218 237 246 225 112 192 87 132 62 24 12 94 135 255 0 63 252 84 169 84 138 197 226 112 56 132 239 118 187 181 90 141 8 204 4 118 42 149 130 65 220 88 249 237 118 75 4 134 70 163 17 240 229 114 25 62 151 203 45 151 75 34 48 83 58 157 46 20 10 48 217 108 118 189 94 211 221 227 104 52 234 245 122 97 2 129 128 88 44 38 77 32 119 182 209 104 124 230 61 254 138 194 225 240 241 120 132 185 94 175 79 57 231 95 77 153 34 145 200 227 241 192 24 12 6 189 94 79 154 171 213 106 117 44 22 131 177 219 237 18 137 132 180 72 160 51 244 251 253 48 191 15 90 248 221 63 96 179 89 30 197 150 183 90 45 186 178 40 16 8 220 110 55 140 217 108 150 203 229 164 245 216 106 181 6 131 65 24 157 78 71 183 212 76 161 80 104 181 90 193 236 247 251 70 163 65 218 129 176 219 101 50 153 84 42 21 41 88 171 213 34 110 182 224 124 62 159 14 12 97 167 113 208 148 74 165 197 98 161 110 246 124 62 31 75 103 88 0 82 176 66 161 64 9 129 113 56 28 50 153 140 180 189 69 225 98 233 12 155 141 91 254 218 235 244 160 72 36 194 154 98 60 171 213 42 105 67 127 207 225 40 33 164 96 164 207 100 50 201 216 54 155 141 116 132 193 193 78 36 18 236 144 59 157 78 54 39 252 188 217 251 174 80 187 208 155 150 74 37 214 162 163 53 38 2 51 101 50 153 124 62 15 131 166 24 236 241 120 76 4 134 154 205 38 66 199 76 4 127 58 157 48 146 97 44 218 237 118 32 98 60 120 33 152 169 94 175 3 143 169 140 46 226 207 66 245 236 116 58 136 30 113 95 46 23 132 78 4 230 94 69 112 96 14 252 31 193 239 2 12 0 56 172 9 76 50 92 181 9 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
menuPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 1 0 0 0 50 8 2 0 0 0 18 153 38 221 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 31 73 68 65 84 120 218 98 48 54 54 102 98 96 96 192 139 125 125 125 65 52 195 255 255 255 7 43 6 8 48 0 155 170 118 32 171 104 194 177 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
menuRightPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 40 0 0 0 50 8 2 0 0 0 161 209 14 199 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 1 219 73 68 65 84 120 218 236 152 201 138 194 80 16 69 77 210 10 138 3 142 56 225 44 206 162 56 37 162 27 3 65 81 127 65 252 255 159 176 15 60 232 77 111 28 146 114 243 222 34 84 220 28 42 85 117 235 62 141 197 98 17 250 198 49 67 95 58 26 172 193 26 236 219 249 145 193 132 195 225 66 161 144 203 229 82 169 20 175 60 3 7 23 139 197 70 163 145 207 231 229 50 6 89 175 215 73 148 56 26 141 118 58 157 102 179 201 143 188 150 74 165 160 192 163 209 168 213 106 17 212 106 181 229 114 57 153 76 2 207 56 153 76 242 109 201 149 248 124 62 67 149 104 174 108 54 187 221 110 9 102 179 25 200 74 165 34 209 213 233 116 90 81 215 235 245 233 116 18 154 227 88 44 182 219 237 158 164 250 9 110 183 219 207 83 125 3 211 195 52 212 116 58 117 93 87 78 50 153 78 53 57 171 213 42 18 137 8 129 227 241 248 120 60 38 184 92 46 213 106 85 110 73 144 46 79 199 113 94 53 141 31 129 81 65 74 11 251 249 210 250 0 206 100 50 131 193 128 0 161 176 44 75 14 76 174 60 247 251 253 112 56 148 51 2 253 126 31 57 100 138 14 135 131 156 3 97 181 117 187 93 53 63 114 214 199 52 77 245 145 201 85 173 32 33 48 13 133 157 160 161 168 174 156 217 35 69 37 82 182 109 203 185 76 182 30 106 76 192 26 96 239 10 129 153 84 85 218 205 102 195 10 146 243 213 148 22 41 166 180 199 227 81 206 208 179 6 254 52 89 238 38 129 74 40 234 253 126 71 38 37 110 18 248 125 234 138 63 37 190 221 110 159 76 237 11 96 144 202 12 207 231 115 20 10 11 30 248 221 169 92 46 67 85 3 67 81 61 207 11 234 210 134 5 55 12 35 145 72 112 221 64 149 148 125 97 215 210 195 189 94 47 168 219 226 245 122 253 111 42 64 190 183 236 94 203 152 68 209 7 114 37 75 92 42 14 89 224 226 106 60 30 15 253 87 132 6 107 176 6 191 117 126 5 24 0 206 227 65 126 84 175 37 204 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: '<no timestamp>'!
printCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* print.css */
body {line-height:1.5;font-family:"Helvetica Neue", Helvetica, Arial, sans-serif;color:#000;background:none;font-size:10pt;}
.container {background:none;}
hr {background:#ccc;color:#ccc;width:100%;height:2px;margin:2em 0;padding:0;border:none;}
hr.space {background:#fff;color:#fff;}
h1, h2, h3, h4, h5, h6 {font-family:"Helvetica Neue", Arial, "Lucida Grande", sans-serif;}
code {font:.9em "Courier New", Monaco, Courier, monospace;}
img {float:left;margin:1.5em 1.5em 1.5em 0;}
a img {border:none;}
p img.top {margin-top:0;}
blockquote {margin:1.5em;padding:1em;font-style:italic;font-size:.9em;}
.small {font-size:.9em;}
.large {font-size:1.1em;}
.quiet {color:#999;}
.hide {display:none;}
a:link, a:visited {background:transparent;font-weight:700;text-decoration:underline;}
a:link:after, a:visited:after {content:" (" attr(href) ") ";font-size:90%;}'! !

!SKFileLibrary methodsFor: 'uploaded' stamp: 'AQ 9/26/2008 11:45'!
screenCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* reset.css */
html, body, div, span, object, iframe, h1, h2, h3, h4, h5, h6, p, blockquote, pre, a, abbr, acronym, address, code, del, dfn, em, img, q, dl, dt, dd, ol, ul, li, fieldset, form, label, legend, table, caption, tbody, tfoot, thead, tr, th, td {margin:0;padding:0;border:0;font-weight:inherit;font-style:inherit;font-size:100%;font-family:inherit;vertical-align:baseline;}
body {line-height:1.5;}
table {border-collapse:separate;border-spacing:0;}
caption, th, td {text-align:left;font-weight:normal;}
table, td, th {vertical-align:middle;}
blockquote:before, blockquote:after, q:before, q:after {content:"";}
blockquote, q {quotes:"" "";}
a img {border:none;}

/* typography.css */
body {font-size:75%;color:#222;background:#fff;font-family:"Helvetica Neue", Helvetica, Arial, sans-serif;}
h1, h2, h3, h4, h5, h6 {font-weight:normal;color:#111;}
h1 {font-size:3em;line-height:1;margin-bottom:0.5em;}
h2 {font-size:2em;margin-bottom:0.75em;}
h3 {font-size:1.5em;line-height:1;margin-bottom:1em;}
h4 {font-size:1.2em;line-height:1.25;margin-bottom:1.25em;height:1.25em;}
h5 {font-size:1em;font-weight:bold;margin-bottom:1.5em;}
h6 {font-size:1em;font-weight:bold; display: inline;}
h1 img, h2 img, h3 img, h4 img, h5 img, h6 img {margin:0;}
p {margin:0 0 1.5em;}
p img {float:left;margin:1.5em 1.5em 1.5em 0;padding:0;}
p img.right {float:right;margin:1.5em 0 1.5em 1.5em;}
a:focus, a:hover {color:#000;}
a {color:#009;text-decoration:underline;}
blockquote {margin:1.5em;color:#666;font-style:italic;}
strong {font-weight:bold;}
em, dfn {font-style:italic;}
dfn {font-weight:bold;}
sup, sub {line-height:0;}
abbr, acronym {border-bottom:1px dotted #666;}
address {margin:0 0 1.5em;font-style:italic;}
del {color:#666;}
pre, code {margin:1.5em 0;white-space:pre;}
pre, code, tt {font:1em ''andale mono'', ''lucida console'', monospace;line-height:1.5;}
li ul, li ol {margin:0 1.5em;}
ul, ol {margin:0 1.5em 1.5em 1.5em;}
ul {list-style-type:disc;}
ol {list-style-type:decimal;}
dl {margin:0 0 1.5em 0;}
dl dt {font-weight:bold;}
dd {margin-left:1.5em;}
table {margin-bottom:1.4em;width:100%;}
th {font-weight:bold;background:#C3D9FF;}
th, td {padding:4px 10px 4px 5px;}
tr.even td {background:#E5ECF9;}
tfoot {font-style:italic;}
caption {background:#eee;}
.small {font-size:.8em;margin-bottom:1.875em;line-height:1.875em;}
.large {font-size:1.2em;line-height:2.5em;margin-bottom:1.25em;}
.hide {display:none;}
.quiet {color:#666;}
.loud {color:#000;}
.highlight {background:#ff0;}
.added {background:#060;color:#fff;}
.removed {background:#900;color:#fff;}
.first {margin-left:0;padding-left:0;}
.last {margin-right:0;padding-right:0;}
.top {margin-top:0;padding-top:0;}
.bottom {margin-bottom:0;padding-bottom:0;}

/* grid.css */
.container {width:950px;margin:0 auto;}
.showgrid {background:url(src/grid.png);}
body {margin:1.5em 0;}
div.span-1, div.span-2, div.span-3, div.span-4, div.span-5, div.span-6, div.span-7, div.span-8, div.span-9, div.span-10, div.span-11, div.span-12, div.span-13, div.span-14, div.span-15, div.span-16, div.span-17, div.span-18, div.span-19, div.span-20, div.span-21, div.span-22, div.span-23, div.span-24 {float:left;margin-right:10px;}
div.last {margin-right:0;}
.span-1 {width:30px;}
.span-2 {width:70px;}
.span-3 {width:110px;}
.span-4 {width:150px;}
.span-5 {width:190px;}
.span-6 {width:230px;}
.span-7 {width:270px;}
.span-8 {width:310px;}
.span-9 {width:350px;}
.span-10 {width:390px;}
.span-11 {width:430px;}
.span-12 {width:470px;}
.span-13 {width:510px;}
.span-14 {width:550px;}
.span-15 {width:590px;}
.span-16 {width:630px;}
.span-17 {width:670px;}
.span-18 {width:710px;}
.span-19 {width:750px;}
.span-20 {width:790px;}
.span-21 {width:830px;}
.span-22 {width:870px;}
.span-23 {width:910px;}
.span-24, div.span-24 {width:950px;margin:0;}
.append-1 {padding-right:40px;}
.append-2 {padding-right:80px;}
.append-3 {padding-right:120px;}
.append-4 {padding-right:160px;}
.append-5 {padding-right:200px;}
.append-6 {padding-right:240px;}
.append-7 {padding-right:280px;}
.append-8 {padding-right:320px;}
.append-9 {padding-right:360px;}
.append-10 {padding-right:400px;}
.append-11 {padding-right:440px;}
.append-12 {padding-right:480px;}
.append-13 {padding-right:520px;}
.append-14 {padding-right:560px;}
.append-15 {padding-right:600px;}
.append-16 {padding-right:640px;}
.append-17 {padding-right:680px;}
.append-18 {padding-right:720px;}
.append-19 {padding-right:760px;}
.append-20 {padding-right:800px;}
.append-21 {padding-right:840px;}
.append-22 {padding-right:880px;}
.append-23 {padding-right:920px;}
.prepend-1 {padding-left:40px;}
.prepend-2 {padding-left:80px;}
.prepend-3 {padding-left:120px;}
.prepend-4 {padding-left:160px;}
.prepend-5 {padding-left:200px;}
.prepend-6 {padding-left:240px;}
.prepend-7 {padding-left:280px;}
.prepend-8 {padding-left:320px;}
.prepend-9 {padding-left:360px;}
.prepend-10 {padding-left:400px;}
.prepend-11 {padding-left:440px;}
.prepend-12 {padding-left:480px;}
.prepend-13 {padding-left:520px;}
.prepend-14 {padding-left:560px;}
.prepend-15 {padding-left:600px;}
.prepend-16 {padding-left:640px;}
.prepend-17 {padding-left:680px;}
.prepend-18 {padding-left:720px;}
.prepend-19 {padding-left:760px;}
.prepend-20 {padding-left:800px;}
.prepend-21 {padding-left:840px;}
.prepend-22 {padding-left:880px;}
.prepend-23 {padding-left:920px;}
div.border {padding-right:4px;margin-right:5px;border-right:1px solid #eee;}
div.colborder {padding-right:24px;margin-right:25px;border-right:1px solid #eee;}
.pull-1 {margin-left:-40px;}
.pull-2 {margin-left:-80px;}
.pull-3 {margin-left:-120px;}
.pull-4 {margin-left:-160px;}
.pull-5 {margin-left:-200px;}
.pull-6 {margin-left:-240px;}
.pull-7 {margin-left:-280px;}
.pull-8 {margin-left:-320px;}
.pull-9 {margin-left:-360px;}
.pull-10 {margin-left:-400px;}
.pull-11 {margin-left:-440px;}
.pull-12 {margin-left:-480px;}
.pull-13 {margin-left:-520px;}
.pull-14 {margin-left:-560px;}
.pull-15 {margin-left:-600px;}
.pull-16 {margin-left:-640px;}
.pull-17 {margin-left:-680px;}
.pull-18 {margin-left:-720px;}
.pull-19 {margin-left:-760px;}
.pull-20 {margin-left:-800px;}
.pull-21 {margin-left:-840px;}
.pull-22 {margin-left:-880px;}
.pull-23 {margin-left:-920px;}
.pull-24 {margin-left:-960px;}
.pull-1, .pull-2, .pull-3, .pull-4, .pull-5, .pull-6, .pull-7, .pull-8, .pull-9, .pull-10, .pull-11, .pull-12, .pull-13, .pull-14, .pull-15, .pull-16, .pull-17, .pull-18, .pull-19, .pull-20, .pull-21, .pull-22, .pull-23, .pull-24 {float:left;position:relative;}
.push-1 {margin:0 -40px 1.5em 40px;}
.push-2 {margin:0 -80px 1.5em 80px;}
.push-3 {margin:0 -120px 1.5em 120px;}
.push-4 {margin:0 -160px 1.5em 160px;}
.push-5 {margin:0 -200px 1.5em 200px;}
.push-6 {margin:0 -240px 1.5em 240px;}
.push-7 {margin:0 -280px 1.5em 280px;}
.push-8 {margin:0 -320px 1.5em 320px;}
.push-9 {margin:0 -360px 1.5em 360px;}
.push-10 {margin:0 -400px 1.5em 400px;}
.push-11 {margin:0 -440px 1.5em 440px;}
.push-12 {margin:0 -480px 1.5em 480px;}
.push-13 {margin:0 -520px 1.5em 520px;}
.push-14 {margin:0 -560px 1.5em 560px;}
.push-15 {margin:0 -600px 1.5em 600px;}
.push-16 {margin:0 -640px 1.5em 640px;}
.push-17 {margin:0 -680px 1.5em 680px;}
.push-18 {margin:0 -720px 1.5em 720px;}
.push-19 {margin:0 -760px 1.5em 760px;}
.push-20 {margin:0 -800px 1.5em 800px;}
.push-21 {margin:0 -840px 1.5em 840px;}
.push-22 {margin:0 -880px 1.5em 880px;}
.push-23 {margin:0 -920px 1.5em 920px;}
.push-24 {margin:0 -960px 1.5em 960px;}
.push-1, .push-2, .push-3, .push-4, .push-5, .push-6, .push-7, .push-8, .push-9, .push-10, .push-11, .push-12, .push-13, .push-14, .push-15, .push-16, .push-17, .push-18, .push-19, .push-20, .push-21, .push-22, .push-23, .push-24 {float:right;position:relative;}
.box {padding:1.5em;margin-bottom:1.5em;background:#E5ECF9;}
hr {background:#ddd;color:#ddd;clear:both;float:none;width:100%;height:.1em;margin:0 0 1.45em;border:none;}
hr.space {background:#fff;color:#fff;}
.clearfix:after, .container:after {content:".";display:block;height:0;clear:both;visibility:hidden;}
.clearfix, .container {display:inline-block;}
* html .clearfix, * html .container {height:1%;}
.clearfix, .container {display:block;}
.clear {clear:both;}

/* forms.css */
label {font-weight:bold;}
fieldset {padding:1.4em;margin:0 0 1.5em 0;border:1px solid #ccc;}
legend {font-weight:bold;font-size:1.2em;}
input.text, input.title, textarea, select {margin:0.5em 0;border:1px solid #bbb;}
input.text:focus, input.title:focus, textarea:focus, select:focus {border:1px solid #666;}
input.text, input.title {width:300px;padding:5px;}
input.title {font-size:1.5em;}
textarea {width:390px;height:250px;padding:5px;}
.error, .notice, .success {padding:.8em;margin-bottom:1em;border:2px solid #ddd;}
.error {background:#FBE3E4;color:#8a1f11;border-color:#FBC2C4;}
.notice {background:#FFF6BF;color:#514721;border-color:#FFD324;}
.success {background:#E6EFC2;color:#264409;border-color:#C6D880;}
.error a {color:#8a1f11;}
.notice a {color:#514721;}
.success a {color:#264409;}'! !

!SKFileLibrary methodsFor: 'processing' stamp: 'lr 9/26/2008 14:47'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot stylesheet
		addScreen;
		addProjection;
		url: (self urlOf: #screenCss).
	aHtmlRoot stylesheet
		addPrint;
		url: (self urlOf: #printCss).
	aHtmlRoot if ie do: [
		aHtmlRoot stylesheet
			addScreen;
			addProjection;
			url: (self urlOf: #ieCss) ].
	aHtmlRoot stylesheet
		url: (self urlOf: #defaultCss).! !

MDEmptyMessage subclass: #MDGetRepositories
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDGetRepositories class methodsFor: 'reading' stamp: 'lr 11/6/2008 11:07'!
id
	^ 69! !

!MDGetRepositories methodsFor: 'dispatch' stamp: 'lr 11/6/2008 11:05'!
handledBy: anObject
	^ anObject handleGetRepositories: self! !

WAComponent subclass: #SKComponent
	instanceVariableNames: 'parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKComponent subclass: #SKCodeBrowserView
	instanceVariableNames: 'repository memo selectedClass selectedMethod selectedPackage selectedCategory categories packages methods allMethods classIsMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKCodeBrowserView class
	instanceVariableNames: 'repository categories packages versions selectedClass'!

SKCodeBrowserView class
	instanceVariableNames: 'repository categories packages versions selectedClass'!

!SKCodeBrowserView methodsFor: 'querying-class-side' stamp: 'AQ 11/5/2008 15:01'!
allClassMethods
	selectedClass ifNil: [ ^ Set new ].
	^ self versions select: [ :each | (each element isKindOf: MDMethodElement) and: [each element classIsMeta ] and: [each element theClassName = selectedClass element theClassName ]]! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'AQ 11/4/2008 11:08'!
allClasses
	^ self versions select: [ :each | (each element isKindOf: MDClassElement)]! !

!SKCodeBrowserView methodsFor: 'querying-instance-side' stamp: 'AQ 11/5/2008 13:31'!
allInstanceMethods
	selectedClass ifNil: [ ^ Set new ].
	^ self versions select: [ :each | (each element isKindOf: MDMethodElement) and: [each element classIsMeta not] and: [each element theClassName = selectedClass element theClassName ]]! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'AQ 11/5/2008 13:58'!
allMethods
	self classIsMeta
		ifFalse: [ ^ self allInstanceMethods ]
		ifTrue: [ ^ self allClassMethods].! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'AQ 11/4/2008 11:09'!
categories
	^ categories ifNil: [ 
		categories := self allClasses
			collect: [ :each | each variant properties at: #category ].
		categories := categories asArray sort ]! !

!SKCodeBrowserView methodsFor: 'actions' stamp: 'AQ 11/5/2008 15:20'!
changeView
	classIsMeta := classIsMeta not.
	selectedPackage := nil.
	selectedMethod := nil.! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 11/5/2008 13:58'!
classIsMeta
	^ classIsMeta.! !

!SKCodeBrowserView methodsFor: 'querying-class-side' stamp: 'AQ 11/5/2008 12:33'!
classMethods
	selectedClass ifNil: [ ^ Set new ].
	^ self versions select: [ :each | (each element isKindOf: MDMethodElement) and: [each element theClassName = selectedClass element theClassName] and: [(each variant properties at: #category) = self selectedPackage] and: [each element classIsMeta]].! !

!SKCodeBrowserView methodsFor: 'querying-class-side' stamp: 'AQ 11/5/2008 15:26'!
classPackages
	| helper |
	helper := self allClassMethods collect: [:each | each variant properties at: #category].
	helper ifEmpty: [ ^ #('no messages') ].
	helper add: 'all'.
	^ helper! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'AQ 11/4/2008 11:18'!
classes
	self selectedCategory ifNil: [ ^ Set new ].
	^ self allClasses select: [ :each | (each variant properties at: #category) = self selectedCategory].! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'lr 10/3/2008 11:52'!
elements
	^ self versions collect: [ :each | each element ]! !

!SKCodeBrowserView methodsFor: 'initialization' stamp: 'AQ 11/5/2008 15:02'!
initialize
	super initialize.
	classIsMeta := false.! !

!SKCodeBrowserView methodsFor: 'querying-instance-side' stamp: 'AQ 11/5/2008 13:31'!
instanceMethods
	selectedClass ifNil: [ ^ Set new ].
	^ self versions select: [ :each | (each element isKindOf: MDMethodElement) and: [each element theClassName = selectedClass element theClassName] and: [(each variant properties at: #category) = self selectedPackage] and: [each element classIsMeta not]].! !

!SKCodeBrowserView methodsFor: 'querying-instance-side' stamp: 'AQ 11/5/2008 14:58'!
instancePackages
	| helper |
	helper := self allInstanceMethods collect: [:each | each variant properties at: #category].
	helper ifEmpty: [ ^ #('no messages') ].
	helper add: 'all'.
	^ helper! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
memo
	^ memo! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
memo: anObject
	memo := anObject! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'AQ 11/5/2008 13:59'!
methods
	self classIsMeta
		ifFalse: [ ^ self instanceMethods ]
		ifTrue: [ ^ self classMethods ].! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'AQ 11/5/2008 13:59'!
packages
	self classIsMeta
		ifFalse: [ ^ self instancePackages ]
		ifTrue: [ ^ self classPackages ].! !

!SKCodeBrowserView methodsFor: 'rendering' stamp: 'AQ 11/5/2008 15:24'!
renderContentOn: html 
	html heading: self memo name.
	html form: [ html div class: 'browse'; with: [
			html select on: #selectedCategory of: self; list: self categories; size: 10; beSubmitOnChange.
			html select on: #selectedClass of: self; list: self classes; size: 10; beSubmitOnChange;
				labels: [ :each | each element theClassName ].
			html select on: #selectedPackage of: self; list: self packages; size: 10; beSubmitOnChange.
			(self selectedPackage = 'all')
				ifTrue: [
					html select on: #selectedMethod of: self; list: self allMethods; size: 10; beSubmitOnChange;
						labels: [ :each | each element selector ]]
				ifFalse: [
					html select on: #selectedMethod of: self; list: self methods; size: 10; beSubmitOnChange; 
						labels: [ :each | each element selector ]]].
	html submitButton
		text: 'Instance';
		callback: [self changeView].
	html submitButton
		text: 'Class';
		callback: [self changeView].
	self renderSourceOn: html. ]! !

!SKCodeBrowserView methodsFor: 'rendering' stamp: 'AQ 11/5/2008 15:18'!
renderSourceOn: html 
	html break; break.
	selectedMethod isNil ifFalse: [ html code: (selectedMethod variant properties at: #source) ]! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
repository
	^ repository! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
repository: anObject
	repository := anObject! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/10/2008 11:29'!
selectedCategory
	^ selectedCategory! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/26/2008 14:06'!
selectedCategory: aString
	selectedCategory := aString.
	self selectedClass: nil.
	self selectedPackage: nil.
	self selectedMethod: nil.! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 20:17'!
selectedClass
	^ selectedClass! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 11/5/2008 15:22'!
selectedClass: aMDClassElement
	selectedClass := aMDClassElement.
	self selectedPackage: nil.
	self selectedMethod: nil.! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/9/2008 21:10'!
selectedMethod
	^ selectedMethod! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 16:39'!
selectedMethod: aMDMethodElement
	selectedMethod := aMDMethodElement! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/11/2008 19:59'!
selectedPackage
	^ selectedPackage! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/26/2008 14:13'!
selectedPackage: aString
	selectedPackage := aString.
	self selectedMethod: nil.! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'lr 10/3/2008 11:48'!
snapshot
	^ self repository get: self memo reference! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'lr 10/3/2008 11:50'!
versions
	^ self snapshot getVersionsFrom: self repository! !

!SKComponent class methodsFor: 'instance creation' stamp: 'AQ 9/2/2008 01:39'!
on: aComponent
	^ self new initializeOn: aComponent! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/3/2008 14:32'!
editGroup: aGroup
	(self viewGroup: aGroup) edit! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/3/2008 14:31'!
editProject: aProject
	(self viewProject: aProject) edit! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/1/2008 17:16'!
editRoot
	self root content 
		call: (self s2root asComponent
			addValidatedForm;
			addMessage: 'Edit Root';
			yourself)! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/3/2008 14:30'!
editUser: aUser
	(self viewUser: aUser) edit! !

!SKComponent methodsFor: 'initialization' stamp: 'lr 10/31/2008 15:09'!
initializeOn: aComponent 
	parent := aComponent! !

!SKComponent methodsFor: 'accessing' stamp: 'lr 10/31/2008 15:09'!
parent
	^ parent! !

!SKComponent methodsFor: 'rendering' stamp: 'lr 11/3/2008 14:28'!
renderGroup: aGroup on: html
	html anchor
		callback: [ self viewGroup: aGroup ];
		with: aGroup title.
	(aGroup isEditableBy: self session user) ifTrue: [
		html space.
		html anchor
			callback: [ self editGroup: aGroup ];
			with: [ html image url: (SKFileLibrary urlOf: #editPng) ] ]! !

!SKComponent methodsFor: 'rendering' stamp: 'lr 10/31/2008 16:08'!
renderGroups: aCollection on: html
	aCollection 
		do: [ :each | self renderGroup: each on: html ]
		separatedBy: [ html text: ', ' ]! !

!SKComponent methodsFor: 'rendering' stamp: 'lr 11/3/2008 14:28'!
renderProject: aProject on: html
	html anchor
		callback: [ self viewProject: aProject ];
		with: aProject title.
	(aProject isEditableBy: self session user) ifTrue: [
		html space.
		html anchor
			callback: [ self editProject: aProject ];
			with: [ html image url: (SKFileLibrary urlOf: #editPng) ] ]! !

!SKComponent methodsFor: 'rendering' stamp: 'lr 10/31/2008 16:09'!
renderProjects: aCollection on: html
	aCollection 
		do: [ :each | self renderProject: each on: html ]
		separatedBy: [ html text: ', ' ]! !

!SKComponent methodsFor: 'rendering' stamp: 'lr 11/3/2008 14:28'!
renderUser: aUser on: html
	aUser isGuest
		ifTrue: [ html text: aUser title ]
		ifFalse: [
			html anchor
				callback: [ self viewUser: aUser ];
				with: aUser title.
			(aUser isEditableBy: self session user) ifTrue: [
				html space.
				html anchor
					callback: [ self editUser: aUser ];
					with: [ html image url: (SKFileLibrary urlOf: #editPng) ] ] ]! !

!SKComponent methodsFor: 'rendering' stamp: 'lr 10/31/2008 16:09'!
renderUsers: aCollection on: html
	aCollection 
		do: [ :each | self renderUser: each on: html ]
		separatedBy: [ html text: ', ' ]! !

!SKComponent methodsFor: 'accessing' stamp: 'lr 10/31/2008 15:09'!
root
	^ parent root! !

!SKComponent methodsFor: 'accessing' stamp: 'lr 10/31/2008 14:06'!
url
	"Answer the repository url for the Sourcetalk server."
	
	^ self application baseUrl takeServerParametersFromRequest: self session currentRequest! !

!SKComponent methodsFor: 'accessing' stamp: 'AQ 9/2/2008 01:37'!
user
	^ self session user! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/3/2008 14:31'!
viewGroup: aGroup 
	| view |
	self viewGroups.
	view := SKGroupView on: self.
	view group: aGroup.
	self root content show: view.
	^ view! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/1/2008 17:23'!
viewGroups
	self root content: (SKGroupsView on: self)! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/3/2008 14:31'!
viewProject: aProject
	| view |
	self viewProjects.
	view:= SKProjectView on: self.
	view project: aProject.
	self root content show: view.
	^ view! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/1/2008 17:23'!
viewProjects
	self root content: (SKProjectsView on: self)! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/1/2008 17:18'!
viewRoot
	self root welcome! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/3/2008 14:30'!
viewUser: aUser
	| view |
	self viewUsers.
	view := SKUserView on: self.
	view viewedUser: aUser.
	self root content show: view.
	^ view! !

!SKComponent methodsFor: 'actions' stamp: 'lr 11/1/2008 17:23'!
viewUsers
	self root content: (SKUsersView on: self)! !

SKComponent subclass: #SKLoginView
	instanceVariableNames: 'email password message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKLoginView methodsFor: 'actions' stamp: 'lr 11/1/2008 11:08'!
alert: aString
	"Shows an alert message after rendering the next page."
	
	self session addLoadScript: (SUScript new alert: aString)! !

!SKLoginView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:00'!
editAccount
	| user description component |
	user := self session user.
	description := user description
		reject: [ :each | each onlySuperuser and: [ self user isSuperuser not ] ].
	component := description asComponentOn: user.
	user := self root content call: (component
			addValidatedForm;
			addMessage: 'Edit Account';
			yourself).! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 21:42'!
email
	^ email! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 21:42'!
email: aString
	email := aString! !

!SKLoginView methodsFor: 'actions' stamp: 'lr 11/1/2008 11:01'!
forgotPassword
	| user url |
	user := self s2root userByEMail: self email.
	user isNil 
		ifTrue: [ ^ self alert: 'The e-mail ' , self email printString , ' does not belong to a registered user.' ].
	user isSuperuser 
		ifTrue: [ ^ self alert: 'Superusers shoud never forget their password.' ].
	Continuation currentDo: [ :cc | 
		url := self session actionUrlForContinuation: cc.
		[ self sendMailTo: user url: url ] 
			on: Exception
			do: [ :error | ^ self alert: error messageText , '. Please contact the site-administrator.' ].
		^ self alert: 'An e-mail has been successfully sent to you.' ].
	self viewUser: user! !

!SKLoginView methodsFor: 'actions' stamp: 'lr 11/1/2008 11:01'!
loginUser
	| user |
	user := self s2root userByEMail: self email.
	(user notNil and: [ user verifyPassword: self password ])
		ifTrue: [ self session user: user ]
		ifFalse: [ self logoutUser; alert: 'Invalid username or password.' ]! !

!SKLoginView methodsFor: 'actions' stamp: 'lr 11/1/2008 11:56'!
logoutUser
	self root welcome.
	self session logout! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 8/17/2008 16:28'!
password
	^ password! !

!SKLoginView methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:44'!
password: aString 
	password := aString! !

!SKLoginView methodsFor: 'actions' stamp: 'lr 11/1/2008 11:39'!
registerUser
	| user |
	(self email isNil or: [ self email isEmpty or: [ ('#*@#*.#*' match: self email) not ] ])
		ifTrue: [ ^ self alert: 'Invalid e-mail given.' ].
	(self password isNil or: [ self password isEmpty ])
		ifTrue: [ ^ self alert: 'Invalid password given.' ].
	user := self s2root userByEMail: self email.
	user isNil 
		ifFalse: [ ^ self alert: 'A user with this e-mail address already exists.' ].
	user := SKUser new.
	user email: self email.
	user password: self password.
	self s2root addUser: user.
	self session user: user.
	self viewUser: user.
	self alert: 'You have successfully registered to ' , self s2root title , '.'! !

!SKLoginView methodsFor: 'rendering' stamp: 'lr 11/1/2008 12:13'!
renderBody: aString on: html
	html div id: aString; class: 'body'; style: 'display: none'; with: [
		self session user isGuest
			ifTrue: [ self renderFormOn: html ] ]! !

!SKLoginView methodsFor: 'rendering' stamp: 'lr 11/1/2008 12:28'!
renderBottom: aString on: html
	html div class: 'bottom'; with: [
		html div class: 'tab'; with: [
			html div class: 'left'.
			html div class: 'inner'; with: [
				self renderUser: self session user on: html.
				html text: ' | '.
				self session user isGuest 
					ifTrue: [ 
						html anchor
							accessKey: $l;
							onClick: (html effect
								id: aString; 
								toggleSlide;
								onAfterFinish: (html formElement
									id: 'email';
									focus));
							with: 'Log In / Register' ]
					ifFalse: [
						html anchor
							callback: [ self logoutUser ];
							with: 'Log Out' ] ].
			html div class: 'right' ] ]
		
	! !

!SKLoginView methodsFor: 'rendering' stamp: 'lr 11/1/2008 10:38'!
renderContentOn: html
	| id |
	id := html nextId.
	self renderBody: id on: html.
	self renderBottom: id on: html.
			
		
	! !

!SKLoginView methodsFor: 'rendering' stamp: 'lr 11/1/2008 11:53'!
renderFormOn: html
	html form defaultAction: [ self loginUser ]; with: [
		html table: [
			html tableRow: [
				html tableHeading: 'Email: '.
				html tableData: [
					html textInput
						id: 'email';
						callback: [ :value | email := value ] ] ].
			html tableRow: [
				html tableHeading: 'Password: '.
				html tableData: [
					html passwordInput
						id: 'password';
						callback: [ :value | password := value ] ].
			html tableRow: [
				html tableHeading.
				html tableData class: 'buttons'; with: [
					html submitButton
						callback: [ self loginUser ];
						text: 'Log In'.
					html submitButton
						callback: [ self registerUser ];
						text: 'Register User'.
					html submitButton
						callback: [ self forgotPassword ];
						text: 'Forgot Password' ] ] ] ] ]! !

!SKLoginView methodsFor: 'actions' stamp: 'lr 11/1/2008 10:55'!
sendMailTo: aUser url: aUrl
	SMTPClient
		deliverMailFrom: self s2root noReplyMail
		to: (Array with: aUser email)
		text: (String streamContents: [ :stream |
			stream nextPutAll: 'From: '; nextPutAll: self s2root noReplyMail; crlf.
			stream nextPutAll: 'To: '; nextPutAll: aUser email; crlf.
			stream nextPutAll: 'Subject: Forgot password'; crlf.
			stream crlf.
			stream nextPutAll: 'Hi '; nextPutAll: aUser title; nextPutAll: ',

we received a request (presumeably by you) that you forgot your password. To log into your account and to change your password please visit the link below:

	'; print: aUrl; nextPutAll: '
	
If you didn''t sent this request, please forget about this mail. Your account-information won''t be changed and you will be able to access your account with your old password.'; crlf ])
		usingServer: self s2root smtpServer.! !

SKComponent subclass: #SKMenuComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKMenuComponent methodsFor: 'accessing' stamp: 'lr 11/1/2008 17:22'!
classes
	^ Array with: SKProjectsView with: SKUsersView with: SKGroupsView with: SKSearchView ! !

!SKMenuComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:12'!
renderContentOn: html 
	self classes do: [ :each | 	self renderTab: each on: html ]! !

!SKMenuComponent methodsFor: 'rendering' stamp: 'lr 10/31/2008 15:11'!
renderTab: aClass on: html 
	html div
		class: 'span-6';
		class: 'last' if: self classes last = aClass;	
		class: 'active' if: self root content class = aClass;
		with: [ 
			html anchor
				callback: [ self root content: (aClass on: self root) ];
				with: aClass label ]! !

SKComponent subclass: #SKModelComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKModelComponent subclass: #SKGroupView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKGroupView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:26'!
addAdmin
	| view users |
	view := SKSelectUserView new.
	view title: 'Add Admins'.
	view list: (self s2root users reject: [ :each | self group admins includes: each ]).
	users := self call: view.
	users do: [ :user | self group addAdmin: user ]! !

!SKGroupView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:42'!
addUser
	| view users |
	view := SKSelectUserView new.
	view title: 'Add User'.
	view list: (self s2root users reject: 
			[ :each | 
			(self group admins includes: each) or: [ self group users includes: each ] ]).
	users := self call: view.
	users do: [ :user | self group addUser: user ]! !

!SKGroupView methodsFor: 'actions' stamp: 'AQ 11/4/2008 10:54'!
delete: aGroup
	self s2root removeGroup: aGroup.
	self root welcome! !

!SKGroupView methodsFor: 'editing' stamp: 'AQ 9/2/2008 19:18'!
edit
	self call: (group asComponent addValidatedForm; addMessage: 'Edit Group'; yourself)! !

!SKGroupView methodsFor: 'accessing' stamp: 'AQ 9/2/2008 18:26'!
group
	^ group! !

!SKGroupView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:40'!
group: aGroup 
	group := aGroup! !

!SKGroupView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:29'!
removeAdmin
	| view users |
	view := SKSelectUserView new.
	view title: 'Remove Admins'.
	view list: self group admins.
	users := self call: view.
	users do: [ :user | self group removeAdmin: user ]! !

!SKGroupView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:39'!
removeUser
	| view users |
	view := SKSelectUserView new.
	view title: 'Remove User'.
	view list: self group users.
	users := self call: view.
	users do: [ :user | self group removeUser: user ]! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/31/2008 12:32'!
renderActionsOn: html 
	html
		break;
		break.
	(self group isEditableBy: self session user) ifFalse: [ ^ self ].
	html anchor
		callback: [ self edit ];
		with: 'Edit'.
	html break.
	html anchor
		onClick: 'return confirm("Really delete', self group title, '?")';
		callback: [ self delete: group ];
		with: 'Delete'.! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:54'!
renderContentOn: html 
	html heading: group title , ' Group'.
	self renderWikiOn: html.
	self renderMembersOn: html.
	self renderActionsOn: html! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/26/2008 14:20'!
renderEditAdminsOn: html 
	html text: ' ('.
	html anchor
		callback: [ self addAdmin ];
		with: 'Add'.
	html text: ' / '.
	html anchor
		callback: [ self removeAdmin ];
		with: 'Remove'.
	html text: ')'! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/26/2008 14:39'!
renderEditUserOn: html 
	html text: ' ('.
	html anchor
		callback: [ self addUser ];
		with: 'Add'.
	html text: ' / '.
	html anchor
		callback: [ self removeUser ];
		with: 'Remove'.
	html text: ')'! !

!SKGroupView methodsFor: 'rendering' stamp: 'lr 11/1/2008 17:29'!
renderGroupAdminsOn: html 
	html break.
	html text: 'Admins: '.
	self renderUsers: self group admins on: html.
	(self group isEditableBy: self session user) ifFalse: [ ^ self ].
	self renderEditAdminsOn: html.! !

!SKGroupView methodsFor: 'rendering' stamp: 'lr 11/1/2008 17:29'!
renderGroupCreatorOn: html 
	html
		break;
		break.
	html text: 'Creator: '.
	self renderUser: self group creator on: html! !

!SKGroupView methodsFor: 'rendering' stamp: 'lr 11/1/2008 17:29'!
renderGroupUsersOn: html
	html break.
	html text: 'Members:'.
	self renderUsers: self group users on: html.
	(self group isEditableBy: self session user) ifFalse: [ ^ self ].
	self renderEditUserOn: html.! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:54'!
renderMembersOn: html 
	html text: 'Members'.
	self renderGroupCreatorOn: html.
	self renderGroupAdminsOn: html.
	self renderGroupUsersOn: html! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:17'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self group wiki
		in: self
		on: html! !

!SKModelComponent methodsFor: 'editing' stamp: 'AQ 10/30/2008 20:08'!
delete: aEntry
	self subclassResponsibility.! !

!SKModelComponent methodsFor: 'editing' stamp: 'AQ 10/30/2008 20:07'!
edit
	self subclassResponsibility.! !

!SKModelComponent methodsFor: 'rendering' stamp: 'AQ 10/30/2008 20:10'!
renderWikiOn: html
	self subclassResponsibility.! !

SKModelComponent subclass: #SKProjectView
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKProjectView class
	instanceVariableNames: 'project'!

SKProjectView class
	instanceVariableNames: 'project'!

!SKProjectView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:25'!
addAdmin
	| view users |
	view := SKSelectUserView new.
	view title: 'Add Admins'.
	view list: (self s2root users reject: [ :each | self project admins includes: each ]).
	users := self call: view.
	users do: [ :user | self project addAdmin: user ]! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:25'!
addDeveloper
	| view users |
	view := SKSelectUserView new.
	view title: 'Add Developers'.
	view list: (self s2root users reject: 
			[ :each | 
			(self project admins includes: each) or: [ self project developers includes: each ] ]).
	users := self call: view.
	users do: [ :user | self project addDeveloper: user ]! !

!SKProjectView methodsFor: 'actions' stamp: 'lr 10/3/2008 11:32'!
browse: aRepository with: aMemo
	| view |
	view := SKCodeBrowserView new.
	view repository: aRepository; memo: aMemo.
	self call: view; on: self root content.! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 11/4/2008 10:57'!
delete: aProject 
	self s2root removeProject: aProject.
	self root welcome.! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 10/24/2008 13:37'!
downloadVersion: aMemo
	| response exporter |
	response := WAResponse new.
	response contentType: 'application/smalltalk'.
	response attachmentWithFileName: aMemo name , '.st'.
	exporter := MDFileOutExporter on: response stream.
	exporter export: aMemo from: self project repository.
	self project addADownload.
	self session returnResponse: response.! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 10/24/2008 17:50'!
edit
	self call: (self project asComponent addValidatedForm; addMessage: 'Edit Project'; yourself)! !

!SKProjectView methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:41'!
project
	^ project! !

!SKProjectView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:43'!
project: aProject 
	project := aProject! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:30'!
removeAdmin
	| view users |
	view := SKSelectUserView new.
	view title: 'Remove Admins'.
	view list: self project admins.
	users := self call: view.
	users do: [ :user | self project removeAdmin: user ]! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 10/26/2008 14:30'!
removeDeveloper
	| view users |
	view := SKSelectUserView new.
	view title: 'Remove Developer'.
	view list: self project developers.
	users := self call: view.
	users do: [ :user | self project removeDeveloper: user ]! !

!SKProjectView methodsFor: 'rendering' stamp: 'lr 10/24/2008 14:36'!
renderActionsOn: html 
	html
		break;
		break.
	(self project isEditableBy: self session user) ifFalse: [ ^ self ].
	html anchor
		callback: [ self edit ];
		with: 'Edit Project'.
	html break.
	html anchor
		onClick: 'return confirm("Really delete ''' , self project title , '''")';
		callback: [ self delete: self project ];
		with: 'Delete'! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:27'!
renderAdminsOn: html 
	html break.
	html text: 'Admins: '.
	project admins do: [ :admin | html text: admin title , ', ' ].
	(project isEditableBy: self session user) ifFalse: [ ^ self ].
	self renderEditAdminsOn: html! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:16'!
renderContentOn: html 
	html heading
		level: 2;
		with: 'Project ' , project title.
	self renderWikiOn: html.
	self renderCreatorOn: html.
	self renderAdminsOn: html.
	self renderDeveloperOn: html.
	self renderRegistrationOn: html.
	self renderVersionsOn: html.
	self renderStatisticsOn: html.
	self renderActionsOn: html! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:16'!
renderCreatorOn: html 
	html heading
		level: 3;
		with: 'Members'.
	html text: 'Creator:'.
	html
		text: ' ';
		text: project creator! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/26/2008 14:41'!
renderDeveloperOn: html 
	html break.
	html text: 'Developers:'.
	project developers do: 
		[ :developer | 
		html text: ' ';
			text: developer title ].
	(project isEditableBy: self session user) ifFalse: [ ^ self ].
	self renderEditDeveloperOn: html.! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:27'!
renderEditAdminsOn: html 
	html text: ' ('.
	html anchor
		callback: [ self addAdmin ];
		with: 'Add'.
	html text: ' / '.
	html anchor
		callback: [ self removeAdmin ];
		with: 'Remove'.
	html text: ')'! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:27'!
renderEditDeveloperOn: html 
	html text: ' ('.
	html anchor
		callback: [ self addDeveloper ];
		with: 'Add'.
	html text: ' / '.
	html anchor
		callback: [ self removeDeveloper ];
		with: 'Remove'.
	html text: ')'! !

!SKProjectView methodsFor: 'rendering' stamp: 'lr 11/6/2008 11:48'!
renderRegistrationOn: html 
	html break; break.
	html heading
		level: 3;
		with: 'Sourcetalk Template'.
	html code: (MDSourcetalkRepository name , '
		url: ' , self url printString printString , '
		project: ' , self project title printString , '
		email: ' , (self session user isGuest
			ifTrue: [ String new printString ]
			ifFalse: [ self session user email ]) , '
		password: ' , String new printString)! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/24/2008 12:48'!
renderStatisticsOn: html 
	html heading
		level: 3;
		with: 'Statistics'.
	html text: 'Registerd: '.
	html text: self project timestamp.
	html break.
	html text: 'Total Versions: '.
	html text: (self project repository memos count: [ :each | true ]).
	html break.
	html text: 'Total Downloads: '.
	html text: self project downloads.! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/24/2008 18:20'!
renderVersionTableDataOn: html 
	^ 
	[ :index :memo |
	| email user | 
	email := (memo properties author
		copyAfter: $<) copyUpTo: $>.
	user := self s2root userByEMail: email.
	html tableRow
		class: 'even'
			if: index even;
		with: 
			[ html
				tableData: 
					[ html anchor
						callback: 
							[ self 
								browse: self project repository
								with: memo ];
						with: memo name ].
				user isNil ifFalse: [ html tableData:  user title]
					ifTrue: [ html tableData: ''].
				html tableData: memo timestamp asString;
				tableData: memo properties comment;
				tableData: [ html anchor callback: [self downloadVersion: memo]; with: 'download' ]]]! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/31/2008 10:29'!
renderVersionsOn: html
	html
		break;
		break.
	html heading
		level: 3;
		with: 'Versions'.
	html table: 
		[ self renderVersionsTableHeadOn: html.
		self project repository memos asSortedCollection keysAndValuesDo: (self renderVersionTableDataOn: html) ]! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/20/2008 10:30'!
renderVersionsTableHeadOn: html 
	html tableHead: 
		[ html
			tableHeading: 'Filename';
			tableHeading: 'Author';
			tableHeading: 'Timestamp';
			tableHeading: 'Comments';
			tableHeading: 'Download' ]! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:08'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self project wiki
		in: self
		on: html! !

!SKProjectView methodsFor: 'updating' stamp: 'lr 10/31/2008 14:32'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot link
		beRss; 
		beAlternate;
		title: self project title;
		url: (self url with: '/projects/' , self project id asString , '.rss').! !

!SKProjectView methodsFor: 'updating' stamp: 'lr 10/20/2008 14:57'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'projects'; addToPath: self project id asString! !

SKModelComponent subclass: #SKUserView
	instanceVariableNames: 'viewedUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKUserView methodsFor: 'actions' stamp: 'lr 11/1/2008 17:30'!
delete: aUser
	self s2root removeUser: aUser.
	aUser = self session user
		ifTrue: [ self session logout ].
	self root welcome! !

!SKUserView methodsFor: 'actions' stamp: 'AQ 10/4/2008 14:09'!
edit
	| user description component |
	user := viewedUser.
	description := user description
		reject: [ :each | each onlySuperuser and: [ self user isSuperuser not ] ].
	component := description asComponentOn: user.
	user := self call: (component
			addValidatedForm;
			addMessage: 'Edit User';
			yourself).! !

!SKUserView methodsFor: 'rendering' stamp: 'AQ 10/31/2008 11:59'!
renderActionsOn: html 
	(self viewedUser isEditableBy: self session user) ifFalse: [ ^ self ].
	html anchor
		callback: [ self edit ];
		with: 'Edit'.
	html break.
	html anchor
		onClick: 'return confirm("Really delete', self viewedUser title, '?")';
		callback: [ self delete: viewedUser ];
		with: 'Delete'.! !

!SKUserView methodsFor: 'rendering' stamp: 'lr 11/1/2008 11:54'!
renderContentOn: html 
	html heading: 'User ' , viewedUser title.
	self renderWikiOn: html.
	html table: [ viewedUser description do: (self renderUserInfoOn: html) ].
	self renderActionsOn: html! !

!SKUserView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 23:25'!
renderUserInfoOn: html 
	^ 
	[ :description | 
	(description label = 'Password' or: [ description label = 'Superuser' or: [ description label = 'Wiki' ] ]) ifFalse: 
		[ html tableRow: 
			[ html tableData: description label , ': '.
			html tableData: [html text: (description toString: (viewedUser readUsing: description))]]]]! !

!SKUserView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:03'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self viewedUser wiki
		in: self
		on: html! !

!SKUserView methodsFor: 'accessing' stamp: 'AQ 7/15/2008 21:44'!
viewedUser
	^ viewedUser! !

!SKUserView methodsFor: 'accessing' stamp: 'AQ 7/15/2008 21:44'!
viewedUser: anObject
	viewedUser := anObject! !

SKComponent subclass: #SKSearchView
	instanceVariableNames: 'searchInput users projects groups displayProjects displayGroups displayMembers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKSearchView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Search'.! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:27'!
children
	^ Array with: users with: projects with: groups.! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:27'!
displayGroups
	^ displayGroups! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:27'!
displayGroups: aBoolean
	displayGroups := aBoolean! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:29'!
displayMembers
	^ displayMembers! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:29'!
displayMembers: aBoolean
	displayMembers := aBoolean! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:25'!
displayProjects
	^ displayProjects! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:25'!
displayProjects: aBoolean
	displayProjects := aBoolean.! !

!SKSearchView methodsFor: 'initialization' stamp: 'lr 11/1/2008 17:22'!
initialize
	super initialize.
	users := SKUsersView on: self.
	projects := SKProjectsView on: self.
	groups := SKGroupsView on: self.
	displayMembers := true.
	displayGroups := true.
	displayProjects := true.! !

!SKSearchView methodsFor: 'rendering' stamp: 'lr 10/31/2008 14:13'!
renderContentOn: html 
	self renderSelectionOn: html.
	searchInput isNil ifTrue: [ ^ self ].
	self displayMembers ifTrue: [html render: users].
	self displayProjects ifTrue: [html render: projects].
	self displayGroups ifTrue: [html render: groups].! !

!SKSearchView methodsFor: 'rendering' stamp: 'AQ 10/31/2008 13:37'!
renderSelectionOn: html 
	html form: 
		[ html textInput
			on: #searchInput
				of: self;
			value: ''.
		html break.
		html checkbox id: 1; value: self displayProjects; onTrue: [self displayProjects: true] onFalse: [self displayProjects: false].
		html label for: 1; with: 'Projects'.
		html checkbox id: 2; value: self displayMembers; onTrue: [self displayMembers: true] onFalse: [self displayMembers: false].
		html label for: 2; with: 'Members'.
		html checkbox id: 3; value: self displayGroups; onTrue: [self displayGroups: true] onFalse: [self displayGroups: false].
		html label for: 3; with: 'Groups'.
		html break.
		html submitButton
			text: 'Search';
			callback: [ self search ] ]! !

!SKSearchView methodsFor: 'actions' stamp: 'AQ 9/6/2008 15:40'!
search
	(self searchInput sameAs: '')
		ifTrue: [ self searchInput: '*']
		ifFalse: [self searchInput: '*', searchInput, '*'].
	users searchString: searchInput.
	projects searchString: searchInput.
	groups searchString: searchInput.! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 9/5/2008 18:10'!
searchInput
	^ searchInput! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 9/5/2008 18:11'!
searchInput: aString
	searchInput := aString! !

!SKSearchView methodsFor: 'updating' stamp: 'AQ 10/4/2008 16:01'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'search'! !

SKComponent subclass: #SKSelectUserView
	instanceVariableNames: 'selectedUsers title list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKSelectUserView methodsFor: 'initialization' stamp: 'AQ 9/11/2008 02:22'!
initialize
	super initialize.
	selectedUsers := Set new.! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/18/2008 12:27'!
list
	^ list! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/18/2008 12:28'!
list: aCollection
	list := aCollection! !

!SKSelectUserView methodsFor: 'rendering' stamp: 'AQ 10/26/2008 14:22'!
renderContentOn: html 
	html heading: self title.
	html
		form: [
			html multiSelect on: #selectedUsers of: self;
				list: self list;
				labels: [ :each | each title ]. html break.
			html submitButton 
				text: self title;
				callback: [ self answer: self selectedUsers ].
			html submitButton
				text: 'Cancel';
				callback: [ self answer: #() ] ].! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/11/2008 02:18'!
selectedUsers
	^ selectedUsers! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/17/2008 00:05'!
selectedUsers: aCollection
	selectedUsers := aCollection! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/11/2008 00:49'!
title
	^ title! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/17/2008 00:06'!
title: aString
	title := aString! !

SKComponent subclass: #SKTableComponent
	instanceVariableNames: 'searchString table'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKTableComponent subclass: #SKGroupsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKGroupsView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Groups'.! !

!SKGroupsView methodsFor: 'rendering' stamp: 'AQ 11/3/2008 18:16'!
initialize
	super initialize.
	table rows: self s2root groups asOrderedCollection.
	table addHead: 'Group' data: [ :row :html | self renderGroup: row on: html].
	table addHead: 'Admins' data: [ :row :html | self renderUsers: row admins on: html].
	table addHead: 'Members' data: [ :row :html | self renderUsers: row users on: html].
	table addHead: 'Tags' data: [ :row :html | html text: (row tags isNil ifFalse: [ row tags asCommaString ])].! !

!SKGroupsView methodsFor: 'actions' stamp: 'AQ 10/31/2008 13:22'!
search! !

!SKGroupsView methodsFor: 'updating' stamp: 'lr 10/31/2008 14:31'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot link
		beRss; 
		beAlternate;
		title: self s2root title;
		url: (self url with: 'groups.rss')! !

!SKGroupsView methodsFor: 'updating' stamp: 'AQ 10/4/2008 15:58'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'groups'! !

SKTableComponent subclass: #SKProjectsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKProjectsView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Projects'.! !

!SKProjectsView methodsFor: 'initialization' stamp: 'lr 11/1/2008 12:18'!
initialRequest: aRequest
	| names project |
	super initialRequest: aRequest.
	names := aRequest url findTokens: '/'.
	project := self s2root projects
		detect: [ :each | each id = names last ]
		ifNone: [ nil ].
	project isNil ifFalse: [ self viewProject: project ]! !

!SKProjectsView methodsFor: 'initialization' stamp: 'AQ 11/3/2008 18:16'!
initialize
	super initialize.
	table rows: self s2root projects asOrderedCollection.
	table addHead: 'Project' data: [ :row :html | self renderProject: row on: html ].
	table addHead: 'Admins' data: [ :row :html | self renderUsers: row admins on: html ].
	table addHead: 'Developers' data: [ :row :html | self renderUsers: row developers on: html ].
	table addHead: 'Tags' data: [ :row :html | html text: (row tags isNil ifFalse: [row tags asCommaString])].
	table addHead: 'Activity' data: [ :row :html | html space ].
	table addHead: 'Downloads' data: [ :row :html | html text: row downloads ].! !

!SKProjectsView methodsFor: 'actions' stamp: 'AQ 10/31/2008 13:23'!
search! !

!SKProjectsView methodsFor: 'updating' stamp: 'lr 10/31/2008 14:32'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot link
		beRss; 
		beAlternate;
		title: self s2root title;
		url: (self url with: '/projects.rss').! !

!SKProjectsView methodsFor: 'updating' stamp: 'lr 10/3/2008 12:01'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'projects'! !

!SKTableComponent methodsFor: 'initialization' stamp: 'AQ 10/31/2008 01:08'!
children
	^ Array with: table.! !

!SKTableComponent methodsFor: 'initialization' stamp: 'AQ 11/3/2008 17:51'!
initialize
	super initialize.
	table := SKTableFactory on: self.! !

!SKTableComponent methodsFor: 'rendering' stamp: 'lr 11/3/2008 14:49'!
renderContentOn: html 
	html render: table.! !

!SKTableComponent methodsFor: 'actions' stamp: 'AQ 10/31/2008 13:19'!
search
	self subclassResponsibility.! !

!SKTableComponent methodsFor: 'accessing' stamp: 'AQ 10/31/2008 01:09'!
searchString
	^ searchString! !

!SKTableComponent methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:18'!
searchString: anObject
	searchString := anObject.
	self search.! !

SKTableComponent subclass: #SKUsersView
	instanceVariableNames: 'members'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKUsersView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Members'.! !

!SKUsersView methodsFor: 'initialization' stamp: 'AQ 11/4/2008 01:27'!
initialize
	super initialize.
	table rows: self s2root users asOrderedCollection.
	table addHead: 'Name' data: [ :row :html | self renderUser: row on: html ].
	table addHead: 'Projects' data: [ :row :html | html text: (self s2root countProjectsOfUser: row) ].
	table addHead: 'Groups' data: [ :row :html | self renderGroups: (self s2root getGroupsOfUser: row) on: html ].
	table addHead: 'Tags' data: [ :row :html | html text: (row tags isNil ifFalse: [ row tags asCommaString ]) ].
	table addHead: 'Commits' data: [ :row :html | html text: row commits ]! !

!SKUsersView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:05'!
members
	^ members! !

!SKUsersView methodsFor: 'accessing' stamp: 'AQ 10/31/2008 13:14'!
members: anOrderedCollection
	members := anOrderedCollection! !

!SKUsersView methodsFor: 'actions' stamp: 'AQ 10/31/2008 13:22'!
search
	self members: (self members select: [:user | (self searchString match: user title) or: [self searchString match: user tags asCommaString]]).! !

!SKUsersView methodsFor: 'updating' stamp: 'lr 10/31/2008 14:32'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot link
		beRss; 
		beAlternate;
		title: self s2root title;
		url: (self url with: 'members.rss').! !

!SKUsersView methodsFor: 'updating' stamp: 'AQ 10/4/2008 15:47'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'members'! !

SKComponent subclass: #SKTableFactory
	instanceVariableNames: 'rows columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKTableFactory methodsFor: 'accessing' stamp: 'lr 11/3/2008 14:59'!
addHead: aColumnTitle data: aColumnBody
	columns add: aColumnTitle -> aColumnBody! !

!SKTableFactory methodsFor: 'initialization' stamp: 'lr 11/3/2008 14:56'!
initialize
	super initialize.
	columns := OrderedCollection new! !

!SKTableFactory methodsFor: 'rendering' stamp: 'AQ 10/25/2008 18:28'!
renderContentOn: html
	html table: [
		self renderTableHeadOn: html.
		self renderTableBodyOn: html. ]! !

!SKTableFactory methodsFor: 'rendering' stamp: 'lr 11/3/2008 15:02'!
renderTableBodyOn: html
	self rows keysAndValuesDo: [ :index :row |
		html tableRow
			class: 'even' if: index even;
			with: [ 
				columns
					do: [ :assoc | html tableData: [ assoc value value: row value: html ] ] ] ]! !

!SKTableFactory methodsFor: 'rendering' stamp: 'lr 11/3/2008 15:01'!
renderTableHeadOn: html 
	html tableHead: [
		columns keysAndValuesDo: [ :index :assoc |
				html tableHeading: [
					html anchor 
						callback: [self sortTableByCollumn: index.];
						with: assoc key ]]]! !

!SKTableFactory methodsFor: 'accessing' stamp: 'lr 11/3/2008 14:44'!
rows
	^ rows! !

!SKTableFactory methodsFor: 'accessing' stamp: 'lr 11/3/2008 14:44'!
rows: aCollection
	rows := aCollection! !

!SKTableFactory methodsFor: 'rendering' stamp: 'AQ 11/3/2008 18:09'!
sortTableByCollumn: anIndex
	self rows: self rows asArray.
	self rows sort: [ :a :b | (a at: anIndex) asString < (b at: anIndex) asString ].! !

SKComponent subclass: #SKUserMenuComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKUserMenuComponent methodsFor: 'actions' stamp: 'lr 11/1/2008 16:53'!
newGroup
	| newGroup |
	newGroup := self root content 
		call: (SKGroup new asComponent
			addValidatedForm;
			addMessage: 'Create Group';
			yourself).
	newGroup isNil ifTrue: [ ^ self ].
	self s2root addGroup: newGroup.
	newGroup creator: self session user.
	newGroup addAdmin: self session user.
	self viewGroup: newGroup! !

!SKUserMenuComponent methodsFor: 'actions' stamp: 'AQ 11/3/2008 23:19'!
newProject
	| newProject |
	newProject := self root content 
		call: (SKProject new asComponent
			addValidatedForm;
			addMessage: 'Create Group';
			yourself).
	newProject isNil ifTrue: [ ^ self ].
	self s2root addProject: newProject.
	newProject addAdmin: self session user.
	self viewProject: newProject! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'lr 11/1/2008 16:55'!
renderContentOn: html 
	self session isLoggedIn ifTrue: [
		self renderProjectsOn: html.
		self renderGroupsOn: html ].
	self session user isSuperuser ifFalse: [ ^ self ].
	self renderSuperuserMenuOn: html! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'lr 11/3/2008 14:38'!
renderGroupsOn: html 
	html break.
	html heading
		level: 6;
		with: 'Groups '.
	html anchor
		callback: [ self newGroup ];
		with: [html image url: (SKFileLibrary urlOf: #addPng) ].
	html break.
	self renderGroups: (self s2root getGroupsOfUser: self session user) on: html! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'lr 11/3/2008 14:37'!
renderProjectsOn: html 
	html heading
		level: 6;
		with: 'Projects '.
	html anchor
		callback: [ self newProject ];
		with: [html image url: (SKFileLibrary urlOf: #addPng) ].
	html break.
	self renderProjects: (self s2root getProjectsOfUser: self session user) on: html! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:54'!
renderSuperuserMenuOn: html 
	html break; break.
	html heading
		level: 6;
		with: 'Admin'.
	html break.
	html anchor
		callback: [ self editRoot ];
		with: 'Edit Root'! !

SKComponent subclass: #SKWelcomeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKWelcomeView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:18'!
renderContentOn: html 
	html heading: 'Home'.
	self renderWikiOn: html.
	self renderStatisticsOn: html! !

!SKWelcomeView methodsFor: 'rendering' stamp: 'AQ 11/3/2008 18:33'!
renderGroupsStatOn: html
	html break; break.
	html heading level: 3; with: 'Groups (' , (self s2root groups count: [ :each | true ]) asString , ')'.
	html text: 'Newest Projects: '.
	self renderGroups: self s2root statistics newestGroups on: html.! !

!SKWelcomeView methodsFor: 'rendering' stamp: 'lr 10/31/2008 16:01'!
renderMembersStatOn: html 
	html heading
		level: 3;
		with: 'Members (' , (self s2root users count: [ :each | true ]) asString , ')'.
	html text: 'Newest Members: '.
	self renderUsers: self s2root statistics newestMembers on: html! !

!SKWelcomeView methodsFor: 'rendering' stamp: 'lr 10/31/2008 16:01'!
renderProjectsStatOn: html 
	html break; break.
	html heading level: 3; with: 'Projects (' , (self s2root projects count: [ :each | true ]) asString , ')'.
	html text: 'Newest Projects: '.
	self renderProjects: self s2root statistics newestProjects on: html.! !

!SKWelcomeView methodsFor: 'rendering' stamp: 'AQ 11/3/2008 18:32'!
renderStatisticsOn: html 
	html break; break.
	html heading level: 2; with: 'Statistics:'.
	self renderMembersStatOn: html.
	self renderProjectsStatOn: html.
	self renderGroupsStatOn: html.! !

!SKWelcomeView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:01'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self s2root wiki
		in: self
		on: html! !

WAComponent subclass: #SKRootComponent
	instanceVariableNames: 'content userMenu login menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRootComponent class methodsFor: 'testing' stamp: 'AQ 8/20/2008 14:52'!
canBeRoot
	^ true! !

!SKRootComponent methodsFor: 'accessing' stamp: 'AQ 10/25/2008 18:04'!
children
	^ Array with: content with: userMenu with: login with: menu.! !

!SKRootComponent methodsFor: 'accessing' stamp: 'AQ 9/3/2008 16:10'!
content
	^ content! !

!SKRootComponent methodsFor: 'accessing' stamp: 'lr 11/1/2008 12:18'!
content: aComponent
	content := aComponent! !

!SKRootComponent methodsFor: 'initialization' stamp: 'lr 11/1/2008 17:22'!
initialRequest: aRequest
	| names |
	super initialRequest: aRequest.
	names := aRequest url findTokens: '/'.
	(names last = 'projects' or: [ names size > 1 and: [ (names at: names size - 1) = 'projects' ] ])
		ifTrue: [ ^ self content: (SKProjectsView on: self) ].
	names last = 'members'
		ifTrue: [ ^ self content: (SKUsersView on: self) ].
	names last = 'groups'
		ifTrue: [ ^ self content: (SKGroupsView on: self) ].
	names last = 'search'
		ifTrue: [ ^ self content: (SKSearchView on: self) ].! !

!SKRootComponent methodsFor: 'initialization' stamp: 'lr 10/31/2008 14:36'!
initialize
	super initialize.
	self welcome.
	login := SKLoginView on: self.
	userMenu := SKUserMenuComponent on: self.
	menu := SKMenuComponent on: self.! !

!SKRootComponent methodsFor: 'action' stamp: 'lr 10/31/2008 14:36'!
logout
	self session logout.
	self welcome! !

!SKRootComponent methodsFor: 'accessing' stamp: 'lr 10/3/2008 12:07'!
menu
	^ menu! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:15'!
renderBodyOn: html 
	html render: content! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 11/1/2008 10:27'!
renderContentOn: html
	html div class: 'header'; with: login.
	html div class: 'container'; with: [
		self renderLogoOn: html.
		self renderTabsOn: html.
		self renderMainOn: html.]! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/31/2008 15:55'!
renderLogoOn: html
	html div class: 'logo'; class: 'span-24'; class: 'last'; with: [
		html heading level: 1; with: [
			html anchor
				title: self s2root title;
				callback: [ self welcome ];
				with: [ html span: self s2root title ] ] ]! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:31'!
renderMainOn: html 
	html div class: 'main'; class: 'span-24'; class: 'last'; with: [
		html div class: 'menu';class: 'span-6'; with: [ self renderMenuOn: html ].
		html div class: 'body'; class: 'span-18'; class: 'last'; with: [ self renderBodyOn: html ] ]! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/31/2008 16:31'!
renderMenuOn: html
	html render: userMenu.
	html paragraph! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:12'!
renderTabsOn: html
	html div class: 'tabs'; class: 'span-24'; class: 'last'; with: menu! !

!SKRootComponent methodsFor: 'accessing' stamp: 'lr 10/31/2008 15:09'!
root
	^ self! !

!SKRootComponent methodsFor: 'updating' stamp: 'lr 11/1/2008 12:17'!
updateRoot: html
	super updateRoot: html.
	html title: self s2root title! !

!SKRootComponent methodsFor: 'action' stamp: 'lr 10/31/2008 14:36'!
welcome
	content := SKWelcomeView on: self.! !

Object subclass: #MDPasswordInfo
	instanceVariableNames: ''
	classVariableNames: 'MDPassword'
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDPasswordInfo class methodsFor: 'as yet unclassified' stamp: 'lr 10/16/2008 13:09'!
initialize
	Smalltalk addToShutDownList: self! !

!MDPasswordInfo class methodsFor: 'as yet unclassified' stamp: 'lr 10/16/2008 13:09'!
prompt
	^ ' Please enter you password for Monticello2 '! !

!MDPasswordInfo class methodsFor: 'as yet unclassified' stamp: 'lr 10/16/2008 13:09'!
shutDown
	MDPassword := nil! !

!MDPasswordInfo class methodsFor: 'as yet unclassified' stamp: 'lr 10/16/2008 13:09'!
value
	^ MDPassword ifNil: 
		[ MDPassword := MDPlatform current 
			prompt: self prompt
			default: '' ]! !

!MDPasswordInfo class methodsFor: 'as yet unclassified' stamp: 'lr 10/16/2008 13:09'!
value: aString 
	MDPassword := aString! !

Object subclass: #MDSourcetalkClient
	instanceVariableNames: 'url email password project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDSourcetalkClient class methodsFor: 'instance-creation' stamp: 'lr 11/6/2008 11:38'!
url: aUrlString email: anEmailString password: aPasswordString
	^ self new
		url: aUrlString;
		email: anEmailString;
		password: aPasswordString;
		yourself! !

!MDSourcetalkClient class methodsFor: 'instance-creation' stamp: 'lr 11/6/2008 11:14'!
url: aUrlString project: aProjectName email: anEmailString password: aPasswordString
	^ self new
		url: aUrlString;
		project: aProjectName;
		email: anEmailString;
		password: aPasswordString;
		yourself! !

!MDSourcetalkClient methodsFor: 'private' stamp: 'lr 11/6/2008 10:34'!
argumentsFor: aMessage
	| arguments stream |
	arguments := Dictionary new.
	self email isEmptyOrNil
		ifFalse: [ arguments at: 'email' put: (Array with: self email) ].
	self password isEmptyOrNil
		ifFalse: [ arguments at: 'password' put: (Array with: self password) ].
	self project isEmptyOrNil
		ifFalse: [ arguments at: 'project' put: (Array with: self project) ].
	stream := ReadWriteStream on: ByteArray new.
	aMessage writeOn: stream.
	arguments
		at: 'message'
		put: (Array with: (Base64MimeConverter mimeEncode: stream)
			contents).
	^ arguments! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:31'!
email
	^ email! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:31'!
email: aString
	email := aString! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:31'!
password
	^ password! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:32'!
password: aString
	password := aString! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:32'!
project
	^ project! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:32'!
project: aString
	project := aString! !

!MDSourcetalkClient methodsFor: 'public' stamp: 'lr 11/6/2008 11:37'!
repositories
	^ (self send: MDGetRepositories new) objects! !

!MDSourcetalkClient methodsFor: 'public' stamp: 'lr 11/6/2008 11:09'!
send: aMessage
	| response stream |
	response := HTTPSocket
		httpPost: self url
		args: (self argumentsFor: aMessage)
		accept: 'application/x-monticello'.
	response isString
		ifTrue: [ MDPeerError signal: response ].
	stream := Base64MimeConverter 
		mimeDecodeToBytes: response.
	^ (MDNetMessage readFrom: stream)
		checkForError! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:32'!
url
	^ url! !

!MDSourcetalkClient methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:33'!
url: aString
	url := aString! !

!Object methodsFor: '*sourcetalk' stamp: 'lr 9/26/2008 14:06'!
s2root
	^ SKRoot default! !

Object subclass: #SKEntry
	instanceVariableNames: 'id wiki tags timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKEntry class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:47'!
descriptionTags
	^ MATokenDescription new
		onlyEditing: true;
		accessor: #tags;
		priority: 120;
		label: 'Tags';
		default: #();
		yourself! !

!SKEntry class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:26'!
descriptionTimestamp
	^ MATimeStampDescription new
		accessor: #timestamp;
		label: 'Created';
		beReadonly;
		beHidden;
		yourself! !

!SKEntry class methodsFor: 'accessing-description' stamp: 'AQ 10/24/2008 17:43'!
descriptionWiki
	^ PRDocumentDescription new
		onlyEditing: true;
		accessor: #wiki;
		priority: 130;
		label: 'Wiki';
		yourself! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 9/11/2008 11:02'!
id
	^ id! !

!SKEntry methodsFor: 'initialization' stamp: 'lr 11/1/2008 11:46'!
initialize
	id := UUID new asString.
	timestamp := TimeStamp now.
	self description do: [ :each |
		(each isReadonly not and: [ each default notNil ])
			ifTrue: [ self write: each default using: each ] ]! !

!SKEntry methodsFor: 'testing' stamp: 'lr 11/1/2008 12:20'!
isEditableBy: aUser
	^ false! !

!SKEntry methodsFor: 'testing' stamp: 'lr 11/1/2008 12:20'!
isVisibleBy: aUser
	^ true! !

!SKEntry methodsFor: 'printing' stamp: 'lr 11/1/2008 11:25'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' title: '; print: self title! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 10/10/2008 11:43'!
tags
	^tags ifNil: [ #() ]! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:33'!
tags: aCollection
	tags := aCollection! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 9/11/2008 10:54'!
timestamp
	^ timestamp! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:25'!
title
	^ self subclassResponsibility! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 6/18/2008 17:56'!
wiki
	^wiki! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:37'!
wiki: anObject
	wiki := anObject! !

SKEntry subclass: #SKMember
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

SKMember subclass: #SKGroup
	instanceVariableNames: 'title users admins creator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKGroup class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:47'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beRequired;
		yourself! !

!SKGroup methodsFor: 'actions' stamp: 'AQ 11/3/2008 23:24'!
addAdmin: aUser
	self admins isEmpty
		ifTrue: [self creator: aUser].
	self admins add: aUser.! !

!SKGroup methodsFor: 'actions' stamp: 'lr 11/1/2008 15:58'!
addUser: aUser
	users add: aUser! !

!SKGroup methodsFor: 'accessing-readonly' stamp: 'AQ 7/9/2008 12:13'!
admins
	^ admins! !

!SKGroup methodsFor: 'accessing' stamp: 'AQ 9/7/2008 14:44'!
creator
	^ creator! !

!SKGroup methodsFor: 'accessing' stamp: 'lr 11/1/2008 16:17'!
creator: aMember
	creator := aMember! !

!SKGroup methodsFor: 'initialization' stamp: 'lr 11/1/2008 16:12'!
initialize
	super initialize.
	users := Set new.
	admins := Set new.
	projects := Set new! !

!SKGroup methodsFor: 'testing' stamp: 'lr 11/1/2008 16:44'!
isEditableBy: aUser
	^ aUser isSuperuser or: [ aUser isWithin: self admins ]! !

!SKGroup methodsFor: 'testing' stamp: 'lr 11/1/2008 16:35'!
isGroup
	^ true! !

!SKGroup methodsFor: 'actions' stamp: 'lr 11/1/2008 15:58'!
removeAdmin: aUser
	admins remove: aUser ifAbsent: [ ]! !

!SKGroup methodsFor: 'actions' stamp: 'lr 11/1/2008 15:58'!
removeUser: aUser
	users remove: aUser ifAbsent: [ ]! !

!SKGroup methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:27'!
title
	^ title! !

!SKGroup methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:27'!
title: aString
	title := aString! !

!SKGroup methodsFor: 'accessing-readonly' stamp: 'lr 6/30/2008 14:46'!
users
	^ users! !

!SKMember methodsFor: 'testing' stamp: 'lr 11/1/2008 16:35'!
isGroup
	^ false! !

!SKMember methodsFor: 'accessing' stamp: 'lr 11/1/2008 16:06'!
users
	^ #()! !

SKMember subclass: #SKPerson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

SKPerson subclass: #SKGuest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKGuest methodsFor: 'testing' stamp: 'lr 11/1/2008 12:12'!
isGuest
	^ true! !

!SKGuest methodsFor: 'accessing' stamp: 'lr 10/31/2008 13:27'!
title
	^ 'Guest'! !

!SKPerson methodsFor: 'testing' stamp: 'lr 11/1/2008 12:12'!
isGuest
	^ false! !

!SKPerson methodsFor: 'testing' stamp: 'lr 10/3/2008 12:22'!
isSuperuser
	^ false! !

!SKPerson methodsFor: 'testing' stamp: 'lr 11/1/2008 16:40'!
isWithin: aCollectionOfMembers
	"Tests if the receiving user is contained within the given collection of members."
	
	^ false! !

SKPerson subclass: #SKUser
	instanceVariableNames: 'name email password superuser commits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKUser class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:32'!
descriptionEmail
	^ MAStringDescription new
		accessor: #email;
		label: 'Email';
		priority: 120;
		beRequired;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:36'!
descriptionName
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 100;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:32'!
descriptionPassword
	^ MAPasswordDescription new
		componentClass: MAVerifiedPasswordComponent; 
		accessor: #password;
		label: 'Password';
		priority: 130;
		beRequired;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 12:26'!
descriptionSuperuser
	^ MABooleanDescription new
		onlySuperuser: true;
		accessor: #superuser;
		label: 'Superuser';
		default: false;
		priority: 200;
		yourself! !

!SKUser methodsFor: 'actions' stamp: 'lr 11/1/2008 16:16'!
addOneCommit
	self commits: self commits + 1! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:51'!
commits
	^ commits! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:51'!
commits: aPsotiveNumber
	commits := aPsotiveNumber.! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email
	^ email! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email: anObject
	email := anObject! !

!SKUser methodsFor: 'private' stamp: 'lr 7/9/2008 15:01'!
hashPassword: aString 
	^ aString isEmptyOrNil ifFalse: [ SecureHashAlgorithm new hashMessage: aString ]! !

!SKUser methodsFor: 'initialization' stamp: 'lr 11/3/2008 14:35'!
initialize
	super initialize.
	commits := 0! !

!SKUser methodsFor: 'testing' stamp: 'lr 11/1/2008 16:20'!
isEditableBy: aUser
	^ aUser isSuperuser or: [ self = aUser ]! !

!SKUser methodsFor: 'testing' stamp: 'lr 10/3/2008 12:22'!
isSuperuser
	^ superuser! !

!SKUser methodsFor: 'testing' stamp: 'lr 11/3/2008 14:25'!
isWithin: aCollectionOfMembers
	aCollectionOfMembers do: [ :member |
		member = self
			ifTrue: [ ^ true ].
		member isGroup ifTrue: [
			(member admins includes: self)
				ifTrue: [ ^ true ].
			(member users includes: self)
				ifTrue: [ ^ true ] ] ].
	^ false! !

!SKUser methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:36'!
name
	^ name! !

!SKUser methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:36'!
name: aString
	name := aString! !

!SKUser methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:43'!
password
	^ nil! !

!SKUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 15:01'!
password: aString 
	password := self hashPassword: aString! !

!SKUser methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:41'!
superuser
	^ superuser! !

!SKUser methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:42'!
superuser: aBoolean
	superuser := aBoolean! !

!SKUser methodsFor: 'accessing-readonly' stamp: 'lr 11/1/2008 12:15'!
title
	^ String streamContents: [ :stream |
		(self name isNil or: [ self name isEmpty ])
			ifFalse: [ stream nextPutAll: self name ].
		stream position isZero
			ifTrue: [ stream nextPutAll: self email ] ]! !

!SKUser methodsFor: 'testing' stamp: 'lr 7/9/2008 15:02'!
verifyPassword: aString
	^ (self hashPassword: aString) = password! !

SKEntry subclass: #SKProject
	instanceVariableNames: 'title repository license state rating visibility admins developers creator downloads'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKProject class methodsFor: 'accessing-description' stamp: 'lr 11/6/2008 08:29'!
descriptionLicense
	^ MASingleOptionDescription new
		options: #(None MIT Squeak BSD GPL LPGL);
		accessor: #license;
		default: #None;
		label: 'License';
		priority: 140;
		beRequired;
		yourself! !

!SKProject class methodsFor: 'accessing-description' stamp: 'lr 11/6/2008 08:29'!
descriptionState
	^ MASingleOptionDescription new
		options: #(Planning Alpha Beta Stable Mature Inactive);
		default: #Planning;
		accessor: #state;
		priority: 150;
		label: 'State';
		beRequired;
		yourself! !

!SKProject class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:30'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 100;
		label: 'Title';
		beRequired;
		yourself! !

!SKProject class methodsFor: 'accessing-description' stamp: 'lr 11/6/2008 08:29'!
descriptionVisibility
	^ MASingleOptionDescription new
		options: #(public protected private);
		accessor: #visibility;
		label: 'Visibility';
		default: #public;
		priority: 160;
		beRequired;
		yourself! !

!SKProject methodsFor: 'actions' stamp: 'AQ 10/24/2008 12:46'!
addADownload
	self downloads: self downloads +1.! !

!SKProject methodsFor: 'actions' stamp: 'AQ 11/4/2008 00:28'!
addAdmin: aUser
	self admins isEmpty
		ifTrue: [self creator: aUser].
	(self developers includes: aUser)
		ifTrue: [self removeDeveloper: aUser].
	self admins add: aUser! !

!SKProject methodsFor: 'actions' stamp: 'lr 11/3/2008 14:35'!
addDeveloper: aMember
	(self admins includes: aMember)
		ifTrue: [ self removeAdmin: aMember ].
	self developers add: aMember! !

!SKProject methodsFor: 'accessing-readonly' stamp: 'AQ 6/29/2008 17:34'!
admins
	^ admins! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 9/7/2008 14:44'!
creator
	^ creator! !

!SKProject methodsFor: 'accessing' stamp: 'lr 11/1/2008 16:17'!
creator: aMember
	creator := aMember! !

!SKProject methodsFor: 'accessing-configuration' stamp: 'lr 11/6/2008 08:21'!
defaultRepository
	^ MDSynchronizedRepository	on: (MDFileRepository 
		named: (self directory assureExistence 
			fullNameFor: 'default'))! !

!SKProject methodsFor: 'accessing-readonly' stamp: 'lr 6/30/2008 14:39'!
developers
	^ developers! !

!SKProject methodsFor: 'accessing-readonly' stamp: 'lr 11/6/2008 08:21'!
directory
	^ self s2root directory directoryNamed: self id! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:45'!
downloads
	^ downloads! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 10/24/2008 12:47'!
downloads: aPositiveNumber
	downloads:= aPositiveNumber.! !

!SKProject methodsFor: 'initialization' stamp: 'lr 11/6/2008 08:30'!
initialize
	super initialize.
	repository := self defaultRepository.
	developers := Set new.
	admins := Set new.
	rating := 0.
	downloads := 0! !

!SKProject methodsFor: 'testing' stamp: 'AQ 11/4/2008 00:45'!
isEditableBy: aUser
	^ aUser isSuperuser or: [ aUser isWithin: self admins ]
	
"Edit means changing the SKProject settings"! !

!SKProject methodsFor: 'testing' stamp: 'AQ 11/4/2008 00:46'!
isVisibleBy: aUser 
	^ aUser isSuperuser or: [ self visibility = #public or: [ self visibility = #protected or: [ (aUser isWithin: self developers) or: [ aUser isWithin: self admins ] ] ] ]
	
"Visible means seeing the project on the page"! !

!SKProject methodsFor: 'testing' stamp: 'AQ 11/4/2008 00:46'!
isWritableBy: aUser
	^ aUser isSuperuser or: [ self visibility = #public or: [ (aUser isWithin: self developers) or: [ aUser isWithin: self admins ] ] ]
	
"Write means being able to write in repository"! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 11/4/2008 00:25'!
license
	^ license
	
"
#None
#MIT
#Squeak
#BSD
#GPL
#LPGL
"! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
license: anObject
	license := anObject! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating
	^ rating! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating: anObject
	rating := anObject! !

!SKProject methodsFor: 'actions' stamp: 'lr 11/3/2008 14:36'!
removeAdmin: aMember
	self admins remove: aMember ifAbsent: [ ]! !

!SKProject methodsFor: 'actions' stamp: 'lr 11/3/2008 14:36'!
removeDeveloper: aMember
	self developers remove: aMember ifAbsent: [ ]! !

!SKProject methodsFor: 'accessing-readonly' stamp: 'lr 11/6/2008 08:17'!
repository
	^ repository! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 11/4/2008 00:24'!
state
	^ state
	
"
#Planning
#Alpha
#Beta
#Stable
#Mature
#Inactive
"! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 11/4/2008 00:24'!
state: anObject
	state := anObject.! !

!SKProject methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:30'!
title
	^ title! !

!SKProject methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:30'!
title: aString
	title := aString! !

!SKProject methodsFor: 'accessing' stamp: 'lr 10/31/2008 15:30'!
visibility
	^ visibility
	
"
#public every user can read and write with MC2
#protected every user can read, admins and developers can also write  with MC2
#private only admins and developers can read and write with MC2
"! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 11/4/2008 00:33'!
visibility: aString
	visibility := aString! !

SKEntry subclass: #SKRoot
	instanceVariableNames: 'title users groups projects smtpServer noReplyMail statistics guest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

SKRoot class
	instanceVariableNames: 'Default'!

SKRoot class
	instanceVariableNames: 'Default'!

!SKRoot class methodsFor: 'accessing' stamp: 'lr 10/31/2008 11:41'!
default
	^ Default ifNil: [ Default := self new ]! !

!SKRoot class methodsFor: 'accessing-description' stamp: 'lr 9/8/2008 11:49'!
descriptionNoReplyMail
	^ MAStringDescription new
		accessor: #noReplyMail;
		priority: 150;
		label: 'Generated email';
		beRequired;
		yourself! !

!SKRoot class methodsFor: 'accessing-description' stamp: 'lr 9/26/2008 14:52'!
descriptionSmtpServer
	^ MAStringDescription new
		accessor: #smtpServer;
		priority: 140;
		label: 'SMTP Server';
		comment: 'This is the SMTP Server used for sending mails.';
		beRequired;
		yourself! !

!SKRoot class methodsFor: 'accessing-description' stamp: 'lr 11/1/2008 11:52'!
descriptionTitle
	^ MAStringDescription new
		default: 'Sourcetalk';
		accessor: #title;
		priority: 100;
		label: 'Title';
		beRequired;
		yourself! !

!SKRoot class methodsFor: 'initialization' stamp: 'lr 10/31/2008 12:09'!
reset
	Default := nil! !

!SKRoot methodsFor: 'actions' stamp: 'AQ 11/3/2008 18:31'!
addGroup: aGroup
	groups add: aGroup.
	self statistics newGroup: aGroup.! !

!SKRoot methodsFor: 'actions' stamp: 'AQ 10/19/2008 17:15'!
addProject: aProject
	projects add: aProject.
	self statistics newProject: aProject.! !

!SKRoot methodsFor: 'actions' stamp: 'AQ 10/19/2008 16:34'!
addUser: aUser
	users add: aUser.
	self statistics newMember: aUser.! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:35'!
countProjectsOfUser: aUser 
	^ self projects
		count: [:project | (project admins includes: aUser)
				or: [project developers includes: aUser]]! !

!SKRoot methodsFor: 'accessing-readonly' stamp: 'lr 11/6/2008 08:14'!
directory
	"The default directory where all the projets will be stored."
	
	^ FileDirectory default directoryNamed: 'projects'! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:45'!
getGroupsOfUser: aUser 
	^ self groups
		select: [:group | (group admins includes: aUser)
				or: [group users includes: aUser]]! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 11/4/2008 01:17'!
getProjectNamed: aString
	^ self projects detect: [:each | each title = aString].! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:43'!
getProjectsOfUser: aUser 
	^ self projects
		select: [:project | (project admins includes: aUser)
				or: [project developers includes: aUser]]! !

!SKRoot methodsFor: 'accessing-readonly' stamp: 'AQ 7/6/2008 20:41'!
groups
	^ groups! !

!SKRoot methodsFor: 'accessing-readonly' stamp: 'lr 11/1/2008 11:49'!
guest
	^ guest! !

!SKRoot methodsFor: 'initialization' stamp: 'lr 11/6/2008 08:20'!
initialize
	super initialize.
	self directory assureExistence.
	guest := SKGuest new.
	users := Set new.
	projects := Set new.
	groups := Set new.
	statistics := SKStatistics new! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
noReplyMail
	^ noReplyMail! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
noReplyMail: anObject
	noReplyMail := anObject! !

!SKRoot methodsFor: 'accessing-readonly' stamp: 'AQ 7/6/2008 20:42'!
projects
	^ projects! !

!SKRoot methodsFor: 'actions' stamp: 'AQ 11/4/2008 01:54'!
removeGroup: aGroup
	self groups remove: aGroup ifAbsent: [ ].
	self statistics newestGroups remove: aGroup ifAbsent: [ ].! !

!SKRoot methodsFor: 'actions' stamp: 'AQ 11/4/2008 01:53'!
removeProject: aProject
	self projects remove: aProject ifAbsent: [ ].
	self statistics newestProjects remove: aProject ifAbsent: [ ].! !

!SKRoot methodsFor: 'actions' stamp: 'AQ 11/4/2008 01:51'!
removeUser: aUser
	self users remove: aUser ifAbsent: [ ].
	self projects do: [ :project |
		project removeAdmin: aUser.
		project removeDeveloper: aUser ].
	self groups do: [ :group |
		group removeAdmin: aUser.
		group removeUser: aUser ].
	self statistics newestMembers remove: aUser ifAbsent: [ ].! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
smtpServer
	^ smtpServer! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
smtpServer: anObject
	smtpServer := anObject! !

!SKRoot methodsFor: 'accessing' stamp: 'AQ 10/19/2008 16:33'!
statistics
	^ statistics! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:30'!
title
	^ title! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 11/1/2008 11:30'!
title: aString
	title := aString! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/7/2008 14:24'!
userByEMail: aString
	^ self users detect: [ :each | each email = aString ] ifNone: [ nil ]! !

!SKRoot methodsFor: 'accessing-readonly' stamp: 'lr 6/30/2008 14:36'!
users
	^ users! !

Object subclass: #SKStatistics
	instanceVariableNames: 'newestMembers newestProjects newestGroups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

SKStatistics class
	instanceVariableNames: 'newestMembers newestProjects'!

SKStatistics class
	instanceVariableNames: 'newestMembers newestProjects'!

!SKStatistics methodsFor: 'actions' stamp: 'AQ 11/3/2008 18:24'!
checkIfFull: anOrderedCollection
	(anOrderedCollection size = 11) ifTrue:[
		anOrderedCollection removeLast ].! !

!SKStatistics methodsFor: 'initialization' stamp: 'AQ 11/3/2008 18:21'!
initialize
	super initialize.
	newestMembers := OrderedCollection new.
	newestProjects := OrderedCollection new.
	newestGroups := OrderedCollection new.! !

!SKStatistics methodsFor: 'actions' stamp: 'AQ 11/3/2008 18:25'!
newGroup: aGroup
	self newestGroups addFirst: aGroup.
	self checkIfFull: self newestGroups.! !

!SKStatistics methodsFor: 'actions' stamp: 'AQ 11/3/2008 18:25'!
newMember: aUser
	self newestMembers addFirst: aUser.
	self checkIfFull: self newestMembers.! !

!SKStatistics methodsFor: 'actions' stamp: 'AQ 11/3/2008 18:26'!
newProject: aProject
	self newestProjects addFirst: aProject.
	self checkIfFull: self newestProjects.! !

!SKStatistics methodsFor: 'accessing' stamp: 'AQ 11/3/2008 18:18'!
newestGroups
	^ newestGroups! !

!SKStatistics methodsFor: 'accessing' stamp: 'AQ 10/19/2008 16:41'!
newestMembers
	^ newestMembers! !

!SKStatistics methodsFor: 'accessing' stamp: 'AQ 10/19/2008 17:20'!
newestProjects
	^ newestProjects! !

!MDTimestamp methodsFor: '*sourcetalk' stamp: 'lr 10/20/2008 15:21'!
asDateAndTime
	^ DateAndTime year: self year month: self month day: self day hour: self hour minute: self minute second: self second! !

WASession subclass: #SKSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKSession methodsFor: 'initialization' stamp: 'lr 8/19/2008 11:44'!
initialize
	super initialize.
	self logout.! !

!SKSession methodsFor: 'testing' stamp: 'lr 11/1/2008 12:13'!
isLoggedIn
	^ self user isGuest not! !

!SKSession methodsFor: 'accessing' stamp: 'AQ 8/17/2008 21:03'!
login: aUser 
	self user: aUser! !

!SKSession methodsFor: 'accessing' stamp: 'lr 11/1/2008 12:24'!
logout
	self user: self s2root guest! !

!SKSession methodsFor: 'accessing' stamp: 'AQ 8/17/2008 17:38'!
user
	^ user! !

!SKSession methodsFor: 'accessing' stamp: 'AQ 8/20/2008 14:46'!
user: aS2Person 
	user := aS2Person! !

MDCmdAddRepository subclass: #MDCmdAddSourcetalkProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDCmdAddSourcetalkProject methodsFor: 'running' stamp: 'lr 11/6/2008 10:50'!
createRepository
	| chunk |
	chunk := OBTextRequest
		prompt: 'Sourcetalk Project'
		template: self creationTemplate.
	^ chunk isNil 
		ifFalse: [ MDSourcetalkRepository readFrom: chunk ]! !

!MDCmdAddSourcetalkProject methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:51'!
creationTemplate
	^ MDSourcetalkRepository name , '
	url: ''http://www.sourcetalk.com/''
	project: ''''
	email: ''''
	password: '''''! !

!MDCmdAddSourcetalkProject methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:51'!
label
	^ 'add sourcetalk project...'! !

MDCmdAddRepository subclass: #MDCmdSelectSourcetalkProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDCmdSelectSourcetalkProject methodsFor: 'running' stamp: 'lr 11/6/2008 11:40'!
createRepository
	| chunk server repositories repository |
	chunk := OBTextRequest
		prompt: 'Sourcetalk Server'
		template: self creationTemplate.
	chunk isNil
		ifTrue: [ ^ self ].
	server := chunk isNil 
		ifFalse: [ MDSourcetalkClient readFrom: chunk ].
	server isNil
		ifTrue: [ ^ self ].
	repositories := server repositories 
		asSortedCollection.
	repository := OBChoiceRequest
		prompt: 'Choose Project'
		labels: repositories
		values: repositories.
	^ MDSourcetalkRepository
		url: server url
		project: repository
		email: server email
		password: server password! !

!MDCmdSelectSourcetalkProject methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:41'!
creationTemplate
	^ MDSourcetalkClient name , '
	url: ''http://www.sourcetalk.com/''
	email: ''''
	password: '''''! !

!MDCmdSelectSourcetalkProject methodsFor: 'accessing' stamp: 'lr 11/6/2008 10:48'!
label
	^ 'select sourcetalk project...'! !

!MDAbstractProjectBrowser methodsFor: '*sourcetalk-client' stamp: 'lr 11/6/2008 10:47'!
cmdAddSourcetalkProject
	^ MDCmdAddSourcetalkProject! !

!MDAbstractProjectBrowser methodsFor: '*sourcetalk-client' stamp: 'lr 11/6/2008 10:56'!
cmdSelectSourcetalkProject
	^ MDCmdSelectSourcetalkProject! !
SKRssGroupsFeed initialize!
SKRssMembersFeed initialize!
SKRssProjectsFeed initialize!
SKHttpHandler initialize!
MDPasswordInfo initialize!
